; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; CODE GNR AUTOMATIQUEMENT, NE PAS MODIFIER 
; MOINS D'AVOIR UNE RAISON TRS TRS VALABLE !!!
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Code gnr par : Dev-Module - V0.9.2
; Nom du projet : Dev-Module
; Nom du fichier : DevModule - CryptedFileMethods.pb
; Version du fichier : 1.0.0
; Programmation : OK
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 22-07-2018
; Mise  jour : 02-08-2018
; Cod pour PureBasic : V5.70 beta 1
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule CryptedFileMethods

  Declare.b GetReadWrite()
  Declare.b GetCreateFile()
  Declare.b GetOpenFile()
  Declare.b GetReadFile()
  Declare.s GetExternalModuleToUse()
  Declare SetReadWrite(P_ReadWrite.b)
  Declare SetCreateFile(P_CreateFile.b)
  Declare SetOpenFile(P_OpenFile.b)
  Declare SetReadFile(P_ReadFile.b)
  Declare SetExternalModuleToUse(P_ExternalModuleToUse.s)
  Declare Reset()
  Declare ReadPrefs(P_GroupName.s)
  Declare WritePrefs(P_GroupName.s)
  Declare.s DeclareRead()
  Declare.s DeclareWrite()
  Declare.s DeclareCreateFile()
  Declare.s DeclareOpenFile()
  Declare.s DeclareReadFile()
  Declare.s DefineRead()
  Declare.s DefineWrite()
  Declare.s DefineCreateFile()
  Declare.s DefineOpenFile()
  Declare.s DefineReadFile()

EndDeclareModule

Module CryptedFileMethods

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Dclaration de la Structure <<<<<

  Structure Instance

    ReadWrite.b
    CreateFile.b
    OpenFile.b
    ReadFile.b
    ExternalModuleToUse.s

  EndStructure

  Global Instance.Instance

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Les observateurs <<<<<

  Procedure.b GetReadWrite()

    ProcedureReturn Instance\ReadWrite
  EndProcedure

  Procedure.b GetCreateFile()

    ProcedureReturn Instance\CreateFile
  EndProcedure

  Procedure.b GetOpenFile()

    ProcedureReturn Instance\OpenFile
  EndProcedure

  Procedure.b GetReadFile()

    ProcedureReturn Instance\ReadFile
  EndProcedure

  Procedure.s GetExternalModuleToUse()

    ProcedureReturn Instance\ExternalModuleToUse
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Les mutateurs <<<<<

  Procedure SetReadWrite(P_ReadWrite.b)

    Instance\ReadWrite = P_ReadWrite

  EndProcedure

  Procedure SetCreateFile(P_CreateFile.b)

    Instance\CreateFile = P_CreateFile

  EndProcedure

  Procedure SetOpenFile(P_OpenFile.b)

    Instance\OpenFile = P_OpenFile

  EndProcedure

  Procedure SetReadFile(P_ReadFile.b)

    Instance\ReadFile = P_ReadFile

  EndProcedure

  Procedure SetExternalModuleToUse(P_ExternalModuleToUse.s)

    Instance\ExternalModuleToUse = P_ExternalModuleToUse

  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Reset <<<<<

  Procedure Reset()
    
    Instance\ReadWrite = 0
    Instance\CreateFile = 0
    Instance\OpenFile = 0
    Instance\ReadFile = 0
    Instance\ExternalModuleToUse = ""
    
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Lecture d'un groupe Prfrences <<<<<

  Procedure ReadPrefs(P_GroupName.s)

    PreferenceGroup(P_GroupName)
    
    Instance\ReadWrite = ReadPreferenceLong("ReadWrite", Instance\ReadWrite)
    Instance\CreateFile = ReadPreferenceLong("CreateFile", Instance\CreateFile)
    Instance\OpenFile = ReadPreferenceLong("OpenFile", Instance\OpenFile)
    Instance\ReadFile = ReadPreferenceLong("ReadFile", Instance\ReadFile)
    Instance\ExternalModuleToUse = ReadPreferenceString("ExternalModuleToUse", Instance\ExternalModuleToUse)
    
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< criture d'un groupe de Prfrences <<<<<

  Procedure WritePrefs(P_GroupName.s)

    PreferenceGroup(P_GroupName)
    
    WritePreferenceLong("ReadWrite", Instance\ReadWrite)
    WritePreferenceLong("CreateFile", Instance\CreateFile)
    WritePreferenceLong("OpenFile", Instance\OpenFile)
    WritePreferenceLong("ReadFile", Instance\ReadFile)
    WritePreferenceString("ExternalModuleToUse", Instance\ExternalModuleToUse)
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< criture d'un groupe de Prfrences <<<<<

  Procedure.s DeclareRead()
    
    ProcedureReturn Comments::Tabulation(1) + "Declare Read" + Field::FormatCryptedFileModule(1) + Field::GetModuleName() + "(FileID.i, P_Key.s" + Field::GetExtraParam() + ")" + Field::#LineFeed
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< criture d'un groupe de Prfrences <<<<<

  Procedure.s DeclareWrite()
    
    ProcedureReturn Comments::Tabulation(1) + "Declare Write" + Field::FormatCryptedFileModule(1) + Field::GetModuleName() + "(FileID.i, P_Key.s" + Field::GetExtraParam() + ")" + Field::#LineFeed
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< criture d'un groupe de Prfrences <<<<<

  Procedure.s DeclareCreateFile()
    
    ProcedureReturn Comments::Tabulation(1) + "Declare Create" + Field::FormatCryptedFileModule(1) + Field::GetModuleName() + "File(FileID.i, P_FileName.s, P_Key.s" + Field::GetExtraParam() + ")" + Field::#LineFeed
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< criture d'un groupe de Prfrences <<<<<

  Procedure.s DeclareOpenFile()
    
    ProcedureReturn Comments::Tabulation(1) + "Declare Open" + Field::FormatCryptedFileModule(1) + Field::GetModuleName() + "File(FileID.i, P_FileName.s, P_Key.s" + Field::GetExtraParam() + ")" + Field::#LineFeed
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< criture d'un groupe de Prfrences <<<<<

  Procedure.s DeclareReadFile()
    
    ProcedureReturn Comments::Tabulation(1) + "Declare Read" + Field::FormatCryptedFileModule(1) + Field::GetModuleName() + "File(FileID.i, P_FileName.s, P_Key.s" + Field::GetExtraParam() + ")" + Field::#LineFeed
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Oprateurs privs <<<<<
  
  Procedure.s ReDimArray(InstanceStyle.s, Target.b, SubTarget.b)
    
    Select SubTarget
        
      Case 0
        Output.s = "ReDim " + InstanceStyle + Field::GetFieldAccessMax(Target)
        
      Case 1
        Output.s = "ReDim " + InstanceStyle + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccessMax(Target)
        
    EndSelect
      
    ProcedureReturn Output
  EndProcedure
  
  Procedure.s InstructionReadBasic(TabSize.b, InstanceAccessPath.s, Target.b)
    
    Select Field::GetFieldType(Target)
        
      Case Field::#FIELD_TYPE_BYTE
        Instruction.s = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + " = " + Field::FormatCryptedFileModule(0) + "ReadByte(FileID, P_Key)" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_ASCII
        Instruction = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + " = " + Field::FormatCryptedFileModule(0) + "ReadAsciiCharacter(FileID, P_Key)" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_UNICODE
        Instruction = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + " = " + Field::FormatCryptedFileModule(0) + "ReadUnicodeCharacter(FileID, P_Key)" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_CHARACTER
        Instruction = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + " = " + Field::FormatCryptedFileModule(0) + "ReadCharacter(FileID, P_Key)" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_INTEGER
        Instruction = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + " = " + Field::FormatCryptedFileModule(0) + "ReadInteger(FileID, P_Key)" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_WORD
        Instruction = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + " = " + Field::FormatCryptedFileModule(0) + "ReadWord(FileID, P_Key)" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_LONG
        Instruction = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + " = " + Field::FormatCryptedFileModule(0) + "ReadLong(FileID, P_Key)" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_QUAD
        Instruction = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + " = " + Field::FormatCryptedFileModule(0) + "ReadQuad(FileID, P_Key)" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_FLOAT
        Instruction = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + " = " + Field::FormatCryptedFileModule(0) + "ReadFloat(FileID, P_Key)" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_DOUBLE
        Instruction = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + " = " + Field::FormatCryptedFileModule(0) + "ReadDouble(FileID, P_Key)" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_STRING01, Field::#FIELD_TYPE_STRING02
        Instruction = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + " = " + Field::FormatCryptedFileModule(0) + "ReadString(FileID, P_Key)" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_MODULE
        Instruction = Comments::Tabulation(TabSize) + Field::GetFieldExternModuleName(Target) + "::Read" + Field::FormatCryptedFileModule(1) + Field::GetFieldExternModuleName(Target) + "(FileID, P_Key, " + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
        
    EndSelect
    
    ProcedureReturn Instruction
  EndProcedure
  
  Procedure.s InstructionReadStructure(TabSize.b, InstanceAccessPath.s, Target.b)
    
    Select Field::GetSubFieldType(Target)
        
      Case Field::#FIELD_TYPE_BYTE
        Instruction.s = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + " = " + Field::FormatCryptedFileModule(0) + "ReadByte(FileID, P_Key)" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_ASCII
        Instruction = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + " = " + Field::FormatCryptedFileModule(0) + "ReadAsciiCharacter(FileID, P_Key)" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_UNICODE
        Instruction = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + " = " + Field::FormatCryptedFileModule(0) + "ReadUnicodeCharacter(FileID, P_Key)" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_CHARACTER
        Instruction = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + " = " + Field::FormatCryptedFileModule(0) + "ReadCharacter(FileID, P_Key)" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_INTEGER
        Instruction = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + " = " + Field::FormatCryptedFileModule(0) + "ReadInteger(FileID, P_Key)" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_WORD
        Instruction = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + " = " + Field::FormatCryptedFileModule(0) + "ReadWord(FileID, P_Key)" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_LONG
        Instruction = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + " = " + Field::FormatCryptedFileModule(0) + "ReadLong(FileID, P_Key)" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_QUAD
        Instruction = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + " = " + Field::FormatCryptedFileModule(0) + "ReadQuad(FileID, P_Key)" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_FLOAT
        Instruction = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + " = " + Field::FormatCryptedFileModule(0) + "ReadFloat(FileID, P_Key)" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_DOUBLE
        Instruction = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + " = " + Field::FormatCryptedFileModule(0) + "ReadDouble(FileID, P_Key)" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_STRING01, Field::#FIELD_TYPE_STRING02
        Instruction = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + " = " + Field::FormatCryptedFileModule(0) + "ReadString(FileID, P_Key)" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_MODULE
        Instruction = Comments::Tabulation(TabSize) + Field::GetFieldExternModuleName(Target) + "::Read" + Field::FormatCryptedFileModule(1) + Field::GetFieldExternModuleName(Target) + "(FileID, P_Key, " + InstanceAccessPath + Field::GetFieldAccess(Target)  + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
        
    EndSelect
    
    ProcedureReturn Instruction
  EndProcedure
  
  Procedure.s InstructionWriteBasic(TabSize.b, InstanceAccessPath.s, Target.b)
    
    Select Field::GetFieldType(Target)
        
      Case Field::#FIELD_TYPE_BYTE
        Instruction.s = Comments::Tabulation(TabSize) + Field::FormatCryptedFileModule(0) + "WriteByte(FileID, P_Key, " + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_ASCII
        Instruction = Comments::Tabulation(TabSize) + Field::FormatCryptedFileModule(0) + "WriteAsciiCharacter(FileID, P_Key, " + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_UNICODE
        Instruction = Comments::Tabulation(TabSize) + Field::FormatCryptedFileModule(0) + "WriteUnicodeCharacter(FileID, P_Key, " + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_CHARACTER
        Instruction = Comments::Tabulation(TabSize) + Field::FormatCryptedFileModule(0) + "WriteCharacter(FileID, P_Key, " + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_INTEGER
        Instruction = Comments::Tabulation(TabSize) + Field::FormatCryptedFileModule(0) + "WriteInteger(FileID, P_Key, " + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_WORD
        Instruction = Comments::Tabulation(TabSize) + Field::FormatCryptedFileModule(0) + "WriteWord(FileID, P_Key, " + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_LONG
        Instruction = Comments::Tabulation(TabSize) + Field::FormatCryptedFileModule(0) + "WriteLong(FileID, P_Key, P_Key, " + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_QUAD
        Instruction = Comments::Tabulation(TabSize) + Field::FormatCryptedFileModule(0) + "WriteQuad(FileID, P_Key, " + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_FLOAT
        Instruction = Comments::Tabulation(TabSize) + Field::FormatCryptedFileModule(0) + "WriteFloat(FileID, P_Key, " + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_DOUBLE
        Instruction = Comments::Tabulation(TabSize) + Field::FormatCryptedFileModule(0) + "WriteDouble(FileID, P_Key, " + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_STRING01, Field::#FIELD_TYPE_STRING02
        Instruction = Comments::Tabulation(TabSize) + Field::FormatCryptedFileModule(0) + "WriteString(FileID, P_Key, " + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_MODULE
        Instruction = Comments::Tabulation(TabSize) + Field::GetFieldExternModuleName(Target) + "::Write" + Field::FormatCryptedFileModule(1) + Field::GetFieldExternModuleName(Target) + "(FileID, P_Key, " + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
        
    EndSelect
    
    ProcedureReturn Instruction
  EndProcedure
  
  Procedure.s InstructionWriteStructure(TabSize.b, InstanceAccessPath.s, Target.b)
    
    Select Field::GetSubFieldType(Target)
        
      Case Field::#FIELD_TYPE_BYTE
        Instruction.s = Comments::Tabulation(TabSize) + Field::FormatCryptedFileModule(0) + "WriteByte(FileID, P_Key, " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_ASCII
        Instruction = Comments::Tabulation(TabSize) + Field::FormatCryptedFileModule(0) + "WriteAsciiCharacter(FileID, P_Key, " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_UNICODE
        Instruction = Comments::Tabulation(TabSize) + Field::FormatCryptedFileModule(0) + "WriteUnicodeCharacter(FileID, P_Key, " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_CHARACTER
        Instruction = Comments::Tabulation(TabSize) + Field::FormatCryptedFileModule(0) + "WriteCharacter(FileID, P_Key, " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_INTEGER
        Instruction = Comments::Tabulation(TabSize) + Field::FormatCryptedFileModule(0) + "WriteInteger(FileID, P_Key, " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_WORD
        Instruction = Comments::Tabulation(TabSize) + Field::FormatCryptedFileModule(0) + "WriteWord(FileID, P_Key, " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_LONG
        Instruction = Comments::Tabulation(TabSize) + Field::FormatCryptedFileModule(0) + "WriteLong(FileID, P_Key, P_Key, " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_QUAD
        Instruction = Comments::Tabulation(TabSize) + Field::FormatCryptedFileModule(0) + "WriteQuad(FileID, P_Key, " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_FLOAT
        Instruction = Comments::Tabulation(TabSize) + Field::FormatCryptedFileModule(0) + "WriteFloat(FileID, P_Key, " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_DOUBLE
        Instruction = Comments::Tabulation(TabSize) + Field::FormatCryptedFileModule(0) + "WriteDouble(FileID, P_Key, " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_STRING01, Field::#FIELD_TYPE_STRING02
        Instruction = Comments::Tabulation(TabSize) + Field::FormatCryptedFileModule(0) + "WriteString(FileID, P_Key, " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_MODULE
        Instruction = Comments::Tabulation(TabSize) + Field::GetFieldExternModuleName(Target) + "::Write" + Field::FormatCryptedFileModule(1) + Field::GetFieldExternModuleName(Target) + "(FileID, P_Key, " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
        
    EndSelect
    
    ProcedureReturn Instruction
  EndProcedure
  
  Procedure.s ReadCodeChunk(TabSize.b, InstanceAccessPath.s, Target.b)
    
    If Field::FirstInstance(Target)
      
      Repeat
        
        Select Field::GetFieldStyle(Target)
            
          Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
            SeparatorNeeded = #True
            
          Case Field::#FIELD_STYLE_BASIC
            SeparatorNeeded = #False
            
        EndSelect
        
        If Field::InstanceIndex(Target) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
          Buffer.s + Comments::Tabulation(TabSize) + Field::#LineFeed
        EndIf 
        
        Select Field::GetFieldStyle(Target)
            
          Case Field::#FIELD_STYLE_ARRAY
            
            TabSize.b = 2   
            
            For Index = 1 To Field::GetFieldDynamicArrayDimensionCount(Target)
              Buffer + Comments::Tabulation(TabSize) + Field::GetFieldName(Target) + "_Max_" + Str(Index) + "D.l = " + Field::FormatCryptedFileModule(0) + "ReadLong(FileID, P_Key)" + Field::#LineFeed
            Next 
            
            Buffer + Comments::Tabulation(TabSize) + ReDimArray(InstanceAccessPath, 0, 0) + Field::#TwinLinefeed
            Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize, 0)
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_MODULE
                Buffer + InstructionReadBasic(TabSize+1, InstanceAccessPath, Target)
                
              Case Field::#FIELD_TYPE_STRUCTURE
                
                If Field::FirstSubField(Target)
                  
                  Repeat 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
                        SeparatorNeeded2 = #True
                        
                      Case Field::#FIELD_STYLE_BASIC
                        SeparatorNeeded2 = #False
                        
                    EndSelect
                    
                    If Field::SubFieldIndex(Target) = 0 Or SeparatorNeeded2 = #True Or PreviousSeparator2 = #True
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf   
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY
                        TabSize2.b = TabSize + 1      
                        
                        For Index = 1 To Field::GetSubFieldDynamicArrayDimensionCount(Target)
                          Buffer + Comments::Tabulation(TabSize2) + Field::GetSubFieldName(Target) + "_Max_" + Str(Index) + "D.l = " + Field::FormatCryptedFileModule(0) + "ReadLong(FileID, P_Key)" + Field::#LineFeed
                        Next 
                        
                        Buffer + Comments::Tabulation(TabSize2) + ReDimArray(InstanceAccessPath, Target, 1) + Field::#TwinLinefeed
                        
                        Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize2, 1)
                        Buffer + InstructionReadStructure(TabSize2 + 1, InstanceAccessPath, Target)
                        Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize2, 1) + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_LIST
                        
                        Buffer + Comments::Tabulation(TabSize+1) + Field::GetSubFieldName(Target) + "_Max = " + Field::FormatCryptedFileModule(0) + "ReadLong(FileID, P_Key) - 1" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldName(Target) + "ID = 0 To " + Field::GetSubFieldName(Target) + "_Max" + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize+2) + "AddElement(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
                        Buffer + InstructionReadStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_MAP
                        
                        Buffer + Comments::Tabulation(TabSize+1) + Field::GetSubFieldName(Target) + "_Max = " + Field::FormatCryptedFileModule(0) + "ReadLong(FileID, P_Key) - 1" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldName(Target) + "ID = 0 To " + Field::GetSubFieldName(Target) + "_Max" + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize+2) + "AddMapElement(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ", " + Field::FormatCryptedFileModule(0) + "ReadString(FileID))" + Field::#LineFeed
                        Buffer + InstructionReadStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_BASIC
                        Buffer + InstructionReadStructure(TabSize+1, InstanceAccessPath, Target)
                        
                      Case Field::#FIELD_STYLE_BASIC_ARRAY
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldArrayIndexName(Target) + " = 0 To " + Field::GetSubFieldArraySizeLoop(Target) + Field::#LineFeed
                        Buffer + InstructionReadStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                    EndSelect 
                    
                    If Field::SubFieldIndex(Target) = Field::SubFieldSize(Target) - 1
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf
                    
                    PreviousSeparator2 = SeparatorNeeded2
                    
                  Until Field::NextSubField(Target) = #Null
                  
                EndIf
                
            EndSelect 
            
            Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize, 0) + Field::#LineFeed
            
          Case Field::#FIELD_STYLE_LIST
            
            Buffer + Comments::Tabulation(TabSize) + Field::GetFieldName(Target) + "_Max = " + Field::FormatCryptedFileModule(0) + "ReadLong(FileID, P_Key) - 1" + Field::#TwinLineFeed
            Buffer + Comments::Tabulation(TabSize) + "For " + Field::GetFieldName(Target) + "ID = 0 To " + Field::GetFieldName(Target) + "_Max" + Field::#LineFeed
            Buffer + Comments::Tabulation(TabSize + 1) + "AddElement(" + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_MODULE
                Buffer + InstructionReadBasic(TabSize+1, InstanceAccessPath, Target)
                
              Case Field::#FIELD_TYPE_STRUCTURE
                
                If Field::FirstSubField(Target)
                  
                  Repeat 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
                        SeparatorNeeded2 = #True
                        
                      Case Field::#FIELD_STYLE_BASIC
                        SeparatorNeeded2 = #False
                        
                    EndSelect
                    
                    If Field::SubFieldIndex(Target) = 0 Or SeparatorNeeded2 = #True Or PreviousSeparator2 = #True
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf   
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY
                        TabSize2.b = TabSize+1      
                        
                        For Index = 1 To Field::GetSubFieldDynamicArrayDimensionCount(Target)
                          Buffer + Comments::Tabulation(TabSize2) + Field::GetSubFieldName(Target) + "_Max_" + Str(Index) + "D.l = " + Field::FormatCryptedFileModule(0) + "ReadLong(FileID, P_Key)" + Field::#LineFeed
                        Next 
                        
                        Buffer + Comments::Tabulation(TabSize2) + ReDimArray(InstanceAccessPath, Target, 1) + Field::#TwinLinefeed
                        
                        Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize2, 1)
                        Buffer + InstructionReadStructure(TabSize2 + 1, InstanceAccessPath, Target)
                        Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize2, 1) + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_LIST
                        Buffer + Comments::Tabulation(TabSize+1) + Field::GetSubFieldName(Target) + "_Max = " + Field::FormatCryptedFileModule(0) + "ReadLong(FileID, P_Key) - 1" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldName(Target) + "ID = 0 To " + Field::GetSubFieldName(Target) + "_Max" + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize+2) + "AddElement(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
                        Buffer + InstructionReadStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_MAP
                        Buffer + Comments::Tabulation(TabSize+1) + Field::GetSubFieldName(Target) + "_Max = " + Field::FormatCryptedFileModule(0) + "ReadLong(FileID, P_Key) - 1" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldName(Target) + "ID = 0 To " + Field::GetSubFieldName(Target) + "_Max" + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize+2) + "AddMapElement(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ", " + Field::FormatCryptedFileModule(0) + "ReadString(FileID, P_Key))"+ Field::#LineFeed
                        Buffer + InstructionReadStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_BASIC
                        Buffer + InstructionReadStructure(TabSize+1, InstanceAccessPath, Target)
                        
                      Case Field::#FIELD_STYLE_BASIC_ARRAY
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldArrayIndexName(Target) + " = 0 To " + Field::GetSubFieldArraySizeLoop(Target) + Field::#LineFeed
                        Buffer + InstructionReadStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                    EndSelect 
                    
                    If Field::SubFieldIndex(Target) = Field::SubFieldSize(Target) - 1
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf
                    
                    PreviousSeparator2 = SeparatorNeeded2
                    
                  Until Field::NextSubField(Target) = #Null
                  
                EndIf
                
            EndSelect 
            
            Buffer + Comments::Tabulation(TabSize) + "Next" + Field::#LineFeed
            
          Case Field::#FIELD_STYLE_MAP
            Buffer + Comments::Tabulation(TabSize) + Field::GetFieldName(Target) + "_Max = " + Field::FormatCryptedFileModule(0) + "ReadLong(FileID, P_Key) - 1" + Field::#TwinLineFeed
            Buffer + Comments::Tabulation(TabSize) + "For " + Field::GetFieldName(Target) + "ID = 0 To " + Field::GetFieldName(Target) + "_Max" + Field::#LineFeed
            Buffer + Comments::Tabulation(TabSize+1) + "AddMapElement(" + InstanceAccessPath + Field::GetFieldAccess(Target) + ", " + Field::FormatCryptedFileModule(0) + "ReadString(FileID, P_Key))" + Field::#LineFeed
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_MODULE
                Buffer + InstructionReadBasic(TabSize + 1, InstanceAccessPath, Target)
                
              Case Field::#FIELD_TYPE_STRUCTURE
                
                If Field::FirstSubField(Target)
                  
                  Repeat 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
                        SeparatorNeeded2 = #True
                        
                      Case Field::#FIELD_STYLE_BASIC
                        SeparatorNeeded2 = #False
                        
                    EndSelect
                    
                    If Field::SubFieldIndex(Target) = 0 Or SeparatorNeeded2 = #True Or PreviousSeparator2 = #True
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf   
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY
                        TabSize2.b = 3       
                        
                        For Index = 1 To Field::GetSubFieldDynamicArrayDimensionCount(Target)
                          Buffer + Comments::Tabulation(TabSize2) + Field::GetSubFieldName(Target) + "_Max_" + Str(Index) + "D.l = " + Field::FormatCryptedFileModule(0) + "ReadLong(FileID, P_Key)" + Field::#LineFeed
                        Next 
                        
                        Buffer + Comments::Tabulation(TabSize2) + ReDimArray(InstanceAccessPath, 0, 1) + Field::#TwinLinefeed
                        
                        Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize2, 1)
                        Buffer + InstructionReadStructure(TabSize2 + 1, InstanceAccessPath, Target)
                        Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize2, 1) + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_LIST
                        Buffer + Comments::Tabulation(TabSize+1) + Field::GetSubFieldName(Target) + "_Max = " + Field::FormatCryptedFileModule(0) + "ReadLong(FileID, P_Key) - 1" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldName(Target) + "ID = 0 To " + Field::GetSubFieldName(Target) + "_Max" + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize+2) + "AddElement(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
                        Buffer + InstructionReadStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_MAP
                        Buffer + Comments::Tabulation(TabSize+1) + Field::GetSubFieldName(Target) + "_Max = " + Field::FormatCryptedFileModule(0) + "ReadLong(FileID, P_Key) - 1" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldName(Target) + "ID = 0 To " + Field::GetSubFieldName(Target) + "_Max" + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize+2) + "AddMapElement(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ", " + Field::FormatCryptedFileModule(0) + "ReadString(FileID, P_Key))" + Field::#LineFeed
                        Buffer + InstructionReadStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_BASIC
                        Buffer + InstructionReadStructure(3, InstanceAccessPath, Target)
                        
                      Case Field::#FIELD_STYLE_BASIC_ARRAY
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldArrayIndexName(Target) + " = 0 To " + Field::GetSubFieldArraySizeLoop(Target) + Field::#LineFeed
                        Buffer + InstructionReadStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                    EndSelect 
                    
                    If Field::SubFieldIndex(Target) = Field::SubFieldSize(Target) - 1
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf
                    
                    PreviousSeparator2 = SeparatorNeeded2
                    
                  Until Field::NextSubField(Target) = #Null
                  
                EndIf
                
            EndSelect 
            
            Buffer + Comments::Tabulation(TabSize) + "Next" + Field::#LineFeed
            
          Case Field::#FIELD_STYLE_BASIC
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_MODULE
                Buffer + InstructionReadBasic(TabSize, InstanceAccessPath, Target)
                
              Case Field::#FIELD_TYPE_STRUCTURE
                
                If Field::FirstSubField(Target)
                  
                  Repeat 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
                        SeparatorNeeded3 = #True
                        
                      Case Field::#FIELD_STYLE_BASIC
                        SeparatorNeeded3 = #False
                        
                    EndSelect
                    
                    If Field::SubFieldIndex(Target) = 0 Or SeparatorNeeded3 = #True Or PreviousSeparator3 = #True
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf   
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY
                        TabSize2.b = TabSize      
                        
                        For Index = 1 To Field::GetSubFieldDynamicArrayDimensionCount(Target)
                          Buffer + Comments::Tabulation(TabSize2) + Field::GetSubFieldName(Target) + "_Max_" + Str(Index) + "D.l = " + Field::FormatCryptedFileModule(0) + "ReadLong(FileID, P_Key)" + Field::#LineFeed
                        Next 
                        
                        Buffer + Comments::Tabulation(TabSize2) + ReDimArray(InstanceAccessPath, Target, 1) + Field::#TwinLinefeed
                        
                        Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize2, 1)
                        Buffer + InstructionReadStructure(TabSize2 + 1, InstanceAccessPath, Target)
                        Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize2, 1) + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_LIST
                        Buffer + Comments::Tabulation(TabSize) + Field::GetSubFieldName(Target) + "_Max = " + Field::FormatCryptedFileModule(0) + "ReadLong(FileID, P_Key) - 1" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize) + "For " + Field::GetSubFieldName(Target) + "ID = 0 To " + Field::GetSubFieldName(Target) + "_Max" + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "AddElement(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
                        Buffer + InstructionReadStructure(TabSize+1, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_MAP
                        Buffer + Comments::Tabulation(TabSize) + Field::GetSubFieldName(Target) + "_Max = " + Field::FormatCryptedFileModule(0) + "ReadLong(FileID, P_Key) - 1" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize) + "For " + Field::GetSubFieldName(Target) + "ID = 0 To " + Field::GetSubFieldName(Target) + "_Max" + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "AddMapElement(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ", " + Field::FormatCryptedFileModule(0) + "ReadString(FileID, P_Key))" + Field::#LineFeed
                        Buffer + InstructionReadStructure(TabSize+1, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_BASIC
                        Buffer + InstructionReadStructure(TabSize, InstanceAccessPath, Target)
                        
                      Case Field::#FIELD_STYLE_BASIC_ARRAY
                        Buffer + Comments::Tabulation(TabSize) + "For " + Field::GetSubFieldArrayIndexName(Target) + " = 0 To " + Field::GetSubFieldArraySizeLoop(Target) + Field::#LineFeed
                        Buffer + InstructionReadStructure(TabSize+1, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize) + "Next" + Field::#LineFeed
                        
                    EndSelect 
                    
                    If Field::SubFieldIndex(Target) = Field::SubFieldSize(Target) - 1
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf
                    
                    PreviousSeparator3 = SeparatorNeeded3
                    
                  Until Field::NextSubField(Target) = #Null
                  
                EndIf
                
            EndSelect 
            
          Case Field::#FIELD_STYLE_BASIC_ARRAY
            
            Buffer + Comments::Tabulation(TabSize) + "For " + Field::GetFieldArrayIndexName(Target) + " = 0 To " + Field::GetFieldArraySizeLoop(Target) + Field::#LineFeed
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_MODULE
                Buffer + InstructionReadBasic(TabSize+1, InstanceAccessPath, Target)
                
              Case Field::#FIELD_TYPE_STRUCTURE
                
                If Field::FirstSubField(Target)
                  
                  Select Field::GetSubFieldStyle(Target)
                      
                    Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded2 = #True
                      
                    Case Field::#FIELD_STYLE_BASIC
                      SeparatorNeeded2 = #False
                      
                  EndSelect
                  
                  If Field::SubFieldIndex(Target) = 0 Or SeparatorNeeded2 = #True Or PreviousSeparator2 = #True
                    Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                  EndIf   
                  
                  Repeat 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY
                        TabSize2.b = TabSize + 1       
                        
                        For Index = 1 To Field::GetSubFieldDynamicArrayDimensionCount(Target)
                          Buffer + Comments::Tabulation(TabSize2) + Field::GetSubFieldName(Target) + "_Max_" + Str(Index) + "D.l = " + Field::FormatCryptedFileModule(0) + "ReadLong(FileID, P_Key)" + Field::#LineFeed
                        Next 
                        
                        Buffer + Comments::Tabulation(TabSize2) + ReDimArray(InstanceAccessPath, Target, 1) + Field::#TwinLinefeed
                        
                        Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize2, 1)
                        Buffer + InstructionReadStructure(TabSize2 + 1, InstanceAccessPath, Target)
                        Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize2, 1) + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_LIST                        
                        Buffer + Comments::Tabulation(TabSize+1) + Field::GetSubFieldName(Target) + "_Max = " + Field::FormatCryptedFileModule(0) + "ReadLong(FileID, P_Key) - 1" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldName(Target) + "ID = 0 To " + Field::GetSubFieldName(Target) + "_Max" + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize+2) + "AddElement(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
                        Buffer + InstructionReadStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_MAP             
                        Buffer + Comments::Tabulation(TabSize+1) + Field::GetSubFieldName(Target) + "_Max = " + Field::FormatCryptedFileModule(0) + "ReadLong(FileID, P_Key) - 1" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldName(Target) + "ID = 0 To " + Field::GetSubFieldName(Target) + "_Max" + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize+2) + "AddMapElement(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ", " + Field::FormatCryptedFileModule(0) + "ReadString(FileID,P_Key))" + Field::#LineFeed
                        Buffer + InstructionReadStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_BASIC
                        Buffer + InstructionReadStructure(TabSize+1, InstanceAccessPath, Target)
                        
                      Case Field::#FIELD_STYLE_BASIC_ARRAY
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldArrayIndexName(Target) + " = 0 To " + Field::GetSubFieldArraySizeLoop(Target) + Field::#LineFeed
                        Buffer + InstructionReadStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                    EndSelect 
                    
                    If Field::SubFieldIndex(Target) = Field::SubFieldSize(Target) - 1
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf
                    
                    PreviousSeparator2 = SeparatorNeeded2
                    
                  Until Field::NextSubField(Target) = #Null
                  
                EndIf
                
            EndSelect 
            
            Buffer + Comments::Tabulation(TabSize) + "Next" + Field::#LineFeed
            
        EndSelect
        
        If Field::GetSecondaryInstance() = #False
          If Field::InstanceIndex(Target) = Field::InstanceSize(Target) - 1
            Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
          EndIf
        EndIf 
        
        PreviousSeparator = SeparatorNeeded
        
      Until Field::NextInstance(Target) = #Null
      
    EndIf
    
    ProcedureReturn Buffer
  EndProcedure
  
  Procedure.s WriteCodeChunk(TabSize.b, InstanceAccessPath.s, Target.b)
    
    If Field::FirstInstance(Target)
      
      Repeat
        
        Select Field::GetFieldStyle(Target)
            
          Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
            SeparatorNeeded = #True
            
          Case Field::#FIELD_STYLE_BASIC
            SeparatorNeeded = #False
            
        EndSelect
        
        If Field::InstanceIndex(Target) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
          Buffer.s + Comments::Tabulation(TabSize) + Field::#LineFeed
        EndIf 
        
        Select Field::GetFieldStyle(Target)
            
          Case Field::#FIELD_STYLE_ARRAY
            
            TabSize.b = 2   
            
            For Index = 1 To Field::GetFieldDynamicArrayDimensionCount(Target)
              Buffer + Comments::Tabulation(TabSize) + Field::FormatCryptedFileModule(0) + "WriteLong(FileID, P_Key, ArraySize(" + InstanceAccessPath + Field::GetFieldAccessEmpty(Target) + ", " + Str(Index) +"))" + Field::#TwinLineFeed
            Next 
            
            Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize, 0)
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_MODULE
                Buffer + InstructionWriteBasic(TabSize+1, InstanceAccessPath, Target)
                
              Case Field::#FIELD_TYPE_STRUCTURE
                
                If Field::FirstSubField(Target)
                  
                  Repeat 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
                        SeparatorNeeded2 = #True
                        
                      Case Field::#FIELD_STYLE_BASIC
                        SeparatorNeeded2 = #False
                        
                    EndSelect
                    
                    If Field::SubFieldIndex(Target) = 0 Or SeparatorNeeded2 = #True Or PreviousSeparator2 = #True
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf   
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY
                        TabSize2.b = TabSize + 1      
                        
                        For Index = 1 To Field::GetSubFieldDynamicArrayDimensionCount(Target)
                          Buffer + Comments::Tabulation(TabSize2) + Field::FormatCryptedFileModule(0) + "WriteLong(FileID, P_Key, ArraySize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccessEmpty(Target) + ", " + Str(Index) + "))" + Field::#TwinLineFeed
                        Next 
                        
                        Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize2, 1)
                        Buffer + InstructionWriteStructure(TabSize2 + 1, InstanceAccessPath, Target)
                        Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize2, 1) + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_LIST
                        Buffer + Comments::Tabulation(TabSize+1) + Field::FormatCryptedFileModule(0) + "WriteLong(FileID, P_Key, ListSize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) +"))" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + Field::#LineFeed
                        Buffer + InstructionWriteStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_MAP
                        Buffer + Comments::Tabulation(TabSize+1) + Field::FormatCryptedFileModule(0) + "WriteLong(FileID, P_Key, MapSize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + "))" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize+2) + Field::FormatCryptedFileModule(0) + "WriteString(FileID, P_Key, MapKey(" + InstanceAccessPath + Field::GetFieldAccess(Target)  + "\" + Field::GetSubFieldAccess(Target) + "))" + Field::#LineFeed
                        Buffer + InstructionWriteStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_BASIC
                        Buffer + InstructionWriteStructure(TabSize+1, InstanceAccessPath, Target)
                        
                      Case Field::#FIELD_STYLE_BASIC_ARRAY
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldArrayIndexName(Target) + " = 0 To " + Field::GetSubFieldArraySizeLoop(Target) + Field::#LineFeed
                        Buffer + InstructionWriteStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                    EndSelect 
                    
                    If Field::SubFieldIndex(Target) = Field::SubFieldSize(Target) - 1
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf
                    
                    PreviousSeparator2 = SeparatorNeeded2
                    
                  Until Field::NextSubField(Target) = #Null
                  
                EndIf
                
            EndSelect 
            
            Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize, 0) + Field::#LineFeed
            
          Case Field::#FIELD_STYLE_LIST
            
            Buffer + Comments::Tabulation(TabSize) + Field::FormatCryptedFileModule(0) + "WriteLong(FileID, P_Key, ListSize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "))" + Field::#TwinLineFeed
            Buffer + Comments::Tabulation(TabSize) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + Field::#LineFeed
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_MODULE
                Buffer + InstructionWriteBasic(TabSize+1, InstanceAccessPath, Target)
                
              Case Field::#FIELD_TYPE_STRUCTURE
                
                If Field::FirstSubField(Target)
                  
                  Repeat 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
                        SeparatorNeeded2 = #True
                        
                      Case Field::#FIELD_STYLE_BASIC
                        SeparatorNeeded2 = #False
                        
                    EndSelect
                    
                    If Field::SubFieldIndex(Target) = 0 Or SeparatorNeeded2 = #True Or PreviousSeparator2 = #True
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf   
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY
                        TabSize2.b = TabSize+1      
                        
                        For Index = 1 To Field::GetSubFieldDynamicArrayDimensionCount(Target)
                          Buffer + Comments::Tabulation(TabSize2) + Field::FormatCryptedFileModule(0) + "WriteLong(FileID, P_Key, ArraySize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccessEmpty(Target) + ", " + Str(Index) + "))" + Field::#TwinLineFeed
                        Next 
                        
                        Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize2, 1)
                        Buffer + InstructionWriteStructure(TabSize2 + 1, InstanceAccessPath, Target)
                        Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize2, 1) + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_LIST
                        Buffer + Comments::Tabulation(TabSize+1) + Field::FormatCryptedFileModule(0) + "WriteLong(FileID, P_Key, ListSize(" + InstanceAccessPath + Field::GetFieldAccess(Target)  + "\" + Field::GetSubFieldAccess(Target) + "))" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target)  + "\" + Field::GetSubFieldAccess(Target) + Field::#LineFeed
                        Buffer + InstructionWriteStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_MAP
                        Buffer + Comments::Tabulation(TabSize+1) + Field::FormatCryptedFileModule(0) + "WriteLong(FileID, P_Key, MapSize(" + InstanceAccessPath + Field::GetFieldAccess(Target)  + "\" + Field::GetSubFieldAccess(Target) + "))" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target)  + "\" + Field::GetSubFieldAccess(Target) + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize+2) + Field::FormatCryptedFileModule(0) + "WriteString(FileID, P_Key, MapKey(" + InstanceAccessPath + Field::GetFieldAccess(Target)  + "\" + Field::GetSubFieldAccess(Target) + "))" + Field::#LineFeed
                        Buffer + InstructionWriteStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_BASIC
                        Buffer + InstructionWriteStructure(TabSize+1, InstanceAccessPath, Target)
                        
                      Case Field::#FIELD_STYLE_BASIC_ARRAY
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldArrayIndexName(Target) + " = 0 To " + Field::GetSubFieldArraySizeLoop(Target) + Field::#LineFeed
                        Buffer + InstructionWriteStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                    EndSelect 
                    
                    If Field::SubFieldIndex(Target) = Field::SubFieldSize(Target) - 1
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf
                    
                    PreviousSeparator2 = SeparatorNeeded2
                    
                  Until Field::NextSubField(Target) = #Null
                  
                EndIf
                
            EndSelect 
            
            Buffer + Comments::Tabulation(TabSize) + "Next" + Field::#LineFeed
            
          Case Field::#FIELD_STYLE_MAP
            Buffer + Comments::Tabulation(TabSize) + Field::FormatCryptedFileModule(0) + "WriteLong(FileID, P_Key, MapSize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "))" + Field::#LineFeed
            Buffer + Comments::Tabulation(TabSize) + Field::GetFieldName(Target) + "ID = 0" + Field::#TwinLineFeed
            Buffer + Comments::Tabulation(TabSize) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + Field::#LineFeed
            Buffer + Comments::Tabulation(TabSize + 2) + Field::FormatCryptedFileModule(0) + "WriteString(FileID, P_Key, MapKey(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "))" + Field::#LineFeed
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_MODULE
                Buffer + InstructionWriteBasic(TabSize + 1, InstanceAccessPath, Target)
                
              Case Field::#FIELD_TYPE_STRUCTURE
                
                If Field::FirstSubField(Target)
                  
                  Repeat 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
                        SeparatorNeeded2 = #True
                        
                      Case Field::#FIELD_STYLE_BASIC
                        SeparatorNeeded2 = #False
                        
                    EndSelect
                    
                    If Field::SubFieldIndex(Target) = 0 Or SeparatorNeeded2 = #True Or PreviousSeparator2 = #True
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf   
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY
                        TabSize2.b = 3       
                        
                        For Index = 1 To Field::GetSubFieldDynamicArrayDimensionCount(Target)
                          Buffer + Comments::Tabulation(TabSize2) + Field::FormatCryptedFileModule(0) + "WriteLong(FileID, P_Key, ArraySize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccessEmpty(Target) + ", " + Str(Index) + "))" + Field::#TwinLineFeed
                        Next 
                        
                        Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize2, 1)
                        Buffer + InstructionWriteStructure(TabSize2 + 1, InstanceAccessPath, Target)
                        Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize2, 1) + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_LIST
                        Buffer + Comments::Tabulation(TabSize+1) + Field::FormatCryptedFileModule(0) + "WriteLong(FileID, P_Key, ListSize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + "))" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + Field::#LineFeed
                        Buffer + InstructionWriteStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_MAP
                        Buffer + Comments::Tabulation(TabSize + 1) + Field::FormatCryptedFileModule(0) + "WriteLong(FileID, P_Key, MapSize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + "))" + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize + 1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize + 2) + Field::FormatCryptedFileModule(0) + "WriteString(FileID, P_Key, MapKey(" + InstanceAccessPath + Field::GetFieldAccess(Target)  + "\" + Field::GetSubFieldAccess(Target) + "))" + Field::#LineFeed
                        Buffer + InstructionWriteStructure(TabSize + 2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize + 1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_BASIC
                        Buffer + InstructionWriteStructure(3, InstanceAccessPath, Target)
                        
                      Case Field::#FIELD_STYLE_BASIC_ARRAY
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldArrayIndexName(Target) + " = 0 To " + Field::GetSubFieldArraySizeLoop(Target) + Field::#LineFeed
                        Buffer + InstructionWriteStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                    EndSelect 
                    
                    If Field::SubFieldIndex(Target) = Field::SubFieldSize(Target) - 1
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf
                    
                    PreviousSeparator2 = SeparatorNeeded2
                    
                  Until Field::NextSubField(Target) = #Null
                  
                EndIf
                
            EndSelect 
            
            Buffer + Comments::Tabulation(TabSize+1) + Field::GetFieldName(Target) + "ID + 1" + Field::#TwinLineFeed
            Buffer + Comments::Tabulation(TabSize) + "Next" + Field::#LineFeed
            
          Case Field::#FIELD_STYLE_BASIC
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_MODULE
                Buffer + InstructionWriteBasic(TabSize, InstanceAccessPath, Target)
                
              Case Field::#FIELD_TYPE_STRUCTURE
                
                If Field::FirstSubField(Target)
                  
                  Repeat 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
                        SeparatorNeeded2 = #True
                        
                      Case Field::#FIELD_STYLE_BASIC
                        SeparatorNeeded2 = #False
                        
                    EndSelect
                    
                    If Field::SubFieldIndex(Target) = 0 Or SeparatorNeeded2 = #True Or PreviousSeparator2 = #True
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf   
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY
                        TabSize2.b = TabSize      
                        
                        For Index = 1 To Field::GetSubFieldDynamicArrayDimensionCount(Target)
                          Buffer + Comments::Tabulation(TabSize2) + Field::FormatCryptedFileModule(0) + "WriteLong(FileID, P_Key, ArraySize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccessEmpty(Target) + ", " + Str(Index) + "))" + Field::#TwinLineFeed
                        Next 
                        
                        Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize2, 1)
                        Buffer + InstructionWriteStructure(TabSize2 + 1, InstanceAccessPath, Target)
                        Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize2, 1) + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_LIST
                        Buffer + Comments::Tabulation(TabSize) + Field::FormatCryptedFileModule(0) + "WriteLong(FileID, P_Key, ListSize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + "))" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + Field::#LineFeed
                        Buffer + InstructionWriteStructure(TabSize+1, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_MAP
                        Buffer + Comments::Tabulation(TabSize) + Field::FormatCryptedFileModule(0) + "WriteLong(FileID, P_Key, MapSize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + "))" + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize + 1) + Field::FormatCryptedFileModule(0) + "WriteString(FileID, P_Key, MapKey(" + InstanceAccessPath + Field::GetFieldAccess(Target)  + "\" + Field::GetSubFieldAccess(Target) + "))" + Field::#LineFeed
                        Buffer + InstructionWriteStructure(TabSize + 1, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_BASIC
                        Buffer + InstructionWriteStructure(TabSize, InstanceAccessPath, Target)
                        
                      Case Field::#FIELD_STYLE_BASIC_ARRAY
                        Buffer + Comments::Tabulation(TabSize) + "For " + Field::GetSubFieldArrayIndexName(Target) + " = 0 To " + Field::GetSubFieldArraySizeLoop(Target) + Field::#LineFeed
                        Buffer + InstructionWriteStructure(TabSize+1, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize) + "Next" + Field::#LineFeed
                        
                    EndSelect 
                    
                    If Field::SubFieldIndex(Target) = Field::SubFieldSize(Target) - 1
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf
                    
                    PreviousSeparator2 = SeparatorNeeded2
                    
                  Until Field::NextSubField(Target) = #Null
                  
                EndIf
                
            EndSelect 
            
          Case Field::#FIELD_STYLE_BASIC_ARRAY
            
            Buffer + Comments::Tabulation(TabSize) + "For " + Field::GetFieldArrayIndexName(Target) + " = 0 To " + Field::GetFieldArraySizeLoop(Target) + Field::#LineFeed
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_MODULE
                Buffer + InstructionWriteBasic(TabSize+1, InstanceAccessPath, Target)
                
              Case Field::#FIELD_TYPE_STRUCTURE
                
                If Field::FirstSubField(Target)
                  
                  Select Field::GetSubFieldStyle(Target)
                      
                    Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded3 = #True
                      
                    Case Field::#FIELD_STYLE_BASIC
                      SeparatorNeeded3 = #False
                      
                  EndSelect
                  
                  If Field::SubFieldIndex(Target) = 0 Or SeparatorNeeded3 = #True Or PreviousSeparator3 = #True
                    Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                  EndIf   
                  
                  Repeat 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY
                        TabSize2.b = TabSize + 1       
                        
                        For Index = 1 To Field::GetSubFieldDynamicArrayDimensionCount(Target)
                          Buffer + Comments::Tabulation(TabSize2) + Field::FormatCryptedFileModule(0) + "WriteLong(FileID, P_Key, ArraySize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccessEmpty(Target) + ", " + Str(Index) + "))" + Field::#TwinLineFeed
                        Next 
                        
                        Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize2, 1)
                        Buffer + InstructionWriteStructure(TabSize2 + 1, InstanceAccessPath, Target)
                        Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize2, 1) + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_LIST
                        Buffer + Comments::Tabulation(TabSize+1) + Field::FormatCryptedFileModule(0) + "WriteLong(FileID, P_Key, ListSize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + "))" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + Field::#LineFeed
                        Buffer + InstructionWriteStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_MAP
                        Buffer + Comments::Tabulation(TabSize + 1) + Field::FormatCryptedFileModule(0) + "WriteLong(FileID, P_Key, MapSize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + "))" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize + 1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize + 2) + Field::FormatCryptedFileModule(0) + "WriteString(FileID, P_Key, MapKey(" + InstanceAccessPath + Field::GetFieldAccess(Target)  + "\" + Field::GetSubFieldAccess(Target) + "))" + Field::#LineFeed
                        Buffer + InstructionWriteStructure(TabSize + 2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize + 1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_BASIC
                        Buffer + InstructionWriteStructure(TabSize+1, InstanceAccessPath, Target)
                        
                      Case Field::#FIELD_STYLE_BASIC_ARRAY
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldArrayIndexName(Target) + " = 0 To " + Field::GetSubFieldArraySizeLoop(Target) + Field::#LineFeed
                        Buffer + InstructionWriteStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                    EndSelect 
                    
                    If Field::SubFieldIndex(Target) = Field::SubFieldSize(Target) - 1
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf
                    
                    PreviousSeparator3 = SeparatorNeeded3
                    
                  Until Field::NextSubField(Target) = #Null
                  
                EndIf
                
            EndSelect 
            
            Buffer + Comments::Tabulation(TabSize) + "Next" + Field::#LineFeed
            
        EndSelect
        
        If Field::GetSecondaryInstance() = #False
          If Field::InstanceIndex(Target) = Field::InstanceSize(Target) - 1
            Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
          EndIf
        EndIf 
        
        PreviousSeparator = SeparatorNeeded
        
      Until Field::NextInstance(Target) = #Null
      
    EndIf
    
    ProcedureReturn Buffer
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'Oprateur de dfinition Read <<<<<

  Procedure.s DefineRead()
    
    Buffer.s = Comments::Tabulation(1) + "Procedure Read" + Field::FormatCryptedFileModule(1) + Field::GetModuleName() + "(FileID.i, P_Key.s" + Field::GetExtraParam() + ")" + Field::#LineFeed
    
    Select Field::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE, Field::#INSTANCE_STYLE_OFF_MODULE
        Buffer + ReadCodeChunk(2, Field::GetInstanceAccessPath(), 0)
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME
        
        TempBuffer.s = ReadCodeChunk(4, Field::GetInstanceAccessPath(), 0) + Field::#LineFeed
        
        Buffer + Comments::Tabulation(2) + Field::#LineFeed
        
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID
            Buffer + Comments::Tabulation(2) + "If P_InstanceID = -1" + Field::#TwinLineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(2) + "If P_Index = -1" + Field::#TwinLineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
            Buffer + Comments::Tabulation(2) + "If P_Name = "  + Field::#EmptyString + Field::#TwinLineFeed
            
        EndSelect
        
        Buffer + Comments::Tabulation(3) + "Instances_Max.l = " + Field::FormatCryptedFileModule(0) + "ReadLong(FileID, P_Key) - 1"+ Field::#TwinLineFeed
        Buffer + Comments::Tabulation(3) + "For Index = 0 to Instances_Max" + Field::#LineFeed
  
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(4) + "AddElement(Instances())" + Field::#LineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
            Buffer + Comments::Tabulation(4) + "AddMapElement(Instances(), " + Field::FormatCryptedFileModule(0) + "ReadString(FileID, P_Key))" + Field::#LineFeed
            
        EndSelect
        
        Buffer + TempBuffer
        Buffer + Comments::Tabulation(3) + "Next" + Field::#TwinLineFeed
        
        Buffer + Comments::Tabulation(2) + "Else" + Field::#TwinLineFeed
        
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID
            Buffer + Comments::Tabulation(3) + "If SearchInstances(" + StringField(Field::GetInstanceParam(), 1, ".") + ") <> -1" + Field::#LineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(3) + "If SelectElement(Instances(), " + StringField(Field::GetInstanceParam(), 1, ".") + ")" + Field::#LineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
            Buffer + Comments::Tabulation(3) + "If FindMapElement(Instances(), " + StringField(Field::GetInstanceParam(), 1, ".") + ")" + Field::#LineFeed  
            
        EndSelect
        
        Buffer + TempBuffer
        Buffer + Comments::Tabulation(3) + "EndIf" + Field::#TwinLineFeed
        
        If Field::GetSecondaryInstance() = #False
          Buffer + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed
        Else
          Buffer + Comments::Tabulation(2) + "EndIf" + Field::#LineFeed
        EndIf
        
    EndSelect
    
    If Field::GetSecondaryInstance() = #True
      Buffer + ReadCodeChunk(2, "Secondary\", 1)
      Buffer + Comments::Tabulation(2) + Field::#LineFeed
    EndIf
    
    Buffer + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
    
    ProcedureReturn Buffer
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'Oprateur de dfinition Write <<<<<

  Procedure.s DefineWrite()
    
    Buffer.s = Comments::Tabulation(1) + "Procedure Write" + Field::FormatCryptedFileModule(1) + Field::GetModuleName() + "(FileID.i, P_Key.s" + Field::GetExtraParam() + ")" + Field::#LineFeed
    
    Select Field::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE, Field::#INSTANCE_STYLE_OFF_MODULE
        Buffer + WriteCodeChunk(2, Field::GetInstanceAccessPath(), 0)
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME
        
        TempBuffer.s = WriteCodeChunk(4, Field::GetInstanceAccessPath(), 0) + Field::#LineFeed
        
        Buffer + Comments::Tabulation(2) + Field::#LineFeed
        
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID
            Buffer + Comments::Tabulation(2) + "If P_InstanceID = -1" + Field::#TwinLineFeed
            Buffer + Comments::Tabulation(3) + Field::FormatCryptedFileModule(0) + "WriteLong(FileID, P_Key, ListSize(Instances()))"+ Field::#TwinLineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(2) + "If P_Index = -1" + Field::#TwinLineFeed
            Buffer + Comments::Tabulation(3) + Field::FormatCryptedFileModule(0) + "WriteLong(FileID, P_Key, ListSize(Instances()))"+ Field::#TwinLineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
            Buffer + Comments::Tabulation(2) + "If P_Name = "  + Field::#EmptyString + Field::#TwinLineFeed
            Buffer + Comments::Tabulation(3) + Field::FormatCryptedFileModule(0) + "WriteLong(FileID, P_Key, MapSize(Instances()))"+ Field::#TwinLineFeed
            
        EndSelect
        
        Buffer + Comments::Tabulation(3) + "ForEach Instances()" + Field::#LineFeed
        
        If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_MULTIPLE_NAME
          Buffer + Comments::Tabulation(4) + Field::FormatCryptedFileModule(0) + "WriteString(FileID, P_Key, MapKey(Instances()))" + Field::#LineFeed
        EndIf
        
        Buffer + TempBuffer
        Buffer + Comments::Tabulation(3) + "Next" + Field::#TwinLineFeed
        
        Buffer + Comments::Tabulation(2) + "Else" + Field::#TwinLineFeed
        
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID
            Buffer + Comments::Tabulation(3) + "If SearchInstances(" + StringField(Field::GetInstanceParam(), 1, ".") + ") <> -1" + Field::#LineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(3) + "If SelectElement(Instances(), " + StringField(Field::GetInstanceParam(), 1, ".") + ")" + Field::#LineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
            Buffer + Comments::Tabulation(3) + "If FindMapElement(Instances(), " + StringField(Field::GetInstanceParam(), 1, ".") + ")" + Field::#LineFeed  
            
        EndSelect
        
        Buffer + TempBuffer
        Buffer + Comments::Tabulation(3) + "EndIf" + Field::#TwinLineFeed
        
        If Field::GetSecondaryInstance() = #False
          Buffer + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed
        Else
          Buffer + Comments::Tabulation(2) + "EndIf" + Field::#LineFeed
        EndIf
        
    EndSelect
    
    If Field::GetSecondaryInstance() = #True
      Buffer + WriteCodeChunk(2, "Secondary\", 1)
      Buffer + Comments::Tabulation(2) + Field::#LineFeed
    EndIf
    
    Buffer + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
    
    ProcedureReturn Buffer
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'Oprateur de dfinition CreateFile <<<<<
  
  Procedure.s DefineCreateFile()
    
    Buffer.s = Comments::Tabulation(1) + "Procedure Create" + Field::FormatCryptedFileModule(1) + Field::GetModuleName() + "File(FileID.i, P_FileName.s, P_Key.s" + Field::GetExtraParam() + ")" + Field::#TwinLineFeed
    Buffer + Comments::Tabulation(2) + "FileHandle = CreateFile(FileID, P_FileName)" + Field::#TwinLineFeed
    Buffer + Comments::Tabulation(2) + "If FileID = Field::#PB_Any" + Field::#LineFeed
    Buffer + Comments::Tabulation(3) + "FileID = FileHandle" + Field::#LineFeed
    Buffer + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed
    Buffer + Comments::Tabulation(2) + "If IsFile(FileID) <> 0" + Field::#LineFeed
    
    Select Field::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE, Field::#INSTANCE_STYLE_OFF_MODULE
        Buffer + WriteCodeChunk(3, Field::GetInstanceAccessPath(), 0)
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME
        
        TempBuffer.s = WriteCodeChunk(5, Field::GetInstanceAccessPath(), 0) + Field::#LineFeed
        
        Buffer + Comments::Tabulation(2) + Field::#LineFeed
        
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID
            Buffer + Comments::Tabulation(2) + "If P_InstanceID = -1" + Field::#TwinLineFeed
            Buffer + Comments::Tabulation(3) + Field::FormatCryptedFileModule(0) + "WriteLong(FileID, P_Key, ListSize(Instances()))"+ Field::#TwinLineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(2) + "If P_Index = -1" + Field::#TwinLineFeed
            Buffer + Comments::Tabulation(3) + Field::FormatCryptedFileModule(0) + "WriteLong(FileID, P_Key, ListSize(Instances()))"+ Field::#TwinLineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
            Buffer + Comments::Tabulation(2) + "If P_Name = "  + Field::#EmptyString + Field::#TwinLineFeed
            Buffer + Comments::Tabulation(3) + Field::FormatCryptedFileModule(0) + "WriteLong(FileID, P_Key, MapSize(Instances()))"+ Field::#TwinLineFeed
            
        EndSelect
        
        Buffer + Comments::Tabulation(3) + "ForEach Instances()" + Field::#LineFeed
        
        If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_MULTIPLE_NAME
          Buffer + Comments::Tabulation(4) + Field::FormatCryptedFileModule(0) + "WriteString(FileID, P_Key, MapKey(Instances()))" + Field::#LineFeed
        EndIf
        
        Buffer + TempBuffer
        Buffer + Comments::Tabulation(3) + "Next" + Field::#TwinLineFeed
        
        Buffer + Comments::Tabulation(2) + "Else" + Field::#TwinLineFeed
        
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID
            Buffer + Comments::Tabulation(3) + "If SearchInstances(" + StringField(Field::GetInstanceParam(), 1, ".") + ") <> -1" + Field::#LineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(3) + "If SelectElement(Instances(), " + StringField(Field::GetInstanceParam(), 1, ".") + ")" + Field::#LineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
            Buffer + Comments::Tabulation(3) + "If FindMapElement(Instances(), " + StringField(Field::GetInstanceParam(), 1, ".") + ")" + Field::#LineFeed  
            
        EndSelect
        
        Buffer + TempBuffer
        Buffer + Comments::Tabulation(3) + "EndIf" + Field::#TwinLineFeed
        
        If Field::GetSecondaryInstance() = #False
          Buffer + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed
        Else
          Buffer + Comments::Tabulation(2) + "EndIf" + Field::#LineFeed
        EndIf
        
    EndSelect
    
    If Field::GetSecondaryInstance() = #True
      Buffer + WriteCodeChunk(3, "Secondary\", 1)
      Buffer + Comments::Tabulation(3) + Field::#LineFeed
    EndIf

    Buffer + Comments::Tabulation(3) + "CloseFile(FileID)" + Field::#TwinLineFeed
    Buffer + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed
    Buffer + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
    
    ProcedureReturn Buffer
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'Oprateur de dfinition OpenFile <<<<<
  
  Procedure.s DefineOpenFile()
    
    Buffer.s = Comments::Tabulation(1) + "Procedure Open" + Field::FormatCryptedFileModule(1) + Field::GetModuleName() + "File(FileID.i, P_FileName.s, P_Key.s" + Field::GetExtraParam() + ")" + Field::#TwinLineFeed
    Buffer + Comments::Tabulation(2) + "FileHandle = OpenFile(FileID, P_FileName)" + Field::#TwinLineFeed
    Buffer + Comments::Tabulation(2) + "If FileID = Field::#PB_Any" + Field::#LineFeed
    Buffer + Comments::Tabulation(3) + "FileID = FileHandle" + Field::#LineFeed
    Buffer + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed
    Buffer + Comments::Tabulation(2) + "If IsFile(FileID) <> 0" + Field::#LineFeed
    
    Select Field::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE, Field::#INSTANCE_STYLE_OFF_MODULE
        Buffer + ReadCodeChunk(3, Field::GetInstanceAccessPath(), 0)
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME
        
        TempBuffer.s = ReadCodeChunk(5, Field::GetInstanceAccessPath(), 0) + Field::#LineFeed
        
        Buffer + Comments::Tabulation(2) + Field::#LineFeed
        
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID
            Buffer + Comments::Tabulation(2) + "If P_InstanceID = -1" + Field::#TwinLineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(2) + "If P_Index = -1" + Field::#TwinLineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
            Buffer + Comments::Tabulation(2) + "If P_Name = "  + Field::#EmptyString + Field::#TwinLineFeed
            
        EndSelect
        
        Buffer + Comments::Tabulation(3) + "Instances_Max.l = " + Field::FormatCryptedFileModule(0) + "ReadLong(FileID, P_Key) - 1"+ Field::#TwinLineFeed
        Buffer + Comments::Tabulation(3) + "For Index = 0 to Instances_Max" + Field::#LineFeed
  
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(4) + "AddElement(Instances())" + Field::#LineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
            Buffer + Comments::Tabulation(4) + "AddMapElement(Instances(), " + Field::FormatCryptedFileModule(0) + "ReadString(FileID))" + Field::#LineFeed
            
        EndSelect
        
        Buffer + TempBuffer
        Buffer + Comments::Tabulation(3) + "Next" + Field::#TwinLineFeed
        
        Buffer + Comments::Tabulation(2) + "Else" + Field::#TwinLineFeed
        
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID
            Buffer + Comments::Tabulation(3) + "If SearchInstances(" + StringField(Field::GetInstanceParam(), 1, ".") + ") <> -1" + Field::#LineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(3) + "If SelectElement(Instances(), " + StringField(Field::GetInstanceParam(), 1, ".") + ")" + Field::#LineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
            Buffer + Comments::Tabulation(3) + "If FindMapElement(Instances(), " + StringField(Field::GetInstanceParam(), 1, ".") + ")" + Field::#LineFeed  
            
        EndSelect
        
        Buffer + TempBuffer
        Buffer + Comments::Tabulation(3) + "EndIf" + Field::#TwinLineFeed
        
        If Field::GetSecondaryInstance() = #False
          Buffer + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed
        Else
          Buffer + Comments::Tabulation(2) + "EndIf" + Field::#LineFeed
        EndIf
        
    EndSelect
    
    If Field::GetSecondaryInstance() = #True
      Buffer + ReadCodeChunk(3, "Secondary\", 1)
      Buffer + Comments::Tabulation(3) + Field::#LineFeed
    EndIf
     
    Buffer + Comments::Tabulation(3) + "CloseFile(FileID)" + Field::#TwinLineFeed
    Buffer + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed
    Buffer + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
    
    ProcedureReturn Buffer
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'Oprateur de dfinition ReadFile <<<<<
  
  Procedure.s DefineReadFile()
    
    Buffer.s = Comments::Tabulation(1) + "Procedure Read" + Field::FormatCryptedFileModule(1) + Field::GetModuleName() + "File(FileID.i, P_FileName.s, P_Key.s" + Field::GetExtraParam() + ")" + Field::#TwinLineFeed
    Buffer + Comments::Tabulation(2) + "FileHandle = ReadFile(FileID, P_FileName)" + Field::#TwinLineFeed
    Buffer + Comments::Tabulation(2) + "If FileID = Field::#PB_Any" + Field::#LineFeed
    Buffer + Comments::Tabulation(3) + "FileID = FileHandle" + Field::#LineFeed
    Buffer + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed
    Buffer + Comments::Tabulation(2) + "If IsFile(FileID) <> 0" + Field::#LineFeed
    
    Select Field::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE, Field::#INSTANCE_STYLE_OFF_MODULE
        Buffer + ReadCodeChunk(3, Field::GetInstanceAccessPath(), 0)
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME
        
        TempBuffer.s = ReadCodeChunk(5, Field::GetInstanceAccessPath(), 0) + Field::#LineFeed
        
        Buffer + Comments::Tabulation(2) + Field::#LineFeed
        
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID
            Buffer + Comments::Tabulation(2) + "If P_InstanceID = -1" + Field::#TwinLineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(2) + "If P_Index = -1" + Field::#TwinLineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
            Buffer + Comments::Tabulation(2) + "If P_Name = "  + Field::#EmptyString + Field::#TwinLineFeed
            
        EndSelect
        
        Buffer + Comments::Tabulation(3) + "Instances_Max.l = " + Field::FormatCryptedFileModule(0) + "ReadLong(FileID, P_Key) - 1"+ Field::#TwinLineFeed
        Buffer + Comments::Tabulation(3) + "For Index = 0 to Instances_Max" + Field::#LineFeed
  
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(4) + "AddElement(Instances())" + Field::#LineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
            Buffer + Comments::Tabulation(4) + "AddMapElement(Instances(), " + Field::FormatCryptedFileModule(0) + "ReadString(FileID, P_Key))" + Field::#LineFeed
            
        EndSelect
        
        Buffer + TempBuffer
        Buffer + Comments::Tabulation(3) + "Next" + Field::#TwinLineFeed
        
        Buffer + Comments::Tabulation(2) + "Else" + Field::#TwinLineFeed
        
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID
            Buffer + Comments::Tabulation(3) + "If SearchInstances(" + StringField(Field::GetInstanceParam(), 1, ".") + ") <> -1" + Field::#LineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(3) + "If SelectElement(Instances(), " + StringField(Field::GetInstanceParam(), 1, ".") + ")" + Field::#LineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
            Buffer + Comments::Tabulation(3) + "If FindMapElement(Instances(), " + StringField(Field::GetInstanceParam(), 1, ".") + ")" + Field::#LineFeed  
            
        EndSelect
        
        Buffer + TempBuffer
        Buffer + Comments::Tabulation(3) + "EndIf" + Field::#TwinLineFeed
        
        If Field::GetSecondaryInstance() = #False
          Buffer + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed
        Else
          Buffer + Comments::Tabulation(2) + "EndIf" + Field::#LineFeed
        EndIf
        
    EndSelect
    
    If Field::GetSecondaryInstance() = #True
      Buffer + ReadCodeChunk(3, "Secondary\", 1)
      Buffer + Comments::Tabulation(3) + Field::#LineFeed
    EndIf
    
    Buffer + Comments::Tabulation(3) + "CloseFile(FileID)" + Field::#TwinLineFeed
    Buffer + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed
    Buffer + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
    
    ProcedureReturn Buffer
  EndProcedure
  
EndModule

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Code gnr en : 00.001 secondes (159000.00 lignes/seconde) <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.70 beta 1 (Linux - x64)
; Folding = ---DA9
; EnableXP
; CompileSourceDirectory