; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; CODE GNR AUTOMATIQUEMENT, NE PAS MODIFIER 
; MOINS D'AVOIR UNE RAISON TRS TRS VALABLE !!!
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Code gnr par : Dev-Module - V0.9.2
; Nom du projet : Dev-Module
; Nom du fichier : DevMoidule - PrefsFileMethods.pb
; Version du fichier : 1.0.0
; Programmation : OK
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 22-07-2018
; Mise  jour : 01-08-2018
; Cod pour PureBasic : V5.70 beta 1
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule PrefsFileMethods

  Declare.b GetReadWriteGroup()
  Declare.b GetCreateOpenFile()
  Declare SetReadWriteGroup(P_ReadWriteGroup.b)
  Declare SetCreateOpenFile(P_CreateOpenFile.b)
  Declare Reset()
  Declare ReadPrefs(P_GroupName.s)
  Declare WritePrefs(P_GroupName.s)
  Declare.s DeclareReadGroup()
  Declare.s DeclareWriteGroup()
  Declare.s DeclareCreateFile()
  Declare.s DeclareOpenFile()
  Declare.s DefineReadGroup()
  Declare.s DefineWriteGroup()
  Declare.s DefineCreateFile()
  Declare.s DefineOpenFile()
  
EndDeclareModule

Module PrefsFileMethods
 
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Dclaration de la Structure <<<<<

  Structure Instance

    ReadWriteGroup.b
    CreateOpenFile.b

  EndStructure

  Global Instance.Instance

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Les observateurs <<<<<

  Procedure.b GetReadWriteGroup()

    ProcedureReturn Instance\ReadWriteGroup
  EndProcedure

  Procedure.b GetCreateOpenFile()

    ProcedureReturn Instance\CreateOpenFile
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Les mutateurs <<<<<

  Procedure SetReadWriteGroup(P_ReadWriteGroup.b)

    Instance\ReadWriteGroup = P_ReadWriteGroup

  EndProcedure

  Procedure SetCreateOpenFile(P_CreateOpenFile.b)

    Instance\CreateOpenFile = P_CreateOpenFile

  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Reset <<<<<

  Procedure Reset()
    
    Instance\ReadWriteGroup = 0
    Instance\CreateOpenFile = 0
    
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Lecture d'un groupe Prfrences <<<<<

  Procedure ReadPrefs(P_GroupName.s)

    PreferenceGroup(P_GroupName)
    
    Instance\ReadWriteGroup = ReadPreferenceLong("ReadWriteGroup", Instance\ReadWriteGroup)
    Instance\CreateOpenFile = ReadPreferenceLong("CreateOpenFile", Instance\CreateOpenFile)
    
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< criture d'un groupe de Prfrences <<<<<

  Procedure WritePrefs(P_GroupName.s)

    PreferenceGroup(P_GroupName)
    
    WritePreferenceLong("ReadWriteGroup", Instance\ReadWriteGroup)
    WritePreferenceLong("CreateOpenFile", Instance\CreateOpenFile)
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< l'oprateur de dclaration ReadGroup <<<<<
  
  Procedure.s DeclareReadGroup()

    ProcedureReturn Comments::Tabulation(1) + "Declare ReadPrefs(P_GroupName.s" + Field::GetExtraParam() + ")" + Field::#LineFeed
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< l'oprateur de dclaration WriteGroup <<<<<
  
  Procedure.s DeclareWriteGroup()
    
    ProcedureReturn Comments::Tabulation(1) + "Declare WritePrefs(P_GroupName.s" + Field::GetExtraParam() + ")" + Field::#LineFeed
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< l'oprateur de dclaration CreateFile <<<<<
  
  Procedure.s DeclareCreateFile()

    ProcedureReturn Comments::Tabulation(1) + "Declare CreatePrefs(FileName.s"  + Field::GetExtraParam() + ")" + Field::#LineFeed
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< l'oprateur de dclaration OpenFile <<<<<
  
  Procedure.s DeclareOpenFile()
    
    ProcedureReturn Comments::Tabulation(1) + "Declare OpenPrefs(FileName.s" + Field::GetExtraParam() + ")" + Field::#LineFeed
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Oprateurs privs <<<<<
  
  Procedure.s BuiltDynamicArrayIndexList(Target.b, SubTarget.b, Mode.b)
    
    Select SubTarget
        
      Case 0
        
        If Field::GetFieldDynamicArrayDimensionCount(Target) <> 0
 
          Select Mode
              
            Case 0
              
              For Index = 1 To Field::GetFieldDynamicArrayDimensionCount(Target)
                
                ParamList.s = ParamList + " + Str(" + Field::GetFieldDynamicArrayDimensionIndexName(Target, Index - 1)  + ")"
                
                If Index < Field::GetFieldDynamicArrayDimensionCount(Target)
                  ParamList = ParamList + " + " + Chr(34) + "_" + Chr(34)
                EndIf 
                
              Next 
              
            Case 1
              
              For Index = 1 To Field::GetFieldDynamicArrayDimensionCount(Target)
                
                ParamList = ParamList + Field::GetFieldName(Target) + "_Max_" + Str(Index) + "D"
                
                If Index < Field::GetFieldDynamicArrayDimensionCount(Target)
                  ParamList + ", "
                EndIf
                
              Next
              
          EndSelect
          
        EndIf
        
      Case 1
        
        If Field::GetSubFieldDynamicArrayDimensionCount(Target) <> 0
          
          Select Mode
              
            Case 0
   
              For Index = 1 To Field::GetSubFieldDynamicArrayDimensionCount(Target)
                
                ParamList = ParamList + " + Str(" + Field::GetSubFieldDynamicArrayDimensionIndexName(Target, Index - 1)  + ")"
                
                If Index < Field::GetSubFieldDynamicArrayDimensionCount(Target)
                  ParamList = ParamList + " + " + Chr(34) + "_" + Chr(34)
                EndIf 
                
              Next 
 
            Case 1
              
              For Index = 1 To Field::GetSubFieldDynamicArrayDimensionCount(Target)
                
                ParamList = ParamList + Field::GetSubFieldName(Target) + "_Max_" + Str(Index) + "D"
                
                If Index < Field::GetSubFieldDynamicArrayDimensionCount(Target)
                  ParamList + ", "
                EndIf
                
              Next
              
          EndSelect

        EndIf
        
    EndSelect
    
    ProcedureReturn ParamList
  EndProcedure 
  
  Procedure.s ReDimArray(InstanceStyle.s, Target.b, SubTarget.b)
    
    Select SubTarget
        
      Case 0
        Output.s = "ReDim " + InstanceStyle + Field::GetFieldAccessMax(Target)
        
      Case 1
        Output.s = "ReDim " + InstanceStyle + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccessMax(Target)
        
    EndSelect
      
    ProcedureReturn Output
  EndProcedure
  
  Procedure.s PrefsKey(Target.b, Style.b)
    
    InstanceStyle.s = Field::GetInstanceAccessPath() 
    
    Select Style
        
        ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        ; Cas de figure pour les tableaux dynamiques
        
      Case 0 ; OK
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Chr(34) + BuiltDynamicArrayIndexList(Target, 0, 0)
        
      Case 1 ; OK
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Chr(34) + BuiltDynamicArrayIndexList(Target, 0, 0) + " + " + Chr(34) + "_" + Field::GetSubFieldName(Target) + "_" + Chr(34) + BuiltDynamicArrayIndexList(Target, 1, 0)
        
      Case 2 ; OK
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Chr(34) + BuiltDynamicArrayIndexList(Target, 0, 0) + " + " + Chr(34) + "_" + Field::GetSubFieldName(Target) + "_" + Chr(34) +  " + Str(" + Field::GetSubFieldName(Target) + "ID)"
        
      Case 3 ; OK  
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Chr(34) + BuiltDynamicArrayIndexList(Target, 0, 0) + " + " + Chr(34) + "_" + Field::GetSubFieldName(Target) + "_Key_" + Chr(34) +  " + Str(" + Field::GetSubFieldName(Target) + "ID)"
        
      Case 4 ; OK
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Chr(34) + BuiltDynamicArrayIndexList(Target, 0, 0) + " + " + Chr(34) + "_" + Field::GetSubFieldName(Target) + Chr(34)
        
      Case 5 ; OK
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Chr(34) + BuiltDynamicArrayIndexList(Target, 0, 0) + " + " + Chr(34) + "_" + Field::GetSubFieldName(Target) + "_" + Chr(34) + " + Str(" + Field::GetSubFieldArrayIndexName(Target) + ")" 
        
        ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        ; Cas de figure pour les listes chaines et les Map
        
      Case 6 ; OK
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Chr(34) + " + Str(" + Field::GetFieldName(Target) + "ID)"
        
      Case 7 ; OK
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Chr(34) + " + Str(" + Field::GetFieldName(Target) + "ID) + " + Chr(34) + "_" + Field::GetSubFieldName(Target) + "_" + Chr(34) + BuiltDynamicArrayIndexList(Target, 1, 0)
        
      Case 8 ; OK
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Chr(34) + " + Str(" + Field::GetFieldName(Target) + "ID) + " + Chr(34) + "_" + Field::GetSubFieldName(Target) + "_" + Chr(34) +  " + Str(" + Field::GetSubFieldName(Target) + "ID)"
        
      Case 9 ; OK
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Chr(34) + " + Str(" + Field::GetFieldName(Target) + "ID) + " + Chr(34) + "_" + Field::GetSubFieldName(Target) + "_Key_" + Chr(34) +  " + Str(" + Field::GetSubFieldName(Target) + "ID)"
        
      Case 10 ; OK
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Chr(34) + " + Str(" + Field::GetFieldName(Target) + "ID) + " + Chr(34) + "_" + Field::GetSubFieldName(Target) + Chr(34) 
        
      Case 11 ; OK
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Chr(34) + " + Str(" + Field::GetFieldName(Target) + "ID) + " + Chr(34) + "_" + Field::GetSubFieldName(Target) + "_" + Chr(34) + " + Str(" + Field::GetSubFieldArrayIndexName(Target) + ")" 
        
        ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        ; Cas de figure pour les Map
        
      Case 12
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_Key_" + Chr(34) + " + Str(" + Field::GetFieldName(Target) + "ID)"
        
        ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        ; Cas de figure pour les champs Basic
        
      Case 13
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + Chr(34)
        
      Case 14
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Field::GetSubFieldName(Target) + "_" + Chr(34) + BuiltDynamicArrayIndexList(Target, 1, 0)
        
      Case 15
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Field::GetSubFieldName(Target) + "_" + Chr(34) +  " + Str(" + Field::GetSubFieldName(Target) + "ID)"
        
      Case 16
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Field::GetSubFieldName(Target) + "_Key_" + Chr(34) +  " + Str(" + Field::GetSubFieldName(Target) + "ID)"
        
      Case 17
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Field::GetSubFieldName(Target) + Chr(34) 
        
      Case 18
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Field::GetSubFieldName(Target) + "_" + Chr(34) + " + Str(" + Field::GetSubFieldArrayIndexName(Target) + ")" 
        
        ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        ; Cas de figure pour les champs Basic Array
        
      Case 19
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Chr(34) + " + Str(" + Field::GetFieldArrayIndexName(Target) + ")"
        
      Case 20
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Chr(34) + " + Str(" + Field::GetFieldArrayIndexName(Target) + ") + "  + Chr(34) + "_" + Field::GetSubFieldName(Target) + "_" + Chr(34) + BuiltDynamicArrayIndexList(Target, 1, 0)
        
      Case 21
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Chr(34) + " + Str(" + Field::GetFieldArrayIndexName(Target) + ") + " + Chr(34) + "_" + Field::GetSubFieldName(Target) + "_" + Chr(34) +  " + Str(" + Field::GetSubFieldName(Target) + "ID)"
        
      Case 22
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Chr(34) + " + Str(" + Field::GetFieldArrayIndexName(Target) + ") + " + Chr(34) + "_" + Field::GetSubFieldName(Target) + "_Key_" + Chr(34) +  " + Str(" + Field::GetSubFieldName(Target) + "ID)"
        
      Case 23
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Chr(34) + " + Str(" + Field::GetFieldArrayIndexName(Target) + ") + " + Chr(34) + "_" + Field::GetSubFieldName(Target) + Chr(34) 
        
      Case 24
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Chr(34) + " + Str(" + Field::GetFieldArrayIndexName(Target) + ") + " + Chr(34) + "_" + Field::GetSubFieldName(Target) + "_" + Chr(34) + " + Str(" + Field::GetSubFieldArrayIndexName(Target) + ")" 
        
        ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        ; Cas de figure pour les listes chaines (Mode Write)
        
      Case 25
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Chr(34) + " + Str(ListIndex(" + InstanceStyle + Field::GetFieldAccess(Target) + "))"
        
      Case 26
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Chr(34) + " + Str(ListIndex(" + InstanceStyle + Field::GetFieldAccess(Target) + ")) + " + Chr(34) + "_" + Field::GetSubFieldName(Target) + "_" + Chr(34) + BuiltDynamicArrayIndexList(Target, 1, 0)
        
      Case 27
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Chr(34) + " + Str(ListIndex(" + InstanceStyle + Field::GetFieldAccess(Target) + ")) + " + Chr(34) + "_" + Field::GetSubFieldName(Target) + "_" + Chr(34) +  " + Str(ListIndex(" + InstanceStyle + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + "))"
        
      Case 28
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Chr(34) + " + Str(ListIndex(" + InstanceStyle + Field::GetFieldAccess(Target) + ")) + " + Chr(34) + "_" + Field::GetSubFieldName(Target) + "_Key_" + Chr(34) +  " + Str(" + Field::GetSubFieldName(Target) + "ID)"
        
      Case 29
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Chr(34) + " + Str(ListIndex(" + InstanceStyle + Field::GetFieldAccess(Target) + ")) + " + Chr(34) + "_" + Field::GetSubFieldName(Target) + Chr(34) 
        
      Case 30
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Chr(34) + " + Str(ListIndex(" + InstanceStyle + Field::GetFieldAccess(Target) + ")) + " + Chr(34) + "_" + Field::GetSubFieldName(Target) + "_" + Chr(34) + " + Str(" + Field::GetSubFieldArrayIndexName(Target) + ")" 
        
      Case 31
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Chr(34) + " + Str(ListIndex(" + InstanceStyle + Field::GetFieldAccess(Target) + ")) + " + Chr(34) + "_" + Field::GetSubFieldName(Target) + "_" + Chr(34) +  " + Str(" + Field::GetSubFieldName(Target) + "ID)"
        
        ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        ; Cas de figure pour les Maps (Mode Write)
        
      Case 32 ; OK
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Chr(34) + " + Str(" + Field::GetFieldName(Target) + "ID)"
        
      Case 33 ; OK
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Chr(34) + " + Str(" + Field::GetFieldName(Target) + "ID) + " + Chr(34) + "_" + Field::GetSubFieldName(Target) + "_" + Chr(34) + BuiltDynamicArrayIndexList(Target, 1, 0)
        
      Case 34 ; OK
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Chr(34) + " + Str(" + Field::GetFieldName(Target) + "ID) + " + Chr(34) + "_" + Field::GetSubFieldName(Target) + "_" + Chr(34) +  " + Str(ListIndex(" + InstanceStyle + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + "))"
        
      Case 35 ; OK
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Chr(34) + " + Str(" + Field::GetFieldName(Target) + "ID) + " + Chr(34) + "_" + Field::GetSubFieldName(Target) + "_Key_" + Chr(34) +  " + Str(" + Field::GetSubFieldName(Target) + "ID)"
       
      Case 36 ; OK
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Chr(34) + " + Str(" + Field::GetFieldName(Target) + "ID) + " + Chr(34) + "_" + Field::GetSubFieldName(Target) + "_" + Chr(34) +  " + Str(" + Field::GetSubFieldName(Target) + "ID)"
        
        ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        ; Cas de figure pour les champs Basic (Mode Write)
        
      Case 37
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Field::GetSubFieldName(Target) + "_" + Chr(34) +  " + Str(ListIndex(" + InstanceStyle + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + "))"
        
      Case 38 ; OK
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Field::GetSubFieldName(Target) + "_Key_" + Chr(34) +  " + Str(" + Field::GetSubFieldName(Target) + "ID)"
       
      Case 39 ; OK
        PrefsKey.s = Chr(34) + Field::GetFieldName(Target) + "_" + Field::GetSubFieldName(Target) + "_" + Chr(34) +  " + Str(" + Field::GetSubFieldName(Target) + "ID)"
        
    EndSelect
    
    ProcedureReturn PrefsKey
  EndProcedure
  
  Procedure.s InstructionReadBasic(TabSize.b, InstanceAccessPath.s, Target.b, PrefKeyStyle.b)
    
    Select Field::GetFieldType(Target)
        
      Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_CHARACTER, Field::#FIELD_TYPE_WORD, Field::#FIELD_TYPE_LONG
        Instruction.s = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + " = ReadPreferenceLong(" + PrefsKey(Target, PrefKeyStyle) + ", " + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_INTEGER
        Instruction = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + " = ReadPreferenceInteger(" + PrefsKey(Target, PrefKeyStyle)  + ", " + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_QUAD
        Instruction = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + " = ReadPreferenceQuad(" + PrefsKey(Target, PrefKeyStyle)  + ", " + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_FLOAT
        Instruction = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + " = ReadPreferenceFloat(" + PrefsKey(Target, PrefKeyStyle) + ", " + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_DOUBLE
        Instruction = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + " = ReadPreferenceDouble(" + PrefsKey(Target, PrefKeyStyle) + ", " + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_STRING01, Field::#FIELD_TYPE_STRING02
        Instruction = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + " = ReadPreferenceString(" + PrefsKey(Target, PrefKeyStyle) + ", " + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_MODULE
        Instruction = Comments::Tabulation(TabSize) + Field::GetFieldExternModuleName(Target) + "::ReadPrefs(" + PrefsKey(Target, PrefKeyStyle) + ", " + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
        
    EndSelect
    
    ProcedureReturn Instruction
  EndProcedure
  
  Procedure.s InstructionReadStructure(TabSize.b, InstanceAccessPath.s, Target.b, PrefKeyStyle.b)
    
    Select Field::GetSubFieldType(Target)
        
      Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_CHARACTER, Field::#FIELD_TYPE_WORD, Field::#FIELD_TYPE_LONG
        Instruction.s = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + " = ReadPreferenceLong(" + PrefsKey(Target, PrefKeyStyle) + ", " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_INTEGER
        Instruction.s = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + " = ReadPreferenceInteger(" + PrefsKey(Target, PrefKeyStyle) + ", " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_QUAD
        Instruction.s = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + " = ReadPreferenceQuad(" + PrefsKey(Target, PrefKeyStyle) + ", " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_FLOAT
        Instruction = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + " = ReadPreferenceFloat(" + PrefsKey(Target, PrefKeyStyle) + ", " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_DOUBLE
        Instruction = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + " = ReadPreferenceDouble(" + PrefsKey(Target, PrefKeyStyle) + ", " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_STRING01, Field::#FIELD_TYPE_STRING02
        Instruction = Comments::Tabulation(TabSize) + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + " = ReadPreferenceString(" + PrefsKey(Target, PrefKeyStyle) + ", " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_MODULE
        Instruction = Comments::Tabulation(TabSize) + Field::GetSubFieldExternModuleName(Target) + "::ReadPrefs(" + PrefsKey(Target, PrefKeyStyle) + ", " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
        
    EndSelect 
    
    ProcedureReturn Instruction
  EndProcedure
 
  Procedure.s InstructionWriteBasic(TabSize.b, InstanceAccessPath.s, Target.b, PrefKeyStyle.b)
    
    Select Field::GetFieldType(Target)
        
      Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_CHARACTER, Field::#FIELD_TYPE_WORD, Field::#FIELD_TYPE_LONG
        Instruction.s = Comments::Tabulation(TabSize) + "WritePreferenceLong(" + PrefsKey(Target, PrefKeyStyle) + ", " + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_INTEGER
        Instruction = Comments::Tabulation(TabSize) + "WritePreferenceInteger(" + PrefsKey(Target, PrefKeyStyle)  + ", " + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_QUAD
        Instruction = Comments::Tabulation(TabSize) + "WritePreferenceQuad(" + PrefsKey(Target, PrefKeyStyle)  + ", " + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_FLOAT
        Instruction = Comments::Tabulation(TabSize) + "WritePreferenceFloat(" + PrefsKey(Target, PrefKeyStyle) + ", " + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_DOUBLE
        Instruction = Comments::Tabulation(TabSize) + "WritePreferenceDouble(" + PrefsKey(Target, PrefKeyStyle) + ", " + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_STRING01, Field::#FIELD_TYPE_STRING02
        Instruction = Comments::Tabulation(TabSize) + "WritePreferenceString(" + PrefsKey(Target, PrefKeyStyle) + ", " + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_MODULE
        Instruction = Comments::Tabulation(TabSize) + Field::GetFieldExternModuleName(Target) + "::WritePrefs(" + PrefsKey(Target, PrefKeyStyle) + ", " + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
        
    EndSelect
    
    ProcedureReturn Instruction
  EndProcedure
  
  Procedure.s InstructionWriteStructure(TabSize.b, InstanceAccessPath.s, Target.b, PrefKeyStyle.b)
    
    Select Field::GetSubFieldType(Target)
        
      Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_CHARACTER, Field::#FIELD_TYPE_WORD, Field::#FIELD_TYPE_LONG
        Instruction.s = Comments::Tabulation(TabSize) + "WritePreferenceLong(" + PrefsKey(Target, PrefKeyStyle) + ", " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_INTEGER
        Instruction.s = Comments::Tabulation(TabSize) + "WritePreferenceInteger(" + PrefsKey(Target, PrefKeyStyle) + ", " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_QUAD
        Instruction.s = Comments::Tabulation(TabSize) + "WritePreferenceQuad(" + PrefsKey(Target, PrefKeyStyle) + ", " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_FLOAT
        Instruction = Comments::Tabulation(TabSize) + "WritePreferenceFloat(" + PrefsKey(Target, PrefKeyStyle) + ", " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_DOUBLE
        Instruction = Comments::Tabulation(TabSize) + "WritePreferenceDouble(" + PrefsKey(Target, PrefKeyStyle) + ", " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_STRING01, Field::#FIELD_TYPE_STRING02
        Instruction = Comments::Tabulation(TabSize) + "WritePreferenceString(" + PrefsKey(Target, PrefKeyStyle) + ", " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
        
      Case Field::#FIELD_TYPE_MODULE
        Instruction = Comments::Tabulation(TabSize) + Field::GetSubFieldExternModuleName(Target) + "::WritePrefs(" + PrefsKey(Target, PrefKeyStyle) + ", " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
        
    EndSelect 
    
    ProcedureReturn Instruction
  EndProcedure
  
  Procedure.s ReadPrefsCodeChunk(TabSize.b, InstanceAccessPath.s, Target.b)
    
    If Field::FirstInstance(Target)
      
      Repeat
        
        Select Field::GetFieldStyle(Target)
            
          Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
            SeparatorNeeded = #True
            
          Case Field::#FIELD_STYLE_BASIC
            SeparatorNeeded = #False
            
        EndSelect
        
        If Field::InstanceIndex(Target) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
          Buffer.s + Comments::Tabulation(TabSize) + Field::#LineFeed
        EndIf 
        
        Select Field::GetFieldStyle(Target)
            
          Case Field::#FIELD_STYLE_ARRAY
            
            TabSize.b = 2   
            
            For Index = 1 To Field::GetFieldDynamicArrayDimensionCount(Target)
              Buffer + Comments::Tabulation(TabSize) + Field::GetFieldName(Target) + "_Max_" + Str(Index) + "D.l = ReadPreferenceLong(" + Chr(34) + Field::GetFieldName(Target) + "_Max_" + Str(Index) + "D" + Chr(34) + ", 0)" + Field::#LineFeed
            Next 
            
            Buffer + Comments::Tabulation(TabSize) + ReDimArray(InstanceAccessPath, 0, 0) + Field::#TwinLinefeed
            Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize, 0)
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_MODULE
                Buffer + InstructionReadBasic(TabSize+1, InstanceAccessPath, Target, 0)
                
              Case Field::#FIELD_TYPE_STRUCTURE
                
                If Field::FirstSubField(Target)
                  
                  Repeat 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
                        SeparatorNeeded2 = #True
                        
                      Case Field::#FIELD_STYLE_BASIC
                        SeparatorNeeded2 = #False
                        
                    EndSelect
                    
                    If Field::SubFieldIndex(Target) = 0 Or SeparatorNeeded2 = #True Or PreviousSeparator2 = #True
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf   
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY
                        TabSize2.b = TabSize + 1      
                        
                        For Index = 1 To Field::GetSubFieldDynamicArrayDimensionCount(Target)
                          Buffer + Comments::Tabulation(TabSize2) + Field::GetSubFieldName(Target) + "_Max_" + Str(Index) + "D.l = ReadPreferenceLong(" + Chr(34) + Field::GetSubFieldName(Target) + "_Max_" + Str(Index) + "D" + Chr(34) + ", 0)" + Field::#LineFeed
                        Next 
                        
                        Buffer + Comments::Tabulation(TabSize2) + ReDimArray(InstanceAccessPath, Target, 1) + Field::#TwinLinefeed
                        
                        Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize2, 1)
                        Buffer + InstructionReadStructure(TabSize2 + 1, InstanceAccessPath, Target, 1)
                        Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize2, 1) + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_LIST
                        
                        Buffer + Comments::Tabulation(TabSize+1) + Field::GetSubFieldName(Target) + "_Max = ReadPreferenceLong(" + Chr(34) + Field::GetSubFieldName(Target) + "_Max" + Chr(34) + ", 0) - 1" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldName(Target) + "ID = 0 To " + Field::GetSubFieldName(Target) + "_Max" + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize+2) + "AddElement(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
                        Buffer + InstructionReadStructure(TabSize+2, InstanceAccessPath, Target, 2)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_MAP
                        
                        Buffer + Comments::Tabulation(TabSize+1) + Field::GetSubFieldName(Target) + "_Max = ReadPreferenceLong(" + Chr(34) + Field::GetSubFieldName(Target) + "_Max" + Chr(34) + ", 0) - 1" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldName(Target) + "ID = 0 To " + Field::GetSubFieldName(Target) + "_Max" + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize+2) + "AddMapElement(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ", ReadPreferenceString(" + PrefsKey(0, 3) + ", " + Chr(34) + Chr(34) + "))" + Field::#LineFeed
                        Buffer + InstructionReadStructure(TabSize+2, InstanceAccessPath, Target, 2)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_BASIC
                        Buffer + InstructionReadStructure(TabSize+1, InstanceAccessPath, Target, 4)
                        
                      Case Field::#FIELD_STYLE_BASIC_ARRAY
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldArrayIndexName(Target) + " = 0 To " + Field::GetSubFieldArraySizeLoop(Target) + Field::#LineFeed
                        Buffer + InstructionReadStructure(TabSize+2, InstanceAccessPath, Target, 5)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                    EndSelect 
                    
                    If Field::SubFieldIndex(Target) = Field::SubFieldSize(Target) - 1
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf
                    
                    PreviousSeparator2 = SeparatorNeeded2
                    
                  Until Field::NextSubField(Target) = #Null
                  
                EndIf
                
            EndSelect 
            
            Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize, 0) + Field::#LineFeed
            
          Case Field::#FIELD_STYLE_LIST
            
            Buffer + Comments::Tabulation(TabSize) + Field::GetFieldName(Target) + "_Max = ReadPreferenceLong(" + Chr(34) + Field::GetFieldName(Target) + "_Max" + Chr(34) + ", 0) - 1" + Field::#TwinLineFeed
            Buffer + Comments::Tabulation(TabSize) + "For " + Field::GetFieldName(Target) + "ID = 0 To " + Field::GetFieldName(Target) + "_Max" + Field::#LineFeed
            Buffer + Comments::Tabulation(TabSize+1) + "AddElement(" + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + Field::#LineFeed
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_MODULE
                Buffer + InstructionReadBasic(TabSize+1, InstanceAccessPath, Target, 6)
                
              Case Field::#FIELD_TYPE_STRUCTURE
                
                If Field::FirstSubField(Target)
                  
                  Repeat 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
                        SeparatorNeeded2 = #True
                        
                      Case Field::#FIELD_STYLE_BASIC
                        SeparatorNeeded2 = #False
                        
                    EndSelect
                    
                    If Field::SubFieldIndex(Target) = 0 Or SeparatorNeeded2 = #True Or PreviousSeparator2 = #True
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf   
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY
                        TabSize2.b = TabSize+1      
                        
                        For Index = 1 To Field::GetSubFieldDynamicArrayDimensionCount(Target)
                          Buffer + Comments::Tabulation(TabSize2) + Field::GetSubFieldName(Target) + "_Max_" + Str(Index) + "D.l = ReadPreferenceLong(" + Chr(34) + Field::GetSubFieldName(Target) + "_Max_" + Str(Index) + "D" + Chr(34) + ", 0)" + Field::#LineFeed
                        Next 
                        
                        Buffer + Comments::Tabulation(TabSize2) + ReDimArray(InstanceAccessPath, Target, 1) + Field::#TwinLinefeed
                        
                        Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize2, 1)
                        Buffer + InstructionReadStructure(TabSize2 + 1, InstanceAccessPath, Target, 7)
                        Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize2, 1) + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_LIST
                        
                        Buffer + Comments::Tabulation(TabSize+1) + Field::GetSubFieldName(Target) + "_Max = ReadPreferenceLong(" + Chr(34) + Field::GetSubFieldName(Target) + "_Max" + Chr(34) + ", 0) - 1" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldName(Target) + "ID = 0 To " + Field::GetSubFieldName(Target) + "_Max" + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize+2) + "AddElement(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
                        Buffer + InstructionReadStructure(TabSize+2, InstanceAccessPath, Target, 8)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_MAP
                        
                        Buffer + Comments::Tabulation(TabSize+1) + Field::GetSubFieldName(Target) + "_Max = ReadPreferenceLong(" + Chr(34) + Field::GetSubFieldName(Target) + "_Max" + Chr(34) + ", 0) - 1" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldName(Target) + "ID = 0 To " + Field::GetSubFieldName(Target) + "_Max" + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize+2) + "AddMapElement(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ", ReadPreferenceString(" + PrefsKey(0, 9) + ", " + Chr(34) + Chr(34) + "))" + Field::#LineFeed
                        Buffer + InstructionReadStructure(TabSize+2, InstanceAccessPath, Target, 8)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_BASIC
                        Buffer + InstructionReadStructure(TabSize+1, InstanceAccessPath, Target, 10)
                        
                      Case Field::#FIELD_STYLE_BASIC_ARRAY
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldArrayIndexName(Target) + " = 0 To " + Field::GetSubFieldArraySizeLoop(Target) + Field::#LineFeed
                        Buffer + InstructionReadStructure(TabSize+2, InstanceAccessPath, Target, 11)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                    EndSelect 
                    
                    If Field::SubFieldIndex(Target) = Field::SubFieldSize(Target) - 1
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf
                    
                    PreviousSeparator2 = SeparatorNeeded2
                    
                  Until Field::NextSubField(Target) = #Null
                  
                EndIf
                
            EndSelect 
            
            Buffer + Comments::Tabulation(TabSize) + "Next" + Field::#LineFeed
            
          Case Field::#FIELD_STYLE_MAP
            Buffer + Comments::Tabulation(TabSize) + Field::GetFieldName(Target) + "_Max = ReadPreferenceLong(" + Chr(34) + Field::GetFieldName(Target) + "_Max" + Chr(34) + ", 0) - 1" + Field::#TwinLineFeed
            Buffer + Comments::Tabulation(TabSize) + "For " + Field::GetFieldName(Target) + "ID = 0 To " + Field::GetFieldName(Target) + "_Max" + Field::#LineFeed
            Buffer + Comments::Tabulation(TabSize+1) + "AddMapElement(" + InstanceAccessPath + Field::GetFieldAccess(Target) + ", ReadPreferenceString(" + PrefsKey(0, 12) + ", " + Chr(34) + Chr(34) + "))" + Field::#LineFeed
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_MODULE
                Buffer + InstructionReadBasic(TabSize + 1, InstanceAccessPath, Target, 6)
                
              Case Field::#FIELD_TYPE_STRUCTURE
                
                If Field::FirstSubField(Target)
                  
                  Repeat 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
                        SeparatorNeeded2 = #True
                        
                      Case Field::#FIELD_STYLE_BASIC
                        SeparatorNeeded2 = #False
                        
                    EndSelect
                    
                    If Field::SubFieldIndex(Target) = 0 Or SeparatorNeeded2 = #True Or PreviousSeparator2 = #True
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf   
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY
                        TabSize2.b = 3       
                        
                        For Index = 1 To Field::GetSubFieldDynamicArrayDimensionCount(Target)
                          Buffer + Comments::Tabulation(TabSize2) + Field::GetSubFieldName(Target) + "_Max_" + Str(Index) + "D.l = ReadPreferenceLong(" + Chr(34) + Field::GetSubFieldName(Target) + "_Max_" + Str(Index) + "D" + Chr(34) + ", 0)" + Field::#LineFeed
                        Next 
                        
                        Buffer + Comments::Tabulation(TabSize2) + ReDimArray(InstanceAccessPath, 0, 1) + Field::#TwinLinefeed
                        
                        Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize2, 1)
                        Buffer + InstructionReadStructure(TabSize2 + 1, InstanceAccessPath, Target, 7)
                        Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize2, 1) + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_LIST
                        
                        Buffer + Comments::Tabulation(TabSize+1) + Field::GetSubFieldName(Target) + "_Max = ReadPreferenceLong(" + Chr(34) + Field::GetSubFieldName(Target) + "_Max" + Chr(34) + ", 0) - 1" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldName(Target) + "ID = 0 To " + Field::GetSubFieldName(Target) + "_Max" + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize+2) + "AddElement(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
                        Buffer + InstructionReadStructure(TabSize+2, InstanceAccessPath, Target, 8)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_MAP
                        
                        Buffer + Comments::Tabulation(TabSize+1) + Field::GetSubFieldName(Target) + "_Max = ReadPreferenceLong(" + Chr(34) + Field::GetSubFieldName(Target) + "_Max" + Chr(34) + ", 0) - 1" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldName(Target) + "ID = 0 To " + Field::GetSubFieldName(Target) + "_Max" + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize+2) + "AddMapElement(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ", ReadPreferenceString(" + PrefsKey(0, 9) + ", " + Chr(34) + Chr(34) + "))" + Field::#LineFeed
                        Buffer + InstructionReadStructure(TabSize+2, InstanceAccessPath, Target, 8)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_BASIC
                        Buffer + InstructionReadStructure(3, InstanceAccessPath, Target, 10)
                        
                      Case Field::#FIELD_STYLE_BASIC_ARRAY
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldArrayIndexName(Target) + " = 0 To " + Field::GetSubFieldArraySizeLoop(Target) + Field::#LineFeed
                        Buffer + InstructionReadStructure(TabSize+2, InstanceAccessPath, Target, 11)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                    EndSelect 
                    
                    If Field::SubFieldIndex(Target) = Field::SubFieldSize(Target) - 1
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf
                    
                    PreviousSeparator2 = SeparatorNeeded2
                    
                  Until Field::NextSubField(Target) = #Null
                  
                EndIf
                
            EndSelect 
            
            Buffer + Comments::Tabulation(TabSize) + "Next" + Field::#LineFeed
            
          Case Field::#FIELD_STYLE_BASIC
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_MODULE
                Buffer + InstructionReadBasic(TabSize, InstanceAccessPath, Target, 13)
                
              Case Field::#FIELD_TYPE_STRUCTURE
                
                If Field::FirstSubField(Target)
                  
                  Repeat 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
                        SeparatorNeeded3 = #True
                        
                      Case Field::#FIELD_STYLE_BASIC
                        SeparatorNeeded3 = #False
                        
                    EndSelect
                    
                    If Field::SubFieldIndex(Target) = 0 Or SeparatorNeeded3 = #True Or PreviousSeparator3 = #True
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf   
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY
                        TabSize2.b = TabSize      
                        
                        For Index = 1 To Field::GetSubFieldDynamicArrayDimensionCount(Target)
                          Buffer + Comments::Tabulation(TabSize2) + Field::GetSubFieldName(Target) + "_Max_" + Str(Index) + "D.l = ReadPreferenceLong(" + Chr(34) + Field::GetSubFieldName(Target) + "_Max_" + Str(Index) + "D" + Chr(34) + ", 0)" + Field::#LineFeed
                        Next 
                        
                        Buffer + Comments::Tabulation(TabSize2) + ReDimArray(InstanceAccessPath, Target, 1) + Field::#TwinLinefeed
                        
                        Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize2, 1)
                        Buffer + InstructionReadStructure(TabSize2 + 1, InstanceAccessPath, Target, 14)
                        Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize2, 1) + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_LIST
                        
                        Buffer + Comments::Tabulation(TabSize) + Field::GetSubFieldName(Target) + "_Max = ReadPreferenceLong(" + Chr(34) + Field::GetSubFieldName(Target) + "_Max" + Chr(34) + ", 0) - 1" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize) + "For " + Field::GetSubFieldName(Target) + "ID = 0 To " + Field::GetSubFieldName(Target) + "_Max" + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "AddElement(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
                        Buffer + InstructionReadStructure(TabSize+1, InstanceAccessPath, Target, 15)
                        Buffer + Comments::Tabulation(TabSize) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_MAP
                        
                        Buffer + Comments::Tabulation(TabSize) + Field::GetSubFieldName(Target) + "_Max = ReadPreferenceLong(" + Chr(34) + Field::GetSubFieldName(Target) + "_Max" + Chr(34) + ", 0) - 1" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize) + "For " + Field::GetSubFieldName(Target) + "ID = 0 To " + Field::GetSubFieldName(Target) + "_Max" + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "AddMapElement(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ", ReadPreferenceString(" + PrefsKey(0, 16) + ", " + Chr(34) + Chr(34) + "))" + Field::#LineFeed
                        Buffer + InstructionReadStructure(TabSize+1, InstanceAccessPath, Target, 15)
                        Buffer + Comments::Tabulation(TabSize) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_BASIC
                        Buffer + InstructionReadStructure(TabSize, InstanceAccessPath, Target, 17)
                        
                      Case Field::#FIELD_STYLE_BASIC_ARRAY
                        Buffer + Comments::Tabulation(TabSize) + "For " + Field::GetSubFieldArrayIndexName(Target) + " = 0 To " + Field::GetSubFieldArraySizeLoop(Target) + Field::#LineFeed
                        Buffer + InstructionReadStructure(TabSize+1, InstanceAccessPath, Target, 18)
                        Buffer + Comments::Tabulation(TabSize) + "Next" + Field::#LineFeed
                        
                    EndSelect 
                    
                    If Field::SubFieldIndex(Target) = Field::SubFieldSize(Target) - 1
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf
                    
                    PreviousSeparator3 = SeparatorNeeded3
                    
                  Until Field::NextSubField(Target) = #Null
                  
                EndIf
                
            EndSelect 
            
          Case Field::#FIELD_STYLE_BASIC_ARRAY
            
            Buffer + Comments::Tabulation(TabSize) + "For " + Field::GetFieldArrayIndexName(Target) + " = 0 To " + Field::GetFieldArraySizeLoop(Target) + Field::#LineFeed
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_MODULE
                Buffer + InstructionReadBasic(TabSize+1, InstanceAccessPath, Target, 19)
                
              Case Field::#FIELD_TYPE_STRUCTURE
                
                If Field::FirstSubField(Target)
                  
                  Select Field::GetSubFieldStyle(Target)
                      
                    Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded2 = #True
                      
                    Case Field::#FIELD_STYLE_BASIC
                      SeparatorNeeded2 = #False
                      
                  EndSelect
                  
                  If Field::SubFieldIndex(Target) = 0 Or SeparatorNeeded2 = #True Or PreviousSeparator2 = #True
                    Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                  EndIf   
                  
                  Repeat 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY
                        TabSize2.b = TabSize + 1       
                        
                        For Index = 1 To Field::GetSubFieldDynamicArrayDimensionCount(Target)
                          Buffer + Comments::Tabulation(TabSize2) + Field::GetSubFieldName(Target) + "_Max_" + Str(Index) + "D.l = ReadPreferenceLong(" + Chr(34) + Field::GetSubFieldName(Target) + "_Max_" + Str(Index) + "D" + Chr(34) + ", 0)" + Field::#LineFeed
                        Next 
                        
                        Buffer + Comments::Tabulation(TabSize2) + ReDimArray(InstanceAccessPath, Target, 1) + Field::#TwinLinefeed
                        
                        Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize2, 1)
                        Buffer + InstructionReadStructure(TabSize2 + 1, InstanceAccessPath, Target, 20)
                        Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize2, 1) + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_LIST
                        
                        Buffer + Comments::Tabulation(TabSize+1) + Field::GetSubFieldName(Target) + "_Max = ReadPreferenceLong(" + Chr(34) + Field::GetSubFieldName(Target) + "_Max" + Chr(34) + ", 0) - 1" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldName(Target) + "ID = 0 To " + Field::GetSubFieldName(Target) + "_Max" + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize+2) + "AddElement(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + Field::#LineFeed
                        Buffer + InstructionReadStructure(TabSize+2, InstanceAccessPath, Target, 21)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_MAP
                        
                        Buffer + Comments::Tabulation(TabSize+1) + Field::GetSubFieldName(Target) + "_Max = ReadPreferenceLong(" + Chr(34) + Field::GetSubFieldName(Target) + "_Max" + Chr(34) + ", 0) - 1" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldName(Target) + "ID = 0 To " + Field::GetSubFieldName(Target) + "_Max" + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize+2) + "AddMapElement(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ", ReadPreferenceString(" + PrefsKey(Target, 22) + ", " + Chr(34) + Chr(34) + "))" + Field::#LineFeed
                        Buffer + InstructionReadStructure(TabSize+2, InstanceAccessPath, Target, 21)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_BASIC
                        Buffer + InstructionReadStructure(TabSize+1, InstanceAccessPath, Target, 23)
                        
                      Case Field::#FIELD_STYLE_BASIC_ARRAY
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldArrayIndexName(Target) + " = 0 To " + Field::GetSubFieldArraySizeLoop(Target) + Field::#LineFeed
                        Buffer + InstructionReadStructure(TabSize+2, InstanceAccessPath, Target, 24)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                    EndSelect 
                    
                    If Field::SubFieldIndex(Target) = Field::SubFieldSize(Target) - 1
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf
                    
                    PreviousSeparator2 = SeparatorNeeded2
                    
                  Until Field::NextSubField(Target) = #Null
                  
                EndIf
                
            EndSelect 
            
            Buffer + Comments::Tabulation(TabSize) + "Next" + Field::#LineFeed
            
        EndSelect
        
        If Field::GetSecondaryInstance() = #False
          If Field::InstanceIndex(Target) = Field::InstanceSize(Target) - 1
            Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
          EndIf
        EndIf 
        
        PreviousSeparator = SeparatorNeeded
        
      Until Field::NextInstance(Target) = #Null
      
    EndIf
    
    ProcedureReturn Buffer
  EndProcedure
  
  Procedure.s WritePrefsCodeChunk(TabSize.b, InstanceAccessPath.s, Target.b)
    
    If Field::FirstInstance(Target)
      
      Repeat
        
        Select Field::GetFieldStyle(Target)
            
          Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
            SeparatorNeeded = #True
            
          Case Field::#FIELD_STYLE_BASIC
            SeparatorNeeded = #False
            
        EndSelect
        
        If Field::InstanceIndex(Target) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
          Buffer.s + Comments::Tabulation(TabSize) + Field::#LineFeed
        EndIf 
        
        Select Field::GetFieldStyle(Target)
            
          Case Field::#FIELD_STYLE_ARRAY
            
            TabSize.b = 2   
            
            For Index = 1 To Field::GetFieldDynamicArrayDimensionCount(Target)
              Buffer + Comments::Tabulation(TabSize) + "WritePreferenceLong(" + Chr(34) + Field::GetFieldName(Target) + "_Max_" + Str(Index) + "D" + Chr(34) + ", ArraySize(" + InstanceAccessPath + Field::GetFieldAccessEmpty(Target) + ", " + Str(Index) + "))" + Field::#TwinLineFeed
            Next 
            
            Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize, 0)
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_MODULE
                Buffer + InstructionWriteBasic(TabSize+1, InstanceAccessPath, Target, 0)
                
              Case Field::#FIELD_TYPE_STRUCTURE
                
                If Field::FirstSubField(Target)
                  
                  Repeat 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
                        SeparatorNeeded2 = #True
                        
                      Case Field::#FIELD_STYLE_BASIC
                        SeparatorNeeded2 = #False
                        
                    EndSelect
                    
                    If Field::SubFieldIndex(Target) = 0 Or SeparatorNeeded2 = #True Or PreviousSeparator2 = #True
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf   
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY
                        TabSize2.b = TabSize + 1      
                        
                        For Index = 1 To Field::GetSubFieldDynamicArrayDimensionCount(Target)
                          Buffer + Comments::Tabulation(TabSize2) + "WritePreferenceLong(" + Chr(34) + Field::GetSubFieldName(Target) + "_Max_" + Str(Index) + "D" + Chr(34) + ", ArraySize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccessEmpty(Target) + ", " + Str(Index) + "))" + Field::#TwinLineFeed
                        Next 
                        
                        Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize2, 1)
                        Buffer + InstructionWriteStructure(TabSize2 + 1, InstanceAccessPath, Target, 1)
                        Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize2, 1) + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_LIST
                        Buffer + Comments::Tabulation(TabSize+1) + "WritePreferenceLong(" + Chr(34) + Field::GetSubFieldName(Target) + "_Max" + Chr(34) + ", ListSize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) +"))" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + Field::#LineFeed
                        Buffer + InstructionWriteStructure(TabSize+2, InstanceAccessPath, Target, 2)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_MAP
                        Buffer + Comments::Tabulation(TabSize+1) + "WritePreferenceLong(" + Chr(34) + Field::GetSubFieldName(Target) + "_Max" + Chr(34) + ", MapSize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + "))" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + Field::GetSubFieldName(Target) + "ID.l = 0" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize+2) + "WritePreferenceString(" + PrefsKey(Target, 3) + ", MapKey(" + InstanceAccessPath + Field::GetFieldAccess(Target)  + "\" + Field::GetSubFieldAccess(Target) + "))" + Field::#LineFeed
                        Buffer + InstructionWriteStructure(TabSize+2, InstanceAccessPath, Target, 2)
                        Buffer + Comments::Tabulation(TabSize+2) + Field::GetSubFieldName(Target) + "ID + 1" + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_BASIC
                        Buffer + InstructionWriteStructure(TabSize+1, InstanceAccessPath, Target, 4)
                        
                      Case Field::#FIELD_STYLE_BASIC_ARRAY
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldArrayIndexName(Target) + " = 0 To " + Field::GetSubFieldArraySizeLoop(Target) + Field::#LineFeed
                        Buffer + InstructionWriteStructure(TabSize+2, InstanceAccessPath, Target, 5)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                    EndSelect 
                    
                    If Field::SubFieldIndex(Target) = Field::SubFieldSize(Target) - 1
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf
                    
                    PreviousSeparator2 = SeparatorNeeded2
                    
                  Until Field::NextSubField(Target) = #Null
                  
                EndIf
                
            EndSelect 
            
            Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize, 0) + Field::#LineFeed
            
          Case Field::#FIELD_STYLE_LIST
            
            Buffer + Comments::Tabulation(TabSize) + "WritePreferenceLong(" + Chr(34) + Field::GetFieldName(Target) + "_Max" + Chr(34) + ", ListSize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "))" + Field::#TwinLineFeed
            Buffer + Comments::Tabulation(TabSize) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + Field::#LineFeed
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_MODULE
                Buffer + InstructionWriteBasic(TabSize+1, InstanceAccessPath, Target, 25)
                
              Case Field::#FIELD_TYPE_STRUCTURE
                
                If Field::FirstSubField(Target)
                  
                  Repeat 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
                        SeparatorNeeded2 = #True
                        
                      Case Field::#FIELD_STYLE_BASIC
                        SeparatorNeeded2 = #False
                        
                    EndSelect
                    
                    If Field::SubFieldIndex(Target) = 0 Or SeparatorNeeded2 = #True Or PreviousSeparator2 = #True
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf   
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY
                        TabSize2.b = TabSize+1      
                        
                        For Index = 1 To Field::GetSubFieldDynamicArrayDimensionCount(Target)
                          Buffer + Comments::Tabulation(TabSize2) + "WritePreferenceLong(" + Chr(34) + Field::GetSubFieldName(Target) + "_Max_" + Str(Index) + "D" + Chr(34) + ", ArraySize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccessEmpty(Target) + ", " + Str(Index) + "))" + Field::#TwinLineFeed
                        Next 
                        
                        Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize2, 1)
                        Buffer + InstructionWriteStructure(TabSize2 + 1, InstanceAccessPath, Target, 26)
                        Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize2, 1) + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_LIST
                        Buffer + Comments::Tabulation(TabSize+1) + "WritePreferenceLong(" + Chr(34) + Field::GetSubFieldName(Target) + "_Max" + Chr(34) + ", ListSize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) +"))" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target)  + "\" + Field::GetSubFieldAccess(Target) + Field::#LineFeed
                        Buffer + InstructionWriteStructure(TabSize+2, InstanceAccessPath, Target, 27)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_MAP
                        Buffer + Comments::Tabulation(TabSize+1) + "WritePreferenceLong(" + Chr(34) + Field::GetSubFieldName(Target) + "_Max" + Chr(34) + ", MapSize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) +"))" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + Field::GetSubFieldName(Target) + "ID.l = 0" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target)  + "\" + Field::GetSubFieldAccess(Target) + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize+2) + "WritePreferenceString(" + PrefsKey(Target, 28) + ", MapKey(" + InstanceAccessPath + Field::GetFieldAccess(Target)  + "\" + Field::GetSubFieldAccess(Target) + "))" + Field::#LineFeed
                        Buffer + InstructionWriteStructure(TabSize+2, InstanceAccessPath, Target, 31)
                        Buffer + Comments::Tabulation(TabSize+2) + Field::GetSubFieldName(Target) + "ID + 1" + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_BASIC
                        Buffer + InstructionWriteStructure(TabSize+1, InstanceAccessPath, Target, 29)
                        
                      Case Field::#FIELD_STYLE_BASIC_ARRAY
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldArrayIndexName(Target) + " = 0 To " + Field::GetSubFieldArraySizeLoop(Target) + Field::#LineFeed
                        Buffer + InstructionWriteStructure(TabSize+2, InstanceAccessPath, Target, 30)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                    EndSelect 
                    
                    If Field::SubFieldIndex(Target) = Field::SubFieldSize(Target) - 1
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf
                    
                    PreviousSeparator2 = SeparatorNeeded2
                    
                  Until Field::NextSubField(Target) = #Null
                  
                EndIf
                
            EndSelect 
            
            Buffer + Comments::Tabulation(TabSize) + "Next" + Field::#LineFeed
            
          Case Field::#FIELD_STYLE_MAP
            Buffer + Comments::Tabulation(TabSize) + "WritePreferenceLong(" + Chr(34) + Field::GetFieldName(Target) + "_Max" + Chr(34) + ", MapSize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "))" + Field::#LineFeed
            Buffer + Comments::Tabulation(TabSize) + Field::GetFieldName(Target) + "ID = 0" + Field::#TwinLineFeed
            Buffer + Comments::Tabulation(TabSize) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + Field::#LineFeed
            Buffer + Comments::Tabulation(TabSize + 1) + "WritePreferenceString(" + PrefsKey(Target, 12) + ", MapKey(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "))" + Field::#LineFeed
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_MODULE
                Buffer + InstructionWriteBasic(TabSize + 1, InstanceAccessPath, Target, 6)
                
              Case Field::#FIELD_TYPE_STRUCTURE
                
                If Field::FirstSubField(Target)
                  
                  Repeat 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
                        SeparatorNeeded2 = #True
                        
                      Case Field::#FIELD_STYLE_BASIC
                        SeparatorNeeded2 = #False
                        
                    EndSelect
                    
                    If Field::SubFieldIndex(Target) = 0 Or SeparatorNeeded2 = #True Or PreviousSeparator2 = #True
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf   
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY
                        TabSize2.b = 3       
                        
                        For Index = 1 To Field::GetSubFieldDynamicArrayDimensionCount(Target)
                          Buffer + Comments::Tabulation(TabSize2) + "WritePreferenceLong(" + Chr(34) + Field::GetSubFieldName(Target) + "_Max_" + Str(Index) + "D" + Chr(34) + ", ArraySize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccessEmpty(Target) + ", " + Str(Index) + "))" + Field::#TwinLineFeed
                        Next 
                        
                        Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize2, 1)
                        Buffer + InstructionWriteStructure(TabSize2 + 1, InstanceAccessPath, Target, 33)
                        Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize2, 1) + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_LIST
                        Buffer + Comments::Tabulation(TabSize+1) + "WritePreferenceLong(" + Chr(34) + Field::GetSubFieldName(Target) + "_Max" + Chr(34) + ", ListSize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + "))" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + Field::#LineFeed
                        Buffer + InstructionWriteStructure(TabSize+2, InstanceAccessPath, Target, 34)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_MAP
                        Buffer + Comments::Tabulation(TabSize + 1) + "WritePreferenceLong(" + Chr(34) + Field::GetSubFieldName(Target) + "_Max" + Chr(34) + ", MapSize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + "))" + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize + 1) + Field::GetSubFieldName(Target) + "ID = 0" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize + 1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize + 2) + "WritePreferenceString(" + PrefsKey(Target, 35) + ", MapKey(" + InstanceAccessPath + Field::GetFieldAccess(Target)  + "\" + Field::GetSubFieldAccess(Target) + "))" + Field::#LineFeed
                        Buffer + InstructionWriteStructure(TabSize + 2, InstanceAccessPath, Target, 36)
                        Buffer + Comments::Tabulation(TabSize + 2) + Field::GetSubFieldName(Target) + "ID + 1" + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize + 1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_BASIC
                        Buffer + InstructionWriteStructure(3, InstanceAccessPath, Target, 10)
                        
                      Case Field::#FIELD_STYLE_BASIC_ARRAY
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldArrayIndexName(Target) + " = 0 To " + Field::GetSubFieldArraySizeLoop(Target) + Field::#LineFeed
                        Buffer + InstructionWriteStructure(TabSize+2, InstanceAccessPath, Target, 11)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                    EndSelect 
                    
                    If Field::SubFieldIndex(Target) = Field::SubFieldSize(Target) - 1
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf
                    
                    PreviousSeparator2 = SeparatorNeeded2
                    
                  Until Field::NextSubField(Target) = #Null
                  
                EndIf
                
            EndSelect 
            
            Buffer + Comments::Tabulation(TabSize+1) + Field::GetFieldName(Target) + "ID + 1" + Field::#TwinLineFeed
            Buffer + Comments::Tabulation(TabSize) + "Next" + Field::#LineFeed
            
          Case Field::#FIELD_STYLE_BASIC
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_MODULE
                Buffer + InstructionWriteBasic(TabSize, InstanceAccessPath, Target, 13)
                
              Case Field::#FIELD_TYPE_STRUCTURE
                
                If Field::FirstSubField(Target)
                  
                  Repeat 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
                        SeparatorNeeded2 = #True
                        
                      Case Field::#FIELD_STYLE_BASIC
                        SeparatorNeeded2 = #False
                        
                    EndSelect
                    
                    If Field::SubFieldIndex(Target) = 0 Or SeparatorNeeded2 = #True Or PreviousSeparator2 = #True
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf   
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY
                        TabSize2.b = TabSize      
                        
                        For Index = 1 To Field::GetSubFieldDynamicArrayDimensionCount(Target)
                          Buffer + Comments::Tabulation(TabSize2) + "WritePreferenceLong(" + Chr(34) + Field::GetSubFieldName(Target) + "_Max_" + Str(Index) + "D" + Chr(34) + ", ArraySize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccessEmpty(Target) + ", " + Str(Index) + "))" + Field::#TwinLineFeed
                        Next 
                        
                        Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize2, 1)
                        Buffer + InstructionWriteStructure(TabSize2 + 1, InstanceAccessPath, Target, 14)
                        Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize2, 1) + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_LIST
                        Buffer + Comments::Tabulation(TabSize) + "WritePreferenceLong(" + Chr(34) + Field::GetSubFieldName(Target) + "_Max" + Chr(34) + ", ListSize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + "))" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + Field::#LineFeed
                        Buffer + InstructionWriteStructure(TabSize+1, InstanceAccessPath, Target, 37)
                        Buffer + Comments::Tabulation(TabSize) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_MAP
                        Buffer + Comments::Tabulation(TabSize) + "WritePreferenceLong(" + Chr(34) + Field::GetSubFieldName(Target) + "_Max" + Chr(34) + ", MapSize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + "))" + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize) + Field::GetSubFieldName(Target) + "ID = 0" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize + 1) + "WritePreferenceString(" + PrefsKey(Target, 38) + ", MapKey(" + InstanceAccessPath + Field::GetFieldAccess(Target)  + "\" + Field::GetSubFieldAccess(Target) + "))" + Field::#LineFeed
                        Buffer + InstructionWriteStructure(TabSize + 1, InstanceAccessPath, Target, 39)
                        Buffer + Comments::Tabulation(TabSize + 1) + Field::GetSubFieldName(Target) + "ID + 1" + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_BASIC
                        Buffer + InstructionWriteStructure(TabSize, InstanceAccessPath, Target, 17)
                        
                      Case Field::#FIELD_STYLE_BASIC_ARRAY
                        Buffer + Comments::Tabulation(TabSize) + "For " + Field::GetSubFieldArrayIndexName(Target) + " = 0 To " + Field::GetSubFieldArraySizeLoop(Target) + Field::#LineFeed
                        Buffer + InstructionWriteStructure(TabSize+1, InstanceAccessPath, Target, 18)
                        Buffer + Comments::Tabulation(TabSize) + "Next" + Field::#LineFeed
                        
                    EndSelect 
                    
                    If Field::SubFieldIndex(Target) = Field::SubFieldSize(Target) - 1
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf
                    
                    PreviousSeparator2 = SeparatorNeeded2
                    
                  Until Field::NextSubField(Target) = #Null
                  
                EndIf
                
            EndSelect 
            
          Case Field::#FIELD_STYLE_BASIC_ARRAY
            
            Buffer + Comments::Tabulation(TabSize) + "For " + Field::GetFieldArrayIndexName(Target) + " = 0 To " + Field::GetFieldArraySizeLoop(Target) + Field::#LineFeed
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_MODULE
                Buffer + InstructionWriteBasic(TabSize+1, InstanceAccessPath, Target, 19)
                
              Case Field::#FIELD_TYPE_STRUCTURE
                
                If Field::FirstSubField(Target)
                  
                  Select Field::GetSubFieldStyle(Target)
                      
                    Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded3 = #True
                      
                    Case Field::#FIELD_STYLE_BASIC
                      SeparatorNeeded3 = #False
                      
                  EndSelect
                  
                  If Field::SubFieldIndex(Target) = 0 Or SeparatorNeeded3 = #True Or PreviousSeparator3 = #True
                    Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                  EndIf   
                  
                  Repeat 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY
                        TabSize2.b = TabSize + 1       
                        
                        For Index = 1 To Field::GetSubFieldDynamicArrayDimensionCount(Target)
                          Buffer + Comments::Tabulation(TabSize2) + "WritePreferenceLong(" + Chr(34) + Field::GetSubFieldName(Target) + "_Max_" + Str(Index) + "D" + Chr(34) + ", ArraySize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccessEmpty(Target) + ", " + Str(Index) + "))" + Field::#TwinLineFeed
                        Next 
                        
                        Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize2, 1)
                        Buffer + InstructionWriteStructure(TabSize2 + 1, InstanceAccessPath, Target, 20)
                        Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize2, 1) + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_LIST
                        Buffer + Comments::Tabulation(TabSize+1) + "WritePreferenceLong(" + Chr(34) + Field::GetSubFieldName(Target) + "_Max" + Chr(34) + ", ListSize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + "))" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize+1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + Field::#LineFeed
                        Buffer + InstructionWriteStructure(TabSize+2, InstanceAccessPath, Target, 34)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_MAP
                        Buffer + Comments::Tabulation(TabSize + 1) + "WritePreferenceLong(" + Chr(34) + Field::GetSubFieldName(Target) + "_Max" + Chr(34) + ", MapSize(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + "))" + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize + 1) + Field::GetSubFieldName(Target) + "ID = 0" + Field::#TwinLineFeed
                        Buffer + Comments::Tabulation(TabSize + 1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize + 2) + "WritePreferenceString(" + PrefsKey(Target, 35) + ", MapKey(" + InstanceAccessPath + Field::GetFieldAccess(Target)  + "\" + Field::GetSubFieldAccess(Target) + "))" + Field::#LineFeed
                        Buffer + InstructionWriteStructure(TabSize + 2, InstanceAccessPath, Target, 36)
                        Buffer + Comments::Tabulation(TabSize + 2) + Field::GetSubFieldName(Target) + "ID + 1" + Field::#LineFeed
                        Buffer + Comments::Tabulation(TabSize + 1) + "Next" + Field::#LineFeed
                        
                      Case Field::#FIELD_STYLE_BASIC
                        Buffer + InstructionWriteStructure(TabSize+1, InstanceAccessPath, Target, 23)
                        
                      Case Field::#FIELD_STYLE_BASIC_ARRAY
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldArrayIndexName(Target) + " = 0 To " + Field::GetSubFieldArraySizeLoop(Target) + Field::#LineFeed
                        Buffer + InstructionWriteStructure(TabSize+2, InstanceAccessPath, Target, 24)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + Field::#LineFeed
                        
                    EndSelect 
                    
                    If Field::SubFieldIndex(Target) = Field::SubFieldSize(Target) - 1
                      Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
                    EndIf
                    
                    PreviousSeparator3 = SeparatorNeeded3
                    
                  Until Field::NextSubField(Target) = #Null
                  
                EndIf
                
            EndSelect 
            
            Buffer + Comments::Tabulation(TabSize) + "Next" + Field::#LineFeed
            
        EndSelect
        
        If Field::GetSecondaryInstance() = #False
          If Field::InstanceIndex(Target) = Field::InstanceSize(Target) - 1
            Buffer + Comments::Tabulation(TabSize) + Field::#LineFeed
          EndIf
        EndIf 
        
        PreviousSeparator = SeparatorNeeded
        
      Until Field::NextInstance(Target) = #Null
      
    EndIf
    
    ProcedureReturn Buffer
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition ReadGroup <<<<<
  
  Procedure.s DefineReadGroup()
   
    Buffer.s = Comments::Tabulation(1) + "Procedure ReadPrefs(P_GroupName.s" + Field::GetExtraParam() + ")" + Field::#TwinLineFeed
    
    Select Field::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE, Field::#INSTANCE_STYLE_OFF_MODULE
        Buffer + Comments::Tabulation(2) + "PreferenceGroup(P_GroupName)" + Field::#LineFeed
        Buffer + ReadPrefsCodeChunk(2, Field::GetInstanceAccessPath(), 0)
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME
        
        TempBuffer.s = ReadPrefsCodeChunk(4, Field::GetInstanceAccessPath(), 0)
        
        Buffer + Comments::Tabulation(2) + Field::#LineFeed
        
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID
            Buffer + Comments::Tabulation(2) + "If P_InstanceID = -1" + Field::#TwinLineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(2) + "If P_Index = -1" + Field::#TwinLineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
            Buffer + Comments::Tabulation(2) + "If P_Name = "  + Field::#EmptyString + Field::#TwinLineFeed
            
        EndSelect
        
        Buffer + Comments::Tabulation(3) + "Instances_Max.l = ReadPreferenceLong(P_GroupName + " + Chr(34) + "_Instances_Max" + Chr(34) + ", 0) - 1"+ Field::#TwinLineFeed
        Buffer + Comments::Tabulation(3) + "For Index = 0 to Instances_Max" + Field::#TwinLineFeed
        Buffer + Comments::Tabulation(4) + "PreferenceGroup(P_GroupName + " + Chr(34) + "_InstanceID_" + Chr(34) + " + Str(Index))" + Field::#LineFeed
        
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(4) + "AddElement(Instances())" + Field::#LineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
            Buffer + Comments::Tabulation(4) + "AddMapElement(Instances())" + Field::#LineFeed
            
        EndSelect
        
        Buffer + TempBuffer
        Buffer + Comments::Tabulation(3) + "Next" + Field::#TwinLineFeed
        
        Buffer + Comments::Tabulation(2) + "Else" + Field::#TwinLineFeed
        
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID
            Buffer + Comments::Tabulation(3) + "If SearchInstances(" + StringField(Field::GetInstanceParam(), 1, ".") + ") <> -1" + Field::#LineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(3) + "If SelectElement(Instances(), " + StringField(Field::GetInstanceParam(), 1, ".") + ")" + Field::#LineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
            Buffer + Comments::Tabulation(3) + "If FindMapElement(Instances(), " + StringField(Field::GetInstanceParam(), 1, ".") + ")" + Field::#LineFeed  
            
        EndSelect
        
        Buffer + TempBuffer
        Buffer + Comments::Tabulation(3) + "EndIf" + Field::#TwinLineFeed
        
        If Field::GetSecondaryInstance() = #False
          Buffer + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed
        Else
          Buffer + Comments::Tabulation(2) + "EndIf" + Field::#LineFeed
        EndIf
        
    EndSelect
    
    If Field::GetSecondaryInstance() = #True
      Buffer + ReadPrefsCodeChunk(2, "Secondary\", 1)
      Buffer + Comments::Tabulation(2) + Field::#LineFeed
    EndIf
    
    Buffer + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
    
    ProcedureReturn Buffer
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition WriteGroup <<<<<
  
  Procedure.s DefineWriteGroup()
    
    Buffer.s = Comments::Tabulation(1) + "Procedure WritePrefs(P_GroupName.s" + Field::GetExtraParam() + ")" + Field::#TwinLineFeed
    
    Select Field::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE, Field::#INSTANCE_STYLE_OFF_MODULE
        Buffer + Comments::Tabulation(2) + "PreferenceGroup(P_GroupName)" + Field::#LineFeed
        Buffer + WritePrefsCodeChunk(2, Field::GetInstanceAccessPath(), 0)
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME
        
        TempBuffer.s = WritePrefsCodeChunk(4, Field::GetInstanceAccessPath(), 0)
        
        Buffer + Comments::Tabulation(2) + Field::#LineFeed
        
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID
            Buffer + Comments::Tabulation(2) + "If P_InstanceID = -1" + Field::#TwinLineFeed
            Buffer + Comments::Tabulation(3) + "WritePreferenceLong(P_GroupName + " + Chr(34) + "_Instances_Max" + Chr(34) + ", ListSize(Instances()))"+ Field::#TwinLineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(2) + "If P_Index = -1" + Field::#TwinLineFeed
            Buffer + Comments::Tabulation(3) + "WritePreferenceLong(P_GroupName + " + Chr(34) + "_Instances_Max" + Chr(34) + ", ListSize(Instances()))"+ Field::#TwinLineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
            Buffer + Comments::Tabulation(2) + "If P_Name = "  + Field::#EmptyString + Field::#TwinLineFeed
            Buffer + Comments::Tabulation(3) + "WritePreferenceLong(P_GroupName + " + Chr(34) + "_Instances_Max" + Chr(34) + ", MapSize(Instances()))"+ Field::#TwinLineFeed
            
        EndSelect
        
        Buffer + Comments::Tabulation(3) + "ForEach Instances()" + Field::#TwinLineFeed
        Buffer + Comments::Tabulation(4) + "PreferenceGroup(P_GroupName + " + Chr(34) + "_InstanceID_" + Chr(34) + " + Str(Index))" + Field::#LineFeed
        
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(4) + "AddElement(Instances())" + Field::#LineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
            Buffer + Comments::Tabulation(4) + "AddMapElement(Instances())" + Field::#LineFeed
            
        EndSelect
        
        Buffer + TempBuffer
        Buffer + Comments::Tabulation(3) + "Next" + Field::#TwinLineFeed
        
        Buffer + Comments::Tabulation(2) + "Else" + Field::#TwinLineFeed
        
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID
            Buffer + Comments::Tabulation(3) + "If SearchInstances(" + StringField(Field::GetInstanceParam(), 1, ".") + ") <> -1" + Field::#LineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(3) + "If SelectElement(Instances(), " + StringField(Field::GetInstanceParam(), 1, ".") + ")" + Field::#LineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
            Buffer + Comments::Tabulation(3) + "If FindMapElement(Instances(), " + StringField(Field::GetInstanceParam(), 1, ".") + ")" + Field::#LineFeed  
            
        EndSelect
        
        Buffer + TempBuffer
        Buffer + Comments::Tabulation(3) + "EndIf" + Field::#TwinLineFeed
        
        If Field::GetSecondaryInstance() = #False
          Buffer + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed
        Else
          Buffer + Comments::Tabulation(2) + "EndIf" + Field::#LineFeed
        EndIf
        
    EndSelect
    
    If Field::GetSecondaryInstance() = #True
      Buffer + WritePrefsCodeChunk(2, "Secondary\", 1)
      Buffer + Comments::Tabulation(2) + Field::#LineFeed
    EndIf
    
    Buffer + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
    
    ProcedureReturn Buffer
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition CreateFile <<<<<
  
  Procedure.s DefineCreateFile()
    
    InstanceAccessPath.s = Field::GetInstanceAccessPath() 
      
    Buffer.s = Comments::Tabulation(1) + "Procedure CreatePrefs(FileName" + Field::GetExtraParam() + ")" + Field::#TwinLineFeed
    Buffer + Comments::Tabulation(2) + "If CreatePreferences(FileName)" + Field::#LineFeed
    
    Select Field::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE, Field::#INSTANCE_STYLE_OFF_MODULE
        Buffer + WritePrefsCodeChunk(3, Field::GetInstanceAccessPath(), 0)
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME
        
        TempBuffer.s = WritePrefsCodeChunk(5, Field::GetInstanceAccessPath(), 0)
        
        Buffer + Comments::Tabulation(3) + Field::#LineFeed
        
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID
            Buffer + Comments::Tabulation(3) + "If P_InstanceID = -1" + Field::#TwinLineFeed
            Buffer + Comments::Tabulation(4) + "WritePreferenceLong(" + Chr(34) + "Instances_Max" + Chr(34) + ", ListSize(Instances()))"+ Field::#TwinLineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(3) + "If P_Index = -1" + Field::#TwinLineFeed
            Buffer + Comments::Tabulation(4) + "WritePreferenceLong(" + Chr(34) + "Instances_Max" + Chr(34) + ", ListSize(Instances()))"+ Field::#TwinLineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
            Buffer + Comments::Tabulation(3) + "If P_Name = "  + Field::#EmptyString + Field::#TwinLineFeed
            Buffer + Comments::Tabulation(4) + "WritePreferenceLong(" + Chr(34) + "Instances_Max" + Chr(34) + ", MapSize(Instances()))"+ Field::#TwinLineFeed     
            
        EndSelect
       
        Buffer + Comments::Tabulation(4) + "ForEach Instances()" + Field::#TwinLineFeed
        Buffer + Comments::Tabulation(5) + "PreferenceGroup(" + Chr(34) + "InstanceID_" + Chr(34) + " + Str(ListIndex(Instances())))" + Field::#LineFeed
        Buffer + TempBuffer + Field::#LineFeed
        Buffer + Comments::Tabulation(3) + "Next" + Field::#TwinLineFeed
        Buffer + Comments::Tabulation(3) + "Else" + Field::#TwinLineFeed
        
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID
            Buffer + Comments::Tabulation(4) + "If SearchInstances(" + StringField(Field::GetInstanceParam(), 1, ".") + ") <> -1" + Field::#LineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(4) + "If SelectElement(Instances(), " + StringField(Field::GetInstanceParam(), 1, ".") + ")" + Field::#LineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
            Buffer + Comments::Tabulation(4) + "If FindMapElement(Instances(), " + StringField(Field::GetInstanceParam(), 1, ".") + ")" + Field::#LineFeed  
            
        EndSelect
        
        Buffer + TempBuffer + Field::#LineFeed
        Buffer + Comments::Tabulation(4) + "EndIf" + Field::#TwinLineFeed
        
        If Field::GetSecondaryInstance() = #False
          Buffer + Comments::Tabulation(3) + "EndIf" + Field::#TwinLineFeed
        Else
          Buffer + Comments::Tabulation(3) + "EndIf" + Field::#LineFeed
        EndIf
        
    EndSelect
    
    If Field::GetSecondaryInstance() = #True
      Buffer + WritePrefsCodeChunk(3, "Secondary\", 1)
      Buffer + Comments::Tabulation(3) + Field::#LineFeed
    EndIf
    
    Buffer + Comments::Tabulation(3) + "ClosePreferences()" + Field::#TwinLineFeed
    Buffer + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed
    Buffer + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
    
    ProcedureReturn Buffer
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition OpenFile <<<<<
  
  Procedure.s DefineOpenFile()
    
    InstanceAccessPath.s = Field::GetInstanceAccessPath() 
    
    Buffer.s = Comments::Tabulation(1) + "Procedure OpenPrefs(FileName" + Field::GetExtraParam() + ")" + Field::#TwinLineFeed
    Buffer + Comments::Tabulation(2) + "If OpenPreferences(FileName)" + Field::#LineFeed
    
    Select Field::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE, Field::#INSTANCE_STYLE_OFF_MODULE
        Buffer + ReadPrefsCodeChunk(3, Field::GetInstanceAccessPath(), 0)
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME
        
        TempBuffer.s = ReadPrefsCodeChunk(5, Field::GetInstanceAccessPath(), 0) 
        Buffer + Comments::Tabulation(3) + Field::#LineFeed
        
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID
            Buffer + Comments::Tabulation(3) + "If P_InstanceID = -1" + Field::#TwinLineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(3) + "If P_Index = -1" + Field::#TwinLineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
            Buffer + Comments::Tabulation(3) + "If P_Name = "  + Field::#EmptyString + Field::#TwinLineFeed
            
        EndSelect
        
        Buffer + Comments::Tabulation(4) + "Instances_Max.l = ReadPreferenceLong(P_GroupName + " + Chr(34) + "_Instances_Max" + Chr(34) + ", 0) - 1"+ Field::#TwinLineFeed
        Buffer + Comments::Tabulation(4) + "For Index = 0 to Instances_Max" + Field::#TwinLineFeed
        Buffer + Comments::Tabulation(5) + "PreferenceGroup(P_GroupName + " + Chr(34) + "_InstanceID_" + Chr(34) + " + Str(Index))" + Field::#LineFeed
        
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(5) + "AddElement(Instances())" + Field::#LineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
            Buffer + Comments::Tabulation(5) + "AddMapElement(Instances())" + Field::#LineFeed
            
        EndSelect
        
        Buffer + TempBuffer + Field::#LineFeed
        Buffer + Comments::Tabulation(4) + "Next" + Field::#TwinLineFeed
        
        Buffer + Comments::Tabulation(3) + "Else" + Field::#TwinLineFeed
        
        Select Field::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID
            Buffer + Comments::Tabulation(4) + "If SearchInstances(" + StringField(Field::GetInstanceParam(), 1, ".") + ") <> -1" + Field::#LineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_INDEX
            Buffer + Comments::Tabulation(4) + "If SelectElement(Instances(), " + StringField(Field::GetInstanceParam(), 1, ".") + ")" + Field::#LineFeed
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
            Buffer + Comments::Tabulation(4) + "If FindMapElement(Instances(), " + StringField(Field::GetInstanceParam(), 1, ".") + ")" + Field::#LineFeed  
            
        EndSelect
        
        Buffer + TempBuffer + Field::#LineFeed
        Buffer + Comments::Tabulation(4) + "EndIf" + Field::#TwinLineFeed
        
        If Field::GetSecondaryInstance() = #False
          Buffer + Comments::Tabulation(3) + "EndIf" + Field::#TwinLineFeed
        Else
          Buffer + Comments::Tabulation(3) + "EndIf" + Field::#LineFeed
        EndIf
        
    EndSelect
    
    If Field::GetSecondaryInstance() = #True
      Buffer + ReadPrefsCodeChunk(3, "Secondary\", 1)
      Buffer + Comments::Tabulation(3) + Field::#LineFeed
    EndIf
    
    Buffer + Comments::Tabulation(3) + "ClosePreferences()" + Field::#TwinLineFeed
    Buffer + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed
    Buffer + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
    
    ProcedureReturn Buffer
  EndProcedure
  
EndModule

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Code gnr en : 00.001 secondes (108000.00 lignes/seconde) <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.70 beta 1 (Linux - x64)
; Folding = -PAQ-
; EnableXP
; CompileSourceDirectory