; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; CODE GNR AUTOMATIQUEMENT, NE PAS MODIFIER 
; MOINS D'AVOIR UNE RAISON TRS TRS VALABLE !!!
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Code gnr par : Dev-Module - V0.9.2
; Nom du projet : Dev-Module
; Nom du fichier : DevModule - MathsMethods.pb
; Version du fichier : 1.0.0
; Programmation : OK
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 22-07-2018
; Mise  jour : 30-07-2018
; Cod pour PureBasic : V5.70 beta 1
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule MathsMethods

  Declare.b GetEqual()
  Declare.b GetPlus()
  Declare.b GetMinus()
  Declare.b GetProduct()
  Declare.b GetDivide()
  Declare.b GetProductByScalar()
  Declare.b GetDivideByScalar()
  Declare.b GetCopy()
  Declare.b GetCompare()
  Declare.b GetSwapping()
  Declare SetEqual(P_Equal.b)
  Declare SetPlus(P_Plus.b)
  Declare SetMinus(P_Minus.b)
  Declare SetProduct(P_Product.b)
  Declare SetDivide(P_Divide.b)
  Declare SetProductByScalar(P_ProductByScalar.b)
  Declare SetDivideByScalar(P_DivideByScalar.b)
  Declare SetCopy(P_Copy.b)
  Declare SetCompare(P_Compare.b)
  Declare SetSwapping(P_Swapping.b)
  Declare Reset()
  Declare ReadPrefs(P_GroupName.s)
  Declare WritePrefs(P_GroupName.s)
  
  Declare.s DeclareEqual()
  Declare.s DeclarePlus()
  Declare.s DeclareMinus()
  Declare.s DeclareProduct()
  Declare.s DeclareDivide()
  Declare.s DeclareProductByScalar()
  Declare.s DeclareDivideByScalar()
  Declare.s DeclareCopy()
  Declare.s DeclareCompare()
  Declare.s DeclareSwapping()
  Declare.s DeclareIdentity()
  Declare.s DeclareTranspose()
  Declare.s DeclareSelfTranspose()
  Declare.s DeclareDeterminant()
  Declare.s DeclareInverse()
  Declare.s DeclareRandomize()
  Declare.s DeclareFormatLine()
  Declare.s DeclareUnformatLine()
  
  Declare.s DefineEqual()
  Declare.s DefinePlus()
  Declare.s DefineMinus()
  Declare.s DefineProduct()
  Declare.s DefineDivide()
  Declare.s DefineProductByScalar()
  Declare.s DefineDivideByScalar()
  Declare.s DefineCopy()
  Declare.s DefineCompare()
  Declare.s DefineSwapping()
  Declare.s DefineIdentity()
  Declare.s DefineTranspose()
  Declare.s DefineSelfTranspose()
  Declare.s DefineDeterminant()
  Declare.s DefineInverse()
  Declare.s DefineRandomize()
  Declare.s DefineFormatLine()
  Declare.s DefineUnformatLine()
  
EndDeclareModule

Module MathsMethods

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Dclaration de la Structure <<<<<

  Structure Instance

    Equal.b
    Plus.b
    Minus.b
    Product.b
    Divide.b
    ProductByScalar.b
    DivideByScalar.b
    Copy.b
    Compare.b
    Swapping.b

  EndStructure

  Global Instance.Instance

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Les observateurs <<<<<

  Procedure.b GetEqual()

    ProcedureReturn Instance\Equal
  EndProcedure

  Procedure.b GetPlus()

    ProcedureReturn Instance\Plus
  EndProcedure

  Procedure.b GetMinus()

    ProcedureReturn Instance\Minus
  EndProcedure

  Procedure.b GetProduct()

    ProcedureReturn Instance\Product
  EndProcedure

  Procedure.b GetDivide()

    ProcedureReturn Instance\Divide
  EndProcedure

  Procedure.b GetProductByScalar()

    ProcedureReturn Instance\ProductByScalar
  EndProcedure

  Procedure.b GetDivideByScalar()

    ProcedureReturn Instance\DivideByScalar
  EndProcedure

  Procedure.b GetCopy()

    ProcedureReturn Instance\Copy
  EndProcedure

  Procedure.b GetCompare()

    ProcedureReturn Instance\Compare
  EndProcedure

  Procedure.b GetSwapping()

    ProcedureReturn Instance\Swapping
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Les mutateurs <<<<<

  Procedure SetEqual(P_Equal.b)

    Instance\Equal = P_Equal

  EndProcedure

  Procedure SetPlus(P_Plus.b)

    Instance\Plus = P_Plus

  EndProcedure

  Procedure SetMinus(P_Minus.b)

    Instance\Minus = P_Minus

  EndProcedure

  Procedure SetProduct(P_Product.b)

    Instance\Product = P_Product

  EndProcedure

  Procedure SetDivide(P_Divide.b)

    Instance\Divide = P_Divide

  EndProcedure

  Procedure SetProductByScalar(P_ProductByScalar.b)

    Instance\ProductByScalar = P_ProductByScalar

  EndProcedure

  Procedure SetDivideByScalar(P_DivideByScalar.b)

    Instance\DivideByScalar = P_DivideByScalar

  EndProcedure

  Procedure SetCopy(P_Copy.b)

    Instance\Copy = P_Copy

  EndProcedure

  Procedure SetCompare(P_Compare.b)

    Instance\Compare = P_Compare

  EndProcedure

  Procedure SetSwapping(P_Swapping.b)

    Instance\Swapping = P_Swapping

  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Reset <<<<<

  Procedure Reset()
    
    Instance\Equal = 0
    Instance\Plus = 0
    Instance\Minus = 0
    Instance\Product = 0
    Instance\Divide = 0
    Instance\ProductByScalar = 0
    Instance\DivideByScalar = 0
    Instance\Copy = 0
    Instance\Compare = 0
    Instance\Swapping = 0
    
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Lecture d'un groupe Prfrences <<<<<

  Procedure ReadPrefs(P_GroupName.s)

    PreferenceGroup(P_GroupName)
    
    Instance\Equal = ReadPreferenceLong("Equal", Instance\Equal)
    Instance\Plus = ReadPreferenceLong("Plus", Instance\Plus)
    Instance\Minus = ReadPreferenceLong("Minus", Instance\Minus)
    Instance\Product = ReadPreferenceLong("Product", Instance\Product)
    Instance\Divide = ReadPreferenceLong("Divide", Instance\Divide)
    Instance\ProductByScalar = ReadPreferenceLong("ProductByScalar", Instance\ProductByScalar)
    Instance\DivideByScalar = ReadPreferenceLong("DivideByScalar", Instance\DivideByScalar)
    Instance\Copy = ReadPreferenceLong("Copy", Instance\Copy)
    Instance\Compare = ReadPreferenceLong("Compare", Instance\Compare)
    Instance\Swapping = ReadPreferenceLong("Swapping", Instance\Swapping)
    
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< criture d'un groupe de Prfrences <<<<<
  
  Procedure WritePrefs(P_GroupName.s)
    
    PreferenceGroup(P_GroupName)
    
    WritePreferenceLong("Equal", Instance\Equal)
    WritePreferenceLong("Plus", Instance\Plus)
    WritePreferenceLong("Minus", Instance\Minus)
    WritePreferenceLong("Product", Instance\Product)
    WritePreferenceLong("Divide", Instance\Divide)
    WritePreferenceLong("ProductByScalar", Instance\ProductByScalar)
    WritePreferenceLong("DivideByScalar", Instance\DivideByScalar)
    WritePreferenceLong("Copy", Instance\Copy)
    WritePreferenceLong("Compare", Instance\Compare)
    WritePreferenceLong("Swapping", Instance\Swapping)
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration Equal <<<<<
  
  Procedure.s DeclareEqual()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      FullNameA.s = "*" + Field::GetModuleName() + "A." + Field::GetModuleName()
      FullNameB.s = "*" + Field::GetModuleName() + "B." + Field::GetModuleName()
      
      Output.s = Comments::Tabulation(1) + "Declare Equal(" + FullNameA + ", " + FullNameB + ")" + Field::#LineFeed
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration Plus <<<<<
  
  Procedure.s DeclarePlus()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE

      FullNameR.s = "*" + Field::GetModuleName() + "R." + Field::GetModuleName()
      FullNameA.s = "*" + Field::GetModuleName() + "A." + Field::GetModuleName()
      FullNameB.s = "*" + Field::GetModuleName() + "B." + Field::GetModuleName()
      
      Output.s = Comments::Tabulation(1) + "Declare Plus(" + FullNameR + ", " + FullNameA + ", " + FullNameB + ")" + Field::#LineFeed
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration Minus <<<<<
  
  Procedure.s DeclareMinus()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      FullNameR.s = "*" + Field::GetModuleName() + "R." + Field::GetModuleName()
      FullNameA.s = "*" + Field::GetModuleName() + "A." + Field::GetModuleName()
      FullNameB.s = "*" + Field::GetModuleName() + "B." + Field::GetModuleName()
      
      Output.s = Comments::Tabulation(1) + "Declare Minus(" + FullNameR + ", " + FullNameA + ", " + FullNameB + ")" + Field::#LineFeed
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration Product <<<<<
  
  Procedure.s DeclareProduct()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      FullNameR.s = "*" + Field::GetModuleName() + "R." + Field::GetModuleName()
      FullNameA.s = "*" + Field::GetModuleName() + "A." + Field::GetModuleName()
      FullNameB.s = "*" + Field::GetModuleName() + "B." + Field::GetModuleName()
      
      Output.s = Comments::Tabulation(1) + "Declare Product(" + FullNameR + ", " + FullNameA + ", " + FullNameB + ")" + Field::#LineFeed
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration Divide <<<<<
  
  Procedure.s DeclareDivide()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      FullNameR.s = "*" + Field::GetModuleName() + "R." + Field::GetModuleName()
      FullNameA.s = "*" + Field::GetModuleName() + "A." + Field::GetModuleName()
      FullNameB.s = "*" + Field::GetModuleName() + "B." + Field::GetModuleName()
      
      Output.s = Comments::Tabulation(1) + "Declare Divide(" + FullNameR + ", " + FullNameA + ", " + FullNameB + ")" + Field::#LineFeed
      
    EndIf
    
    ProcedureReturn 
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration ProductByScalar <<<<<
  
  Procedure.s DeclareProductByScalar()
    
     If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      FullNameR.s = "*" + Field::GetModuleName() + "R." + Field::GetModuleName()
      FullNameA.s = "*" + Field::GetModuleName() + "A." + Field::GetModuleName()
      
      If Field::FirstInstance(0)
        Output.s = Comments::Tabulation(1) + "Declare ProductByScalar(" + FullNameR + ", " + FullNameA + ", P_Scalar" + Field::GetFieldExtensionLong(0) + ")" + Field::#LineFeed
      EndIf
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration DivideByScalar <<<<<
  
  Procedure.s DeclareDivideByScalar()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      FullNameR.s = "*" + Field::GetModuleName() + "R." + Field::GetModuleName()
      FullNameA.s = "*" + Field::GetModuleName() + "A." + Field::GetModuleName()
      
      If Field::FirstInstance(0)
        Output.s = Comments::Tabulation(1) + "Declare DivideByScalar(" + FullNameR + ", " + FullNameA + ", P_Scalar" + Field::GetFieldExtensionLong(0) + ")" + Field::#LineFeed
      EndIf
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration Copy <<<<<
  
  Procedure.s DeclareCopy()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      FullNameA.s = "*" + Field::GetModuleName() + "A." + Field::GetModuleName()
      FullNameB.s = "*" + Field::GetModuleName() + "B." + Field::GetModuleName()
      
      Output.s = Comments::Tabulation(1) + "Declare Copy(" + FullNameA + ", " + FullNameB + ")" + Field::#LineFeed
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration Compare <<<<<
  
  Procedure.s DeclareCompare()
    
   If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      FullNameA.s = "*" + Field::GetModuleName() + "A." + Field::GetModuleName()
      FullNameB.s = "*" + Field::GetModuleName() + "B." + Field::GetModuleName()
      
      Output.s = Comments::Tabulation(1) + "Declare.b Compare(" + FullNameA + ", " + FullNameB + ")" + Field::#LineFeed
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration Swapping <<<<<
  
  Procedure.s DeclareSwapping()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
     
      FullNameA.s = "*" + Field::GetModuleName() + "A." + Field::GetModuleName()
      FullNameB.s = "*" + Field::GetModuleName() + "B." + Field::GetModuleName()
      
      Output.s = Comments::Tabulation(1) + "Declare Swapping(" + FullNameA + ", " + FullNameB + ")" + Field::#LineFeed
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration Identity <<<<<
  
  Procedure.s DeclareIdentity()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      FullNameA.s = "*" + Field::GetModuleName() + "A." + Field::GetModuleName()
      
      Output.s = Comments::Tabulation(1) + "Declare Identity(" + FullNameA + ")" + Field::#LineFeed
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration Transpose <<<<<
  
  Procedure.s DeclareTranspose()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      FullNameA.s = "*" + Field::GetModuleName() + "A." + Field::GetModuleName()
      FullNameB.s = "*" + Field::GetModuleName() + "B." + Field::GetModuleName()
      
      Output.s = Comments::Tabulation(1) + "Declare Transpose(" + FullNameA + ", " + FullNameB + ")" + Field::#LineFeed
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration SelfTranspose <<<<<
  
  Procedure.s DeclareSelfTranspose()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      FullNameA.s = "*" + Field::GetModuleName() + "A." + Field::GetModuleName()
      Output.s = Comments::Tabulation(1) + "Declare SelfTranspose(" + FullNameA + ")" + Field::#LineFeed
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration Determinant <<<<<
  
  Procedure.s DeclareDeterminant()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      If Field::FirstInstance(0)
        
        Select Field::GetFieldType(0)
            
          Case Field::#FIELD_TYPE_LONG
            ReturnType.s = ".l"
            
          Case Field::#FIELD_TYPE_QUAD
            ReturnType.s = ".q"
            
          Case Field::#FIELD_TYPE_FLOAT
            ReturnType.s = ".f"
            
          Case Field::#FIELD_TYPE_DOUBLE
            ReturnType.s = ".d"
            
        EndSelect
        
        FullNameA.s = "*" + Field::GetModuleName() + "A." + Field::GetModuleName()
        Output.s = Comments::Tabulation(1) + "Declare" + ReturnType + " Determinant(" + FullNameA + ")" + Field::#LineFeed
        
      EndIf
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration Inverse <<<<<
  
  Procedure.s DeclareInverse()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      FullNameA.s = "*" + Field::GetModuleName() + "A." + Field::GetModuleName()
      Output.s = Comments::Tabulation(1) + "Declare.b Inverse(*Inverse." + Field::GetModuleName() + ", " + FullNameA + ")" + Field::#LineFeed
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration Randomize <<<<<
  
  Procedure.s DeclareRandomize()
    
   If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      If Field::FirstInstance(0)
        
        Select Field::GetFieldType(0)
            
          Case Field::#FIELD_TYPE_LONG
            ReturnType.s = ".l"
            
          Case Field::#FIELD_TYPE_QUAD
            ReturnType.s = ".q"
            
          Case Field::#FIELD_TYPE_FLOAT
            ReturnType.s = ".f"
            
          Case Field::#FIELD_TYPE_DOUBLE
            ReturnType.s = ".d"
            
        EndSelect
        
        FullNameA.s = "*" + Field::GetModuleName() + "A." + Field::GetModuleName()
        Output.s = Comments::Tabulation(1) + "Declare Randomize(" + FullNameA + ", Min" + ReturnType + ", Max" + ReturnType + ", Resolution = 10000)" + Field::#LineFeed
        
      EndIf
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration FormatLine <<<<<
  
  Procedure.s DeclareFormatLine()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      If Field::FirstInstance(0)
        
        Select Field::GetFieldType(0)
            
          Case Field::#FIELD_TYPE_LONG
            ConvertDeciPar.s = ""
            
          Case Field::#FIELD_TYPE_QUAD
            ConvertDeciPar.s = ""
            
          Case Field::#FIELD_TYPE_FLOAT
            ConvertDeciPar.s = ", Decimal = 3"
            
          Case Field::#FIELD_TYPE_DOUBLE
            ConvertDeciPar.s = ", Decimal = 6"
            
        EndSelect
        
        FullNameA.s = "*" + Field::GetModuleName() + "A." + Field::GetModuleName()
        
        For i = 1 To Field::GetMatrixSizeI()
          Output.s + Comments::Tabulation(1) + "Declare.s FormatLine" + Str(i) + "("  + FullNameA + ConvertDeciPar + ")" + Field::#LineFeed
        Next
        
      EndIf
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure 
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration UnformatLine <<<<<
  
  Procedure.s DeclareUnformatLine()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      FullNameA.s = "*" + Field::GetModuleName() + "A." + Field::GetModuleName()
      
      For i = 1 To Field::GetMatrixSizeI()
        Output.s + Comments::Tabulation(1) + "Declare UnformatLine" + Str(i) + "("  + FullNameA + ", P_MatrixLine.s)" + Field::#LineFeed
      Next
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure 
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition Equal <<<<<
  
  Procedure.s DefineEqual()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      VarNameA.s = "*" + Field::GetModuleName() + "A"
      VarNameB.s = "*" + Field::GetModuleName() + "B"
      
      FullNameA.s = VarNameA + "." + Field::GetModuleName()
      FullNameB.s = VarNameB + "." + Field::GetModuleName()
      
      If Field::FirstInstance(0)
        
        Output.s = Comments::Tabulation(1) + "Procedure Equal(" + FullNameA + ", " + FullNameB + ")" + Field::#TwinLineFeed
        
        Repeat
          If Field::GetFieldStyle(0) = Field::#FIELD_STYLE_BASIC
            Output + Comments::Tabulation(2) + VarNameA + "\" + Field::GetFieldName(0) + " = " + VarNameB + "\" + Field::GetFieldName(0) + Field::#LineFeed
          EndIf
        Until Field::NextInstance(0) = #Null
        
        Output + Comments::Tabulation(1) + Field::#LineFeed 
        Output + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
        
      EndIf
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition Plus <<<<<
  
  Procedure.s DefinePlus()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      VarNameR.s = "*" + Field::GetModuleName() + "R"
      VarNameA.s = "*" + Field::GetModuleName() + "A"
      VarNameB.s = "*" + Field::GetModuleName() + "B"
      
      FullNameR.s = VarNameR + "." + Field::GetModuleName()
      FullNameA.s = VarNameA + "." + Field::GetModuleName()
      FullNameB.s = VarNameB + "." + Field::GetModuleName()
      
      If Field::FirstInstance(0)
        
        Output.s = Comments::Tabulation(1) + "Procedure Plus(" + FullNameR + ", " + FullNameA + ", " + FullNameB + ")" + Field::#TwinLineFeed
        
        Repeat
          If Field::GetFieldStyle(0) = Field::#FIELD_STYLE_BASIC
            OutPut + Comments::Tabulation(2) + VarNameR + "\" + Field::GetFieldName(0) + " = " + VarNameA + "\" + Field::GetFieldName(0) + " + " + VarNameB + "\" + Field::GetFieldName(0) + Field::#LineFeed
          EndIf
        Until Field::NextInstance(0) = #Null
        
        Output + Comments::Tabulation(1) + Field::#LineFeed 
        Output + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
        
      EndIf
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition Minus <<<<<
    
  Procedure.s DefineMinus()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      VarNameR.s = "*" + Field::GetModuleName() + "R"
      VarNameA.s = "*" + Field::GetModuleName() + "A"
      VarNameB.s = "*" + Field::GetModuleName() + "B"
      
      FullNameR.s = VarNameR + "." + Field::GetModuleName()
      FullNameA.s = VarNameA + "." + Field::GetModuleName()
      FullNameB.s = VarNameB + "." + Field::GetModuleName()
      
      If Field::FirstInstance(0)
        
        Output.s = Comments::Tabulation(1) + "Procedure Minus(" + FullNameR + ", " + FullNameA + ", " + FullNameB + ")" + Field::#TwinLineFeed
        
        Repeat
          If Field::GetFieldStyle(0) = Field::#FIELD_STYLE_BASIC
            OutPut + Comments::Tabulation(2) + VarNameR + "\" + Field::GetFieldName(0) + " = " + VarNameA + "\" + Field::GetFieldName(0) + " - " + VarNameB + "\" + Field::GetFieldName(0) + Field::#LineFeed
          EndIf
        Until Field::NextInstance(0) = #Null
        
        Output + Comments::Tabulation(1) + Field::#LineFeed 
        Output + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
        
      EndIf
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition Product <<<<<
    
  Procedure.s DefineProduct()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      VarNameR.s = "*" + Field::GetModuleName() + "R"
      VarNameA.s = "*" + Field::GetModuleName() + "A"
      VarNameB.s = "*" + Field::GetModuleName() + "B"
      
      FullNameR.s = VarNameR + "." + Field::GetModuleName()
      FullNameA.s = VarNameA + "." + Field::GetModuleName()
      FullNameB.s = VarNameB + "." + Field::GetModuleName()
      
      Output.s = Comments::Tabulation(1) + "Procedure Product(" + FullNameR + ", " + FullNameA + ", " + FullNameB + ")" + Field::#TwinLineFeed
      
      If Field::IsSquareMatrix() = #False
        
        If Field::FirstInstance(0)
          
          Repeat
            If Field::GetFieldStyle(0) = Field::#FIELD_STYLE_BASIC
              OutPut + Comments::Tabulation(2) + VarNameR + "\" + Field::GetFieldName(0) + " = " + VarNameA + "\" + Field::GetFieldName(0) + " * " + VarNameB + "\" + Field::GetFieldName(0) + Field::#LineFeed
            EndIf
          Until Field::NextInstance(0) = #Null
          
        EndIf
        
      Else
        
        For i = 1 To Field::GetMatrixSizeI()
          
          For j = 1 To Field::GetMatrixSizeI()
            
            Result.s = VarNameR + "\e" + Str(i) + Str(j) + " = "
            
            For k = 1 To Field::GetMatrixSizeI()
              
              Sum.s = Sum + VarNameA + "\e" + Str(i) + Str(k) + " * " + VarNameB + "\e" + Str(k) + Str(j)
              
              If k < Field::GetMatrixSizeI()
                Sum + " + "
              EndIf
              
            Next
            
            OutPut + Comments::Tabulation(2) + Result + Sum + Field::#LineFeed
            
            Result = ""
            Sum = ""
            
          Next
          
        Next
        
      EndIf

      Output + Comments::Tabulation(1) + Field::#LineFeed 
      Output + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
      
    EndIf
    
  ProcedureReturn Output
EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition Divide <<<<<
    
  Procedure.s DefineDivide()
    
        If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      VarNameR.s = "*" + Field::GetModuleName() + "R"
      VarNameA.s = "*" + Field::GetModuleName() + "A"
      VarNameB.s = "*" + Field::GetModuleName() + "B"
      
      FullNameR.s = VarNameR + "." + Field::GetModuleName()
      FullNameA.s = VarNameA + "." + Field::GetModuleName()
      FullNameB.s = VarNameB + "." + Field::GetModuleName()
      
      If Field::FirstInstance(0)
        
        Output.s = Comments::Tabulation(1) + "Procedure Divide(" + FullNameR + ", " + FullNameA + ", " + FullNameB + ")" + Field::#TwinLineFeed
        
        Repeat
          If Field::GetFieldStyle(0) = Field::#FIELD_STYLE_BASIC
            OutPut + Comments::Tabulation(2) + VarNameR + "\" + Field::GetFieldName(0) + " = " + VarNameA + "\" + Field::GetFieldName(0) + " / " + VarNameB + "\" + Field::GetFieldName(0) + Field::#LineFeed
          EndIf
        Until Field::NextInstance(0) = #Null
        
        Output + Comments::Tabulation(1) + Field::#LineFeed 
        Output + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
        
      EndIf
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition ProductByScalar <<<<<
    
  Procedure.s DefineProductByScalar()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      VarNameR.s = "*" + Field::GetModuleName() + "R"
      VarNameA.s = "*" + Field::GetModuleName() + "A"
      
      FullNameR.s = VarNameR + "." + Field::GetModuleName()
      FullNameA.s = VarNameA + "." + Field::GetModuleName()
      
      If Field::FirstInstance(0)
        
        Output.s = Comments::Tabulation(1) + "Procedure ProductByScalar(" + FullNameR + ", " + FullNameA + ", P_Scalar" + Field::GetFieldExtensionLong(0) + ")" + Field::#TwinLineFeed
        
        Repeat
          If Field::GetFieldStyle(0) = Field::#FIELD_STYLE_BASIC
            OutPut + Comments::Tabulation(2) + VarNameR + "\" + Field::GetFieldName(0) + " = " + VarNameA + "\" + Field::GetFieldName(0) + " * P_Scalar" + Field::#LineFeed
          EndIf
        Until Field::NextInstance(0) = #Null
        
        Output + Comments::Tabulation(1) + Field::#LineFeed 
        Output + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
        
      EndIf
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition DivideByScalar <<<<<
    
  Procedure.s DefineDivideByScalar()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      VarNameR.s = "*" + Field::GetModuleName() + "R"
      VarNameA.s = "*" + Field::GetModuleName() + "A"
      
      FullNameR.s = VarNameR + "." + Field::GetModuleName()
      FullNameA.s = VarNameA + "." + Field::GetModuleName()
      
      If Field::FirstInstance(0)
        
        Output.s = Comments::Tabulation(1) + "Procedure DivideByScalar(" + FullNameR + ", " + FullNameA + ", P_Scalar" + Field::GetFieldExtensionLong(0) + ")" + Field::#TwinLineFeed
        
        Repeat
          If Field::GetFieldStyle(0) = Field::#FIELD_STYLE_BASIC
            OutPut + Comments::Tabulation(2) + VarNameR + "\" + Field::GetFieldName(0) + " = " + VarNameA + "\" + Field::GetFieldName(0) + " / P_Scalar" + Field::#LineFeed
          EndIf
        Until Field::NextInstance(0) = #Null
        
        Output + Comments::Tabulation(1) + Field::#LineFeed 
        Output + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
        
      EndIf
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition Copy <<<<<
    
  Procedure.s DefineCopy()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      VarNameA.s = "*" + Field::GetModuleName() + "A"
      VarNameB.s = "*" + Field::GetModuleName() + "B"
      
      FullNameA.s = VarNameA + "." + Field::GetModuleName()
      FullNameB.s = VarNameB + "." + Field::GetModuleName()
      
      If Field::FirstInstance(0)
        
        Output.s = Comments::Tabulation(1) + "Procedure Copy(" + FullNameA + ", " + FullNameB + ")" + Field::#TwinLineFeed
        
        Repeat
          
          If Field::GetFieldStyle(0) = Field::#FIELD_STYLE_BASIC
            
            If Field::GetFieldType(0) = Field::#FIELD_TYPE_MODULE
              OutPut + Comments::Tabulation(2) + Field::GetSubFieldExternModuleName(0) + "::Copy(" + VarNameA + "\" + Field::GetFieldName(0) + ", " + VarNameB + "\" + Field::GetFieldName(0) + ")"  + Field::#LineFeed
            Else  
              OutPut + Comments::Tabulation(2) + VarNameB + "\" + Field::GetFieldName(0) + " = " + VarNameA + "\" + Field::GetFieldName(0) + Field::#LineFeed
            EndIf
            
          EndIf
          
        Until Field::NextInstance(0) = #Null
        
        Output + Comments::Tabulation(1) + Field::#LineFeed 
        Output + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
        
      EndIf
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition Compare <<<<<
    
  Procedure.s DefineCompare()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      VarNameA.s = "*" + Field::GetModuleName() + "A"
      VarNameB.s = "*" + Field::GetModuleName() + "B"
      
      FullNameA.s = VarNameA + "." + Field::GetModuleName()
      FullNameB.s = VarNameB + "." + Field::GetModuleName()
      
      If Field::FirstInstance(0)
        
        Output.s = Comments::Tabulation(1) + "Procedure.b Compare(" + FullNameA + ", " + FullNameB + ")" + Field::#TwinLineFeed
        
        Repeat
          
          If Field::GetFieldStyle(0) = Field::#FIELD_STYLE_BASIC
            
            If Field::GetFieldType(0) = Field::#FIELD_TYPE_MODULE
              Output + Comments::Tabulation(2) + "If " + Field::GetSubFieldExternModuleName(0) + "::Compare(" + VarNameA + "\" + Field::GetFieldName(0) + ", " + VarNameB + "\" + Field::GetFieldName(0) + ") = #False"  + Field::#LineFeed
              Output + Comments::Tabulation(3) + "ProcedureReturn #False" + Field::#LineFeed
              Output + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed
            Else  
              Output + Comments::Tabulation(2) + "If " + VarNameA + "\" + Field::GetFieldName(0) + " <> " + VarNameB + "\" + Field::GetFieldName(0) + Field::#LineFeed
              Output + Comments::Tabulation(3) + "ProcedureReturn #False" + Field::#LineFeed
              Output + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed
            EndIf
            
          EndIf
          
        Until Field::NextInstance(0) = #Null
        
        Output + Comments::Tabulation(2) + "; ProcedureReturn CompareMemory(" + VarNameA + ", " + VarNameB + ", MemorySize(" + Field::GetModuleName() + "))"+ Field::#LineFeed
        Output + Comments::Tabulation(2) + "ProcedureReturn #True" + Field::#LineFeed
        Output + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
        
      EndIf
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition Swapping <<<<<
    
  Procedure.s DefineSwapping()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      VarNameA.s = "*" + Field::GetModuleName() + "A"
      VarNameB.s = "*" + Field::GetModuleName() + "B"
      
      FullNameA.s = VarNameA + "." + Field::GetModuleName()
      FullNameB.s = VarNameB + "." + Field::GetModuleName()
      
      If Field::FirstInstance(0)
        
        Output.s = Comments::Tabulation(1) + "Procedure Swapping(" + FullNameA + ", " + FullNameB + ")" + Field::#TwinLineFeed
        
        Repeat
          
          If Field::GetFieldStyle(0) = Field::#FIELD_STYLE_BASIC
            
            If Field::GetFieldType(0) = Field::#FIELD_TYPE_MODULE
              Output + Comments::Tabulation(2) + Field::GetSubFieldExternModuleName(0) + "::Swapping(" + VarNameA + "\" + Field::GetFieldName(0) + ", " + VarNameB + "\" + Field::GetFieldName(0) + ")"  + Field::#LineFeed
            Else  
              Output + Comments::Tabulation(2) + "Swap " + VarNameA + "\" + Field::GetFieldName(0) + ", " + VarNameB + "\" + Field::GetFieldName(0) + Field::#LineFeed
            EndIf
            
          EndIf
          
        Until Field::NextInstance(0) = #Null
        
        Output + Comments::Tabulation(1) + Field::#LineFeed 
        Output + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
        
      EndIf
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition Identity <<<<<
    
  Procedure.s DefineIdentity()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      VarNameA.s = "*" + Field::GetModuleName() + "A"
      FullNameA.s = VarNameA + "." + Field::GetModuleName()
      
      If Field::FirstInstance(0)
        
        Select Field::GetFieldType(0)
            
          Case Field::#FIELD_TYPE_LONG, Field::#FIELD_TYPE_QUAD
            Instruct00.s = "0"
            Instruct01.s = "1"
            
          Case Field::#FIELD_TYPE_FLOAT, Field::#FIELD_TYPE_DOUBLE
            Instruct00.s = "0.0"
            Instruct01.s = "1.0" 

        EndSelect
        
      EndIf
      
      Output.s = Comments::Tabulation(1) + "Procedure Identity(" + FullNameA + ")" + Field::#TwinLineFeed
      
      For j = 1 To Field::GetMatrixSizeI()
        For i = 1 To Field::GetMatrixSizeI()
          
          If i <> j
            Output + Comments::Tabulation(2) + VarNameA + "\e" + Str(i) + Str(j) + " = " + Instruct00 + Field::#LineFeed
          Else
            Output + Comments::Tabulation(2) + VarNameA + "\e" + Str(i) + Str(j) + " = " + Instruct01 + Field::#LineFeed
          EndIf
          
        Next
      Next
      
      Output + Comments::Tabulation(1) + Field::#LineFeed 
      Output + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition Transpose <<<<<
    
  Procedure.s DefineTranspose()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      VarNameA.s = "*" + Field::GetModuleName() + "A"
      VarNameR.s = "*" + Field::GetModuleName() + "B"
      
      FullNameA.s = VarNameA + "." + Field::GetModuleName()
      FullNameR.s = VarNameR + "." + Field::GetModuleName()
      
      If Field::FirstInstance(0)
        
        Output.s = Comments::Tabulation(1) + "Procedure Transpose(" + FullNameR + ", " + FullNameA + ")" + Field::#TwinLineFeed
        
        For j = 1 To Field::GetMatrixSizeI()
          For i = 1 To Field::GetMatrixSizeI()
            Output + Comments::Tabulation(2) + VarNameR + "\e" + Str(i) + Str(j) + " = " + VarNameA + "\e" + Str(j) + Str(i) + Field::#LineFeed
          Next
        Next
        
        Output + Comments::Tabulation(1) + Field::#LineFeed 
        Output + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
        
      EndIf
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition SelfTranspose <<<<<
    
  Procedure.s DefineSelfTranspose()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      VarNameA.s = "*" + Field::GetModuleName() + "A"
      FullNameA.s = VarNameA + "." + Field::GetModuleName()
  
      If Field::FirstInstance(0)
        
        Output.s = Comments::Tabulation(1) + "Procedure SelfTranspose(" + FullNameA + ")" + Field::#TwinLineFeed
        
        For I = 1 To Field::GetMatrixSizeI() - 1
          For J = I To Field::GetMatrixSizeI()
            If J <> I
              Output + Comments::Tabulation(2) + "Swap " + VarNameA + "\e" + Str(I) + Str(J) + ", " + VarNameA + "\e" + Str(J) + Str(I) + Field::#LineFeed
            EndIf
          Next
        Next
        
        Output + Comments::Tabulation(1) + Field::#LineFeed 
        Output + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
        
      EndIf
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition Determinant <<<<<
    
  Procedure.s DefineDeterminant()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      If Field::FirstInstance(0)
        
        Select Field::GetFieldType(0)
            
          Case Field::#FIELD_TYPE_LONG
            ReturnType.s = ".l"
            
          Case Field::#FIELD_TYPE_QUAD
            ReturnType.s = ".q"
            
          Case Field::#FIELD_TYPE_FLOAT
            ReturnType.s = ".f"
            
          Case Field::#FIELD_TYPE_DOUBLE
            ReturnType.s = ".d"
            
        EndSelect
        
        VarNameA.s = "*" + Field::GetModuleName() + "A"
        FullNameA.s = VarNameA + "." + Field::GetModuleName()
        Output.s = Comments::Tabulation(1) + "Procedure" + ReturnType + " Determinant(" + FullNameA + ")" + Field::#TwinLineFeed
        
        Select Field::GetMatrixSizeI()
            
          Case 2 
            Output.s + Comments::Tabulation(2) + "ProcedureReturn " + VarNameA + "\e11 * " + VarNameA + "\e22 - " + VarNameA + "\e12 * " + VarNameA + "\e21" + Field::#LineFeed
            
          Case 3
            Output.s + Comments::Tabulation(2) + "ProcedureReturn (" + VarNameA + "\e11 * (" + VarNameA + "\e22 * " + VarNameA + "\e33 - " + VarNameA + "\e23 * " + VarNameA + "\e32) - " + VarNameA + "\e12 * (" + VarNameA + "\e21 * " + VarNameA + "\e33 - " + VarNameA + "\e23 * " + VarNameA + "\e31) + " + VarNameA + "\e13 * (" + VarNameA + "\e21 * " + VarNameA + "\e32 - " + VarNameA + "\e22 * " + VarNameA + "\e31))" + Field::#LineFeed
            
          Case 4
            Output.s + Comments::Tabulation(2) + "ProcedureReturn (" + VarNameA + "\e11 * " + VarNameA + "\e22 * " + VarNameA + "\e33 * " + VarNameA + "\e44 - " + VarNameA + "\e11 * " + VarNameA + "\e22 * " + VarNameA + "\e34 * " + VarNameA + "\e43 - " + VarNameA + "\e11 * " + VarNameA + "\e32 * " + VarNameA + "\e23 * " + VarNameA + "\e44 + " + VarNameA + "\e11 * " + VarNameA + "\e32 * " + VarNameA + "\e24 * " + VarNameA + "\e43 + " + VarNameA + "\e11 * " + VarNameA + "\e42 * " + VarNameA + "\e23 * " + VarNameA + "\e34 - " + VarNameA + "\e11 * " + VarNameA + "\e42 * " + VarNameA + "\e24 * " + VarNameA + "\e33 - " + VarNameA + "\e21 * " + VarNameA + "\e12 * " + VarNameA + "\e33 * " + VarNameA + "\e44 + " + VarNameA + "\e21 * " + VarNameA + "\e12 * " + VarNameA + "\e34 * " + VarNameA + "\e43 + " + VarNameA + "\e21 * " + VarNameA + "\e32 * " + VarNameA + "\e13 * " + VarNameA + "\e44 - " + VarNameA + "\e21 * " + VarNameA + "\e32 * " + VarNameA + "\e14 * " + VarNameA + "\e43 - " + VarNameA + "\e21 * " + VarNameA + "\e42 * " + VarNameA + "\e13 * " + VarNameA + "\e34 + " + VarNameA + "\e21 * " + VarNameA + "\e42 * " + VarNameA + "\e14 * " + VarNameA + "\e33 + " + VarNameA + "\e31 * " + VarNameA + "\e12 * " + VarNameA + "\e23 * " + VarNameA + "\e44 - " + VarNameA + "\e31 * " + VarNameA + "\e12 * " + VarNameA + "\e24 * " + VarNameA + "\e43 - " + VarNameA + "\e31 * " + VarNameA + "\e22 * " + VarNameA + "\e13 * " + VarNameA + "\e44 + " + VarNameA + "\e31 * " + VarNameA + "\e22 * " + VarNameA + "\e14 * " + VarNameA + "\e43 + " + VarNameA + "\e31 * " + VarNameA + "\e42 * " + VarNameA + "\e13 * " + VarNameA + "\e24 - " + VarNameA + "\e31 * " + VarNameA + "\e42 * " + VarNameA + "\e14 * " + VarNameA + "\e23 - " + VarNameA + "\e41 * " + VarNameA + "\e12 * " + VarNameA + "\e23 * " + VarNameA + "\e34 + " + VarNameA + "\e41 * " + VarNameA + "\e12 * " + VarNameA + "\e24 * " + VarNameA + "\e33 + " + VarNameA + "\e41 * " + VarNameA + "\e22 * " + VarNameA + "\e13 * " + VarNameA + "\e34 - " + VarNameA + "\e41 * " + VarNameA + "\e22 * " + VarNameA + "\e14 * " + VarNameA + "\e33 - " + VarNameA + "\e41 * " + VarNameA + "\e32 * " + VarNameA + "\e13 * " + VarNameA + "\e24 + " + VarNameA + "\e41 * " + VarNameA + "\e32 * " + VarNameA + "\e14 * " + VarNameA + "\e23)" + Field::#LineFeed
            
        EndSelect
        
        Output + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
        
      EndIf
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition Inverse <<<<<
    
  Procedure.s DefineInverse()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      If Field::FirstInstance(0)
        
        Select Field::GetFieldType(0)
            
          Case Field::#FIELD_TYPE_LONG
            Instruct00.s = "0"
            ReturnType.s = ".l"
            
          Case Field::#FIELD_TYPE_QUAD
            Instruct00.s = "0"
            ReturnType.s = ".q"
            
          Case Field::#FIELD_TYPE_FLOAT
            Instruct00.s = "0.0"
            ReturnType.s = ".f"
            
          Case Field::#FIELD_TYPE_DOUBLE
            Instruct00.s = "0.0"
            ReturnType.s = ".d"
            
        EndSelect
        
        VarNameA.s = "*" + Field::GetModuleName() + "A"
        FullNameA.s = VarNameA + "." + Field::GetModuleName()
        
        Output.s = Comments::Tabulation(1) + "Procedure.b Inverse(*Inverse." + Field::GetModuleName() + ", " + FullNameA + ")" + Field::#TwinLineFeed
        Output + Comments::Tabulation(2) + "Copy(" + VarNameA + ", CopyA." + Field::GetModuleName() + ")" + Field::#LineFeed
        Output + Comments::Tabulation(2) + "Cofactor_Determinant" + ReturnType + " = Determinant(" + VarNameA + ")" + Field::#TwinLineFeed
        Output + Comments::Tabulation(2) + "If Cofactor_Determinant <> "+ Instruct00 + Field::#LineFeed
        
        Select Field::GetMatrixSizeI()
            
          Case 2
            
            Output + Comments::Tabulation(3) + "*Inverse\e11 = Copy\e22 / Cofactor_Determinant" + Field::#LineFeed
            Output + Comments::Tabulation(3) + "*Inverse\e12 = -Copy\e12 / Cofactor_Determinant" + Field::#LineFeed
            Output + Comments::Tabulation(3) + "*Inverse\e21 = -Copy\e21 / Cofactor_Determinant" + Field::#LineFeed
            Output + Comments::Tabulation(3) + "*Inverse\e22 = Copy\e11 / Cofactor_Determinant" + Field::#LineFeed
            
          Case 3
            
            Output + Comments::Tabulation(3) + "*Inverse\e11 = (CopyA\e22 * CopyA\e33 - CopyA\e23 * CopyA\e32) / Cofactor_Determinant" + Field::#LineFeed
            Output + Comments::Tabulation(3) + "*Inverse\e12 = (CopyA\e13 * CopyA\e32 - CopyA\e12 * CopyA\e33) / Cofactor_Determinant" + Field::#LineFeed
            Output + Comments::Tabulation(3) + "*Inverse\e13 = (CopyA\e12 * CopyA\e23 - CopyA\e13 * CopyA\e22) / Cofactor_Determinant" + Field::#LineFeed
            
            Output + Comments::Tabulation(3) + "*Inverse\e21 = (CopyA\e23 * CopyA\e31 - CopyA\e21 * CopyA\e33) / Cofactor_Determinant" + Field::#LineFeed
            Output + Comments::Tabulation(3) + "*Inverse\e22 = (CopyA\e11 * CopyA\e33 - CopyA\e13 * CopyA\e31) / Cofactor_Determinant" + Field::#LineFeed
            Output + Comments::Tabulation(3) + "*Inverse\e23 = (CopyA\e13 * CopyA\e21 - CopyA\e11 * CopyA\e23) / Cofactor_Determinant" + Field::#LineFeed
            
            Output + Comments::Tabulation(3) + "*Inverse\e31 = (CopyA\e21 * CopyA\e32 - CopyA\e22 * CopyA\e31) / Cofactor_Determinant" + Field::#LineFeed
            Output + Comments::Tabulation(3) + "*Inverse\e32 = (CopyA\e12 * CopyA\e31 - CopyA\e11 * CopyA\e32) / Cofactor_Determinant" + Field::#LineFeed
            Output + Comments::Tabulation(3) + "*Inverse\e33 = (CopyA\e11 * CopyA\e22 - CopyA\e12 * CopyA\e21) / Cofactor_Determinant" + Field::#LineFeed
            
          Case 4
            
            Output + Comments::Tabulation(3) + "*Inverse\e11 = (CopyA\e22 * CopyA\e33 * CopyA\e44 - CopyA\e22 * CopyA\e34 * CopyA\e43 - CopyA\e32 * CopyA\e23 * CopyA\e44 + CopyA\e32 * CopyA\e24 * CopyA\e43 + CopyA\e42 * CopyA\e23 * CopyA\e34 - CopyA\e42 * CopyA\e24 * CopyA\e33) / Cofactor_Determinant" + Field::#LineFeed
            Output + Comments::Tabulation(3) + "*Inverse\e12 = (CopyA\e12 * CopyA\e34 * CopyA\e43 + CopyA\e32 * CopyA\e13 * CopyA\e44 - CopyA\e32 * CopyA\e14 * CopyA\e43 - CopyA\e42 * CopyA\e13 * CopyA\e34 + CopyA\e42 * CopyA\e14 * CopyA\e33 - CopyA\e12 * CopyA\e33 * CopyA\e44) / Cofactor_Determinant" + Field::#LineFeed
            Output + Comments::Tabulation(3) + "*Inverse\e13 = (CopyA\e12 * CopyA\e23 * CopyA\e44 - CopyA\e12 * CopyA\e24 * CopyA\e43 - CopyA\e22 * CopyA\e13 * CopyA\e44 + CopyA\e22 * CopyA\e14 * CopyA\e43 + CopyA\e42 * CopyA\e13 * CopyA\e24 - CopyA\e42 * CopyA\e14 * CopyA\e23) / Cofactor_Determinant" + Field::#LineFeed
            Output + Comments::Tabulation(3) + "*Inverse\e14 = (CopyA\e12 * CopyA\e24 * CopyA\e33 + CopyA\e22 * CopyA\e13 * CopyA\e34 - CopyA\e22 * CopyA\e14 * CopyA\e33 - CopyA\e32 * CopyA\e13 * CopyA\e24 + CopyA\e32 * CopyA\e14 * CopyA\e23 - CopyA\e12 * CopyA\e23 * CopyA\e34) / Cofactor_Determinant" + Field::#LineFeed
            
            Output + Comments::Tabulation(3) + "*Inverse\e21 = (CopyA\e21 * CopyA\e34 * CopyA\e43 + CopyA\e31 * CopyA\e23 * CopyA\e44 - CopyA\e31 * CopyA\e24 * CopyA\e43 - CopyA\e41 * CopyA\e23 * CopyA\e34 + CopyA\e41 * CopyA\e24 * CopyA\e33 - CopyA\e21 * CopyA\e33 * CopyA\e44) / Cofactor_Determinant" + Field::#LineFeed
            Output + Comments::Tabulation(3) + "*Inverse\e22 = (CopyA\e11 * CopyA\e33 * CopyA\e44 - CopyA\e11 * CopyA\e34 * CopyA\e43 - CopyA\e31 * CopyA\e13 * CopyA\e44 + CopyA\e31 * CopyA\e14 * CopyA\e43 + CopyA\e41 * CopyA\e13 * CopyA\e34 - CopyA\e41 * CopyA\e14 * CopyA\e33) / Cofactor_Determinant" + Field::#LineFeed
            Output + Comments::Tabulation(3) + "*Inverse\e23 = (CopyA\e11 * CopyA\e24 * CopyA\e43 + CopyA\e21 * CopyA\e13 * CopyA\e44 - CopyA\e21 * CopyA\e14 * CopyA\e43 - CopyA\e41 * CopyA\e13 * CopyA\e24 + CopyA\e41 * CopyA\e14 * CopyA\e23 - CopyA\e11 * CopyA\e23 * CopyA\e44) / Cofactor_Determinant" + Field::#LineFeed
            Output + Comments::Tabulation(3) + "*Inverse\e24 = (CopyA\e11 * CopyA\e23 * CopyA\e34 - CopyA\e11 * CopyA\e24 * CopyA\e33 - CopyA\e21 * CopyA\e13 * CopyA\e34 + CopyA\e21 * CopyA\e14 * CopyA\e33 + CopyA\e31 * CopyA\e13 * CopyA\e24 - CopyA\e31 * CopyA\e14 * CopyA\e23) / Cofactor_Determinant" + Field::#LineFeed
            
            Output + Comments::Tabulation(3) + "*Inverse\e31 = (CopyA\e21 * CopyA\e32 * CopyA\e44 - CopyA\e21 * CopyA\e34 * CopyA\e42 - CopyA\e31 * CopyA\e22 * CopyA\e44 + CopyA\e31 * CopyA\e24 * CopyA\e42 + CopyA\e41 * CopyA\e22 * CopyA\e34 - CopyA\e41 * CopyA\e24 * CopyA\e32) / Cofactor_Determinant" + Field::#LineFeed
            Output + Comments::Tabulation(3) + "*Inverse\e32 = (CopyA\e11 * CopyA\e34 * CopyA\e42 + CopyA\e31 * CopyA\e12 * CopyA\e44 - CopyA\e31 * CopyA\e14 * CopyA\e42 - CopyA\e41 * CopyA\e12 * CopyA\e34 + CopyA\e41 * CopyA\e14 * CopyA\e32 - CopyA\e11 * CopyA\e32 * CopyA\e44) / Cofactor_Determinant" + Field::#LineFeed
            Output + Comments::Tabulation(3) + "*Inverse\e33 = (CopyA\e11 * CopyA\e22 * CopyA\e44 - CopyA\e11 * CopyA\e24 * CopyA\e42 - CopyA\e21 * CopyA\e12 * CopyA\e44 + CopyA\e21 * CopyA\e14 * CopyA\e42 + CopyA\e41 * CopyA\e12 * CopyA\e24 - CopyA\e41 * CopyA\e14 * CopyA\e22) / Cofactor_Determinant" + Field::#LineFeed
            Output + Comments::Tabulation(3) + "*Inverse\e34 = (CopyA\e11 * CopyA\e24 * CopyA\e32 + CopyA\e21 * CopyA\e12 * CopyA\e34 - CopyA\e21 * CopyA\e14 * CopyA\e32 - CopyA\e31 * CopyA\e12 * CopyA\e24 + CopyA\e31 * CopyA\e14 * CopyA\e22 - CopyA\e11 * CopyA\e22 * CopyA\e34) / Cofactor_Determinant" + Field::#LineFeed
            
            Output + Comments::Tabulation(3) + "*Inverse\e41 = (CopyA\e41 * CopyA\e23 * CopyA\e32 - CopyA\e21 * CopyA\e32 * CopyA\e43 + CopyA\e21 * CopyA\e33 * CopyA\e42 + CopyA\e31 * CopyA\e22 * CopyA\e43 - CopyA\e31 * CopyA\e23 * CopyA\e42 - CopyA\e41 * CopyA\e22 * CopyA\e33) / Cofactor_Determinant" + Field::#LineFeed
            Output + Comments::Tabulation(3) + "*Inverse\e42 = (CopyA\e11 * CopyA\e32 * CopyA\e43 - CopyA\e11 * CopyA\e33 * CopyA\e42 - CopyA\e31 * CopyA\e12 * CopyA\e43 + CopyA\e31 * CopyA\e13 * CopyA\e42 + CopyA\e41 * CopyA\e12 * CopyA\e33 - CopyA\e41 * CopyA\e13 * CopyA\e32) / Cofactor_Determinant" + Field::#LineFeed
            Output + Comments::Tabulation(3) + "*Inverse\e43 = (CopyA\e11 * CopyA\e23 * CopyA\e42 + CopyA\e21 * CopyA\e12 * CopyA\e43 - CopyA\e21 * CopyA\e13 * CopyA\e42 - CopyA\e41 * CopyA\e12 * CopyA\e23 + CopyA\e41 * CopyA\e13 * CopyA\e22 - CopyA\e11 * CopyA\e22 * CopyA\e43) / Cofactor_Determinant" + Field::#LineFeed
            Output + Comments::Tabulation(3) + "*Inverse\e44 = (CopyA\e11 * CopyA\e22 * CopyA\e33 - CopyA\e11 * CopyA\e23 * CopyA\e32 - CopyA\e21 * CopyA\e12 * CopyA\e33 + CopyA\e21 * CopyA\e13 * CopyA\e32 + CopyA\e31 * CopyA\e12 * CopyA\e23 - CopyA\e31 * CopyA\e13 * CopyA\e22) / Cofactor_Determinant" + Field::#LineFeed
            
        EndSelect
        
        Output + Comments::Tabulation(3) + "Result.b = #True" + Field::#LineFeed 
        Output + Comments::Tabulation(2) + "Else" + Field::#LineFeed
        Output + Comments::Tabulation(3) + "Identity(*Inverse)" + Field::#LineFeed
        Output + Comments::Tabulation(3) + "Result = #False" + Field::#LineFeed
        Output + Comments::Tabulation(2) + "EndIf" + Field::#TwinLineFeed 
        Output + Comments::Tabulation(2) + "ProcedureReturn Result" + Field::#LineFeed
        Output + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
        
      EndIf
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition Randomize <<<<<
    
  Procedure.s DefineRandomize()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      If Field::FirstInstance(0)
        
        Select Field::GetFieldType(0)
            
          Case Field::#FIELD_TYPE_LONG
            ReturnType.s = ".l"
            
          Case Field::#FIELD_TYPE_QUAD
            ReturnType.s = ".q"
            
          Case Field::#FIELD_TYPE_FLOAT
            ReturnType.s = ".f"
            
          Case Field::#FIELD_TYPE_DOUBLE
            ReturnType.s = ".d"
            
        EndSelect
        
        VarNameA.s = "*" + Field::GetModuleName() + "A"
        FullNameA.s = VarNameA + "." + Field::GetModuleName()
        
        Output.s = Comments::Tabulation(1) + "Procedure Randomize(" + FullNameA + ", Min" + ReturnType + ", Max" + ReturnType + ", Resolution = 10000)" + Field::#TwinLineFeed
        
        For j = 1 To Field::GetMatrixSizeJ()
          For i = 1 To Field::GetMatrixSizeI()
            Output + Comments::Tabulation(2) + VarNameA + "\e" + Str(i) + Str(j) + " = (Min + (Max - Min) * Random(Resolution) / Resolution)" + Field::#LineFeed
          Next
        Next
        
        Output + Comments::Tabulation(1) + Field::#LineFeed 
        Output + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
        
      EndIf
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition FormatLine <<<<<
   
  Procedure.s DefineFormatLine()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      If Field::FirstInstance(0)
        
        Select Field::GetFieldType(0)
            
          Case Field::#FIELD_TYPE_LONG
            ConvertStr.s = "Str("
            ConvertDeci.s = ")"
            ConvertDeciPar.s = ""
            UnconvertStr.s = "Val("
            
          Case Field::#FIELD_TYPE_QUAD
            ConvertStr.s = "Str("
            ConvertDeci.s = ")"
            ConvertDeciPar.s = ""
            UnconvertStr.s = "Val("
            
          Case Field::#FIELD_TYPE_FLOAT
            ConvertStr.s = "StrF("
            ConvertDeci.s = ", Decimal)"
            ConvertDeciPar.s = ", Decimal = 3"
            UnconvertStr.s = "ValF("
            
          Case Field::#FIELD_TYPE_DOUBLE
            ConvertStr.s = "StrD("
            ConvertDeci.s = ", Decimal)"
            ConvertDeciPar.s = ", Decimal = 6"
            UnconvertStr.s = "ValD("
            
        EndSelect
        
        VarNameA.s = "*" + Field::GetModuleName() + "A"
        FullNameA.s = VarNameA + "." + Field::GetModuleName()
        
        For i = 1 To Field::GetMatrixSizeI()
          
          Output.s + Comments::Tabulation(1) + "Procedure.s FormatLine" + Str(i) + "("  + FullNameA + ConvertDeciPar + ")" + Field::#TwinLineFeed
          Internal.s = Chr(34) + "[" + Chr(34) + " + "
          
          For j = 1 To Field::GetMatrixSizeJ()
            
            Internal + ConvertStr + VarNameA + "\e" + Str(i) + Str(j) + ConvertDeci
            
            If j < Field::GetMatrixSizeJ()
              Internal + " + " + Chr(34) + " : " + Chr(34) + " + "
            Else
              Internal + " + " + Chr(34) + "]" + Chr(34)
            EndIf
            
          Next
          
          Output.s + Comments::Tabulation(2) + "ProcedureReturn " + Internal + Field::#LineFeed
          Output.s + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
          
        Next
        
      EndIf
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure 
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition UnformatLine <<<<<
    
  Procedure.s DefineUnformatLine()
    
    If Field::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      
      If Field::FirstInstance(0)
        
        Select Field::GetFieldType(0)
            
          Case Field::#FIELD_TYPE_LONG
            UnconvertStr.s = "Val("
            
          Case Field::#FIELD_TYPE_QUAD
            UnconvertStr.s = "Val("
            
          Case Field::#FIELD_TYPE_FLOAT
            UnconvertStr.s = "ValF("
            
          Case Field::#FIELD_TYPE_DOUBLE
            UnconvertStr.s = "ValD("
            
        EndSelect
        
        VarNameA.s = "*" + Field::GetModuleName() + "A"
        FullNameA.s = VarNameA + "." + Field::GetModuleName()
        
        For i = 1 To Field::GetMatrixSizeI()
          
          Output.s + Comments::Tabulation(1) + "Procedure UnformatLine" + Str(i) + "("  + FullNameA + ", P_MatrixLine.s)" + Field::#TwinLineFeed
          
          For j = 1 To Field::GetMatrixSizeJ()
            
            Output + Comments::Tabulation(2) + VarNameA + "\e" + Str(i) + Str(j) + " = " + UnconvertStr + "StringField(StringField(StringField(P_MatrixLine, 2, "
            Output + Chr(34) + "[" + Chr(34) + "), 1, "  + Chr(34) + "]" + Chr(34) + "), " + Str(j) + ", " + Chr(34) + ":" + Chr(34) + "))"
            
            If j < Field::GetMatrixSizeJ()
              Output + Field::#LineFeed
            Else
              Output + Field::#TwinLineFeed
            EndIf
            
          Next
          
          Output.s + Comments::Tabulation(1) + "EndProcedure" + Field::#TwinLineFeed
          
        Next
        
      EndIf 
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure 
  
EndModule

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Code gnr en : 00.001 secondes (278000.00 lignes/seconde) <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.70 beta 1 (Linux - x64)
; Folding = DAAAAeo0---
; EnableXP
; CompileSourceDirectory