; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; CODE GNR AUTOMATIQUEMENT, NE PAS MODIFIER 
; MOINS D'AVOIR UNE RAISON TRS TRS VALABLE !!!
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Code gnr par : Dev-Module - V0.9.0
; Nom du projet : Dev-Module
; Nom du fichier : DevModule - MatrixGenerator.pb
; Version du fichier : 0.9.0
; Programmation : OK
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 04-04-2015
; Mise  jour : 24-05-2018
; Cod pour : PureBasic 5.62
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule MatrixGenerator
  
  Declare Reset()
  Declare Runner(MainWinID)
  Declare GadgetLinking(GadgetID, Flag)
  
EndDeclareModule

Module MatrixGenerator
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Dclaration de la Structure <<<<<
  
  Structure Instance
    
    ElementType.s
    StartCounter.b
    StringModuleNameGadget.l
    EditorFieldGadget.l
    Size.l[2]
    FrameGadget.q[3]
    TrackBarGadget.q[2]
    TextBarGadget.q[2]
    OptionTypeGadget.q[4]
    
  EndStructure
  
  Global Instance.Instance
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Reset <<<<<
  
  Procedure Reset()
    
    Instance\ElementType = ""
    Instance\StartCounter = 0
    Instance\StringModuleNameGadget = 0
    Instance\EditorFieldGadget = 0
    
    For SizeID = 0 To 1
      Instance\Size[SizeID] = 0
    Next
    
    For FrameGadgetID = 0 To 2
      Instance\FrameGadget[FrameGadgetID] = 0
    Next
    
    For TrackBarGadgetID = 0 To 1
      Instance\TrackBarGadget[TrackBarGadgetID] = 0
    Next
    
    For TextBarGadgetID = 0 To 1
      Instance\TextBarGadget[TextBarGadgetID] = 0
    Next
    
    For OptionTypeGadgetID = 0 To 3
      Instance\OptionTypeGadget[OptionTypeGadgetID] = 0
    Next
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< GUI_To_MatrixSize_TrackBar <<<<<
  
  Procedure GUI_To_MatrixSize_TrackBar(Mode)
    
    Select Mode
        
      Case 0, 1
        Instance\Size[Mode] = GetGadgetState(Instance\TrackBarGadget[Mode])
        SetGadgetText(Instance\TextBarGadget[Mode], Str(Instance\Size[Mode]))
        
      Case 2
        For Index = 0 To 1
          SetGadgetAttribute(Instance\TrackBarGadget[Index], #PB_TrackBar_Minimum, 2)
          SetGadgetAttribute(Instance\TrackBarGadget[Index], #PB_TrackBar_Maximum, 4)
          SetGadgetState(Instance\TrackBarGadget[Index], Instance\Size[Index])
          SetGadgetText(Instance\TextBarGadget[Index], Str(Instance\Size[Index]))
        Next
        
    EndSelect
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< TrackBarGadgetGroupEx <<<<<
  
  Procedure TrackBarGadgetGroupEx(PosX, PosY, FrameWidth, *FrameID, *TrackBarID, *TextID)
    
    PokeQ(*FrameID, FrameGadget(#PB_Any, PosX, PosY, FrameWidth, 55, ""))
    TrackBarHandle = TrackBarGadget(#PB_Any, PosX + 5, PosY + 20, FrameWidth - 40, 30, 0, 0, #PB_TrackBar_Ticks)
    PokeQ(*TrackBarID, TrackBarHandle)
    PokeQ(*TextID, TextGadget(#PB_Any, GadgetLocate::RightOf(TrackBarHandle) + 5, PosY + 20, 30, 30, "", #PB_Text_Center))
    
  EndProcedure   
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur GadgetLinking <<<<<
  
  Procedure GadgetLinking(GadgetID, Flag)
    
    Select Flag
        
      Case 0
        Instance\StringModuleNameGadget = GadgetID
        
      Case 1
        Instance\EditorFieldGadget = GadgetID
        
    EndSelect
    
  EndProcedure
    
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< MatrixGeneratorRequester <<<<<
  
  Procedure.b MatrixGeneratorRequester(MainWinID)
    
    MatrixWin_Handle.q = OpenWindow(#PB_Any, 0, 0, 220, 295, Language::Message("Matrix Generator"), #PB_Window_ScreenCentered)
    
    If MatrixWin_Handle
      
      Instance\Size[0] = 2
      Instance\Size[1] = 2
      
      TrackBarGadgetGroupEx(5, 5, 210, @Instance\FrameGadget[0], @Instance\TrackBarGadget[0], @Instance\TextBarGadget[0])
      TrackBarGadgetGroupEx(5, GadgetLocate::DownOf(Instance\FrameGadget[0], 5), 210, @Instance\FrameGadget[1], @Instance\TrackBarGadget[1], @Instance\TextBarGadget[1])
      
      SetGadgetText(Instance\FrameGadget[0], Language::Message("Matrix Size in") + " I") ; Ligne
      SetGadgetText(Instance\FrameGadget[1], Language::Message("Matrix Size in") + " J") ; Colonne
      
      Instance\FrameGadget[2] = FrameGadget(#PB_Any, 5, GadgetLocate::DownOf(Instance\FrameGadget[1], 5), 210, 125, "Type")
      Instance\OptionTypeGadget[0] = OptionGadget(#PB_Any, 10, GadgetLocate::DownOf(Instance\FrameGadget[1], 25), 200, 25, "Long")
      Instance\OptionTypeGadget[1] = OptionGadget(#PB_Any, 10, GadgetLocate::DownOf(Instance\OptionTypeGadget[0], 0), 200, 25, "Quad")
      Instance\OptionTypeGadget[2] = OptionGadget(#PB_Any, 10, GadgetLocate::DownOf(Instance\OptionTypeGadget[1], 0), 200, 25, "Float")
      Instance\OptionTypeGadget[3] = OptionGadget(#PB_Any, 10, GadgetLocate::DownOf(Instance\OptionTypeGadget[2], 0), 200, 25, "Double")
      
      Btn_Y = GadgetLocate::DownOf(Instance\FrameGadget[2]) + 5
      BUTTON_OK = ButtonGadget(#PB_Any, 10, Btn_Y, 95, 30, Language::Message("OK"))
      BUTTON_CANCEL = ButtonGadget(#PB_Any, 115, Btn_Y, 95, 30, Language::Message("Cancel"))
      
      GUI_To_MatrixSize_TrackBar(2)
      SetGadgetState(Instance\OptionTypeGadget[2], 1)
      Instance\ElementType = ".f"
      
      Repeat
        
        EventID = WaitWindowEvent()
        
        If EventID = #PB_Event_Gadget
          
          Select EventGadget() ; La gestion des venements
              
            Case BUTTON_OK
              
              SetGadgetText(Instance\StringModuleNameGadget, "Matrix" + Str(Instance\Size[0]) + Str(Instance\Size[1]))
              ClearGadgetItems(Instance\EditorFieldGadget)
              
              For IndexJ = 1 To Instance\Size[1]
                For IndexI = 1 To Instance\Size[0]
                  AddGadgetItem(Instance\EditorFieldGadget, -1, "e" + Str(IndexI) + Str(IndexJ) + Instance\ElementType)
                Next 
              Next 
              
              Success.b = #True
              EventID = #PB_Event_CloseWindow
              
            Case BUTTON_CANCEL
              Success = #False 
              EventID = #PB_Event_CloseWindow
              
            Case Instance\OptionTypeGadget[0]
              Instance\ElementType = ".l"
              
            Case Instance\OptionTypeGadget[1]
              Instance\ElementType = ".q"
              
            Case Instance\OptionTypeGadget[2]
              Instance\ElementType = ".f"
              
            Case Instance\OptionTypeGadget[3]
              Instance\ElementType = ".d"
              
            Case Instance\TrackBarGadget[0]
              GUI_To_MatrixSize_TrackBar(0)
              
            Case Instance\TrackBarGadget[1]
              GUI_To_MatrixSize_TrackBar(1)      
              
          EndSelect
          
        EndIf
        
      Until EventID = #PB_Event_CloseWindow
      
      CloseWindow(MatrixWin_Handle)
      
    EndIf 
    
    ProcedureReturn Success
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Runner <<<<<
  
  Procedure Runner(MainWinID)
    
    If Instance\StartCounter < 3
      Instance\StartCounter + 1
    Else
      Instance\StartCounter = 0
      HideWindow(MainWinID, 1)
      Output.b = MatrixGeneratorRequester(MainWinID)
      HideWindow(MainWinID, 0)
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
EndModule

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Code gnr en : 00.001 secondes (79000.00 lignes/seconde) <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.70 beta 1 (Linux - x64)
; Folding = --
; EnableXP
; CompileSourceDirectory